/* <unixlib.h>
 *
 *	Various Unix compatibility routines available in VAXCRTL.
 */
#ifndef _UNIXLIB_H
#define _UNIXLIB_H
# ifdef __cplusplus
extern "C" {
# endif
	/*( limited substitute for VAX C V3.x's <unixlib.h> )*/

/* declare the global environ[] array */
#ifdef __GNUC__
extern char **environ	__asm("_$$PsectAttributes_NOSHR$$environ");
#else	/* assume VAXC */
extern char noshare **environ;
#endif

/* check for alternate representation of doubles */
#ifdef __GFLOAT__
# define ecvt	vaxc$ecvt
# define fcvt	vaxc$fcvt
# define gcvt	vaxc$gcvt
#endif

#ifdef __STDC__		/* these aren't standard, but use their prototypes */

/* miscellaneous emulation routines */
char	*getenv(const char *);
char	*getcwd(char *,unsigned,...); /* optional arg is VMS vs shell name format */

char	*ecvt(double,int,int *,int *);
char	*fcvt(double,int,int *,int *);
char	*gcvt(double,int,char *);

int	 getpid(void), getppid(void);

unsigned getgid(void), getuid(void), getegid(void), geteuid(void);
int	 setgid(unsigned), setuid(unsigned);	/* no-ops */

/* note: none of the following are declared in any VAX C header file */
int	 brk(void *);			/* also in our <malloc.h> -*/
void	*sbrk(unsigned long);		/*+  which is deprecated.  */
int	 chdir(const char *);
int	 chmod(const char *,unsigned);
int	 chown(const char *,unsigned, unsigned);
char	*ctermid(char *);
char	*cuserid(char *);
int	 mkdir(const char *,int,...);
int	 nice(int);			/* also in our <processes.h> */
int	 umask(unsigned int);
/* end of "missing" prototypes */

#else	/*!__STDC__ => -traditional */

char	*getenv(), *getcwd(), *ecvt(), *fcvt(), *gcvt();
int	 getpid(), getppid(), setgid(), setuid();
unsigned getgid(), getuid(), getegid(), geteuid();
char	*sbrk();
int	 brk(), chdir(), chmod(), chown();
char	*ctermid(), *cuserid();
int	 mkdir(), nice(), umask();

#endif	/*?__STDC__*/

# ifdef __cplusplus
}
# endif
#endif	/*_UNIXLIB_H*/
