/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <acedef.h>
 *
 *	Access Control list Entry structure definitions
 */
#ifndef _ACEDEF_H
#define _ACEDEF_H

#define ACE$C_KEYID		1	/* key identifier entry */
#define ACE$C_RMSJNL_BI		2	/* RMS BI journal */
#define ACE$C_RMSJNL_AI		3	/* RMS AI journal */
#define ACE$C_RMSJNL_AT		4	/* RMS AT journal */
#define ACE$C_AUDIT		5	/* security audit journal entry */
#define ACE$C_ALARM		6	/* security alarm entry */
#define ACE$C_INFO		7	/* general purpose information */
#define ACE$C_RMSJNL_RU_DEFAULT 8	/* RU journal default volume */
#define ACE$C_DIRDEF		9	/* directory default protection */
#define ACE$C_RMSJNL_RU		10	/* RU journal (many per file) */
#define ACE$C_SUBSYSTEM_IDS	11	/* protected subsystem ids */
#define ACE$C_OIL		12	/* Object Information Label */
#define ACE$C_NEW_OWNER		13	/* Protection for owner ACE */
#define ACE$C_MAX_CODE		14	/* Maximum ACE type code plus 1 */
 /* ACE types registered to outside products. Not recognized by VMS software. */
 /* Registered for Pathworks... */
#define ACE$C_PATHWORKS		128	/* Pathworks common ACE */
#define ACE$C_LANMAN_SECURITY	129	/* LANMAN security */
#define ACE$C_LANMAN_ATTRIB	130	/* LANMAN extended attributes */
#define ACE$C_NETWARE		131	/* Netware trustee */
#define ACE$C_MAC_COMMENT	132	/* MacIntosh comment */
#define ACE$C_PATHWORKS_1	133	/* reserved to Pathworks */
#define ACE$C_PATHWORKS_2	134	/* reserved to Pathworks */
#define ACE$C_PATHWORKS_3	135	/* reserved to Pathworks */
#define ACE$C_RESERVED	      255	/* reserved ACE type */
#define ACE$C_APPLICATION	7	/* alternate application ACE code */
#define ACE$C_CUST	1		/* customer defined */
#define ACE$C_CSS	2		/* CSS defined */
#define ACE$C_VMS	3		/* VMS defined */
#define ACE$V_SUCCESS	0
#define ACE$V_FAILURE	1
#define ACE$V_DEFAULT	8
#define ACE$V_PROTECTED 9
#define ACE$V_HIDDEN	10
#define ACE$V_NOPROPAGATE 11
#define ACE$M_SUCCESS	(1<<ACE$V_SUCCESS)	/* 0x01 */
#define ACE$M_FAILURE	(1<<ACE$V_FAILURE)	/* 0x02 */
#define ACE$M_DEFAULT	(1<<ACE$V_DEFAULT)	/* 0x0100 */
#define ACE$M_PROTECTED (1<<ACE$V_PROTECTED)	/* 0x0200 */
#define ACE$M_HIDDEN	(1<<ACE$V_HIDDEN)	/* 0x0400 */
#define ACE$M_NOPROPAGATE (1<<ACE$V_NOPROPAGATE) /* 0x0800 */
#define ACE$V_READ	0
#define ACE$V_WRITE	1
#define ACE$V_EXECUTE	2
#define ACE$V_DELETE	3
#define ACE$V_CONTROL	4
#define ACE$M_READ	(1<<ACE$V_READ)		/* 0x01 */
#define ACE$M_WRITE	(1<<ACE$V_WRITE)	/* 0x02 */
#define ACE$M_EXECUTE	(1<<ACE$V_EXECUTE)	/* 0x04 */
#define ACE$M_DELETE	(1<<ACE$V_DELETE)	/* 0x08 */
#define ACE$M_CONTROL	(1<<ACE$V_CONTROL)	/* 0x10 */
#define ACE$K_LENGTH 8			/* length of the overhead area */
#define ACE$C_LENGTH 8
#define ACE$C_RMS_ATTRIBUTES 0		/* variant of ACE for file attributes */
#define ACE$K_RMS_ATTRIBUTES 0		/* variant of ACE for file attributes */
#define ACE$K_RMSATR_MINOR_V50 2	/* minor ID for VMS 5.0 */
#define ACE$K_RMSATR_MINOR_VDW 2	/* minor ID for DECwindows V1.0 */
#define ACE$C_RMSATR_MINOR_ID 2		/* current minor ID (obsolete symbol) */
#define ACE$K_RMSATR_MINOR_ID 2
#define ACE$C_RMSATR_MAJOR_ID 1		/* current major ID */
#define ACE$K_RMSATR_MAJOR_ID 1
#define ACE$V_STATISTICS 0
#define ACE$V_XLATE_DEC  1
#define ACE$M_STATISTICS (1<<ACE$V_STATISTICS)	/* 0x01 */
#define ACE$M_XLATE_DEC  (1<<ACE$V_XLATE_DEC)	/* 0x02 */
#define ACE$S_RMSATR 20			/* size of RMS file attributes ACE (fixed fields) */
#define ACE$S_RMSATR_V50 20		/* " */
#define ACE$S_RMSATR_VDW 20		/* " */
/* Beyond the fixed fields, variable length information will by stored */
#define ACE$_RMSATR_ORGANIZATION 1	/* organizational extension object ID */
#define ACE$_RMSATR_SEMANTICS 2		/* file semantics object ID */
#define ACE$K_RMSATR_ORG_MAX_LEN 64
#define ACE$K_RMSATR_SEM_MAX_LEN 64
#define ACE$S_RMSJNL_RU_DEFAULT 17	/* length of RMSJNL RU default ACE */
#define ACE$V_JOURNAL_DISABLED	0
#define ACE$V_BACKUP_DONE	1
#define ACE$M_JOURNAL_DISABLED	(1<<ACE$V_JOURNAL_DISABLED)	/* 0x01 */
#define ACE$M_BACKUP_DONE	(1<<ACE$V_BACKUP_DONE)		/* 0x02 */
#define ACE$S_RMSJNL_RU 38		/* length of RMSJNL RU ACE */
#define ACE$S_RMSJNL	50		/* length of RMSJNL AI/BI/AT ACE */
#define ACE$S_OIL_S64I64 32		/* length of type 0 OIL ACE */
#define ACE$S_OIL_S128	32		/* length of type 1 OIL ACE */
#define ACE$S_OIL	32		/* maximum OIL ACE Size */
struct acedef {
    unsigned char ace$b_size;			/* size of the entry */
    unsigned char ace$b_type;			/* type of entry */
    union {
	unsigned short ace$w_flags;		/* type dependent & independent flags */
	struct {				/* flags for INFO type ACE */
	    unsigned short ace$v_info_type : 4;	/* INFO ACE subtype */
	    unsigned short		   : 4;
	} ace$r_flags_info;
	struct {				/* flags for KEYID type */
	    unsigned short ace$v_reserved  : 4;	/* count of reserved longwords */
	    unsigned short		   : 4;
	} ace$r_flags_keyid;
	struct {
	    unsigned short ace$v_success   : 1;	/* audit or alarm upon success */
	    unsigned short ace$v_failure   : 1;	/* audit ot alarm upon failure */
	    unsigned short		   : 6;
	} ace$r_flags_bits0;
	struct {				/* type independent flags */
	    unsigned short		     : 8;
	    unsigned short ace$v_default     : 1;	/* directory default entry */
	    unsigned short ace$v_protected   : 1;	/* protected ACE */
	    unsigned short ace$v_hidden	     : 1;	/* hidden ACE */
	    unsigned short ace$v_nopropagate : 1;	/* no propagation between versions */
	    unsigned short		     : 4;
	} ace$r_flags_bits;
    } ace$r_flags_overlay;
#define ace$w_flags ace$r_flags_overlay.ace$w_flags
#define ace$v_info_type ace$r_flags_overlay.ace$r_info_type.ace$v_info_type
#define ace$v_reserved ace$r_flags_overlay.ace$r_flags_keyid.ace$v_reserved
#define ace$v_success ace$r_flags_overlay.ace$r_flags_keyid.ace$v_success
#define ace$v_failure ace$r_flags_overlay.ace$r_flags_bits0.ace$v_failure
#define ace$v_default ace$r_flags_overlay.ace$r_flags_bits.ace$v_default
#define ace$v_protected ace$r_flags_overlay.ace$r_flags_bits.ace$v_protected
#define ace$v_hidden ace$r_flags_overlay.ace$r_flags_bits.ace$v_hidden
#define ace$v_nopropagate ace$r_flags_overlay.ace$r_flags_bits.ace$v_nopropagate 

    union {				/* start of ACE overlayed area */
	struct {			/* key-id and security audit types */
	    union {
		unsigned long ace$l_access;	/* access rights bitmask */
		struct {
		    unsigned ace$v_read    : 1; /* allowed to read */
		    unsigned ace$v_write   : 1; /* " to write */
		    unsigned ace$v_execute : 1; /* " to execute */
		    unsigned ace$v_delete  : 1; /* " to delete */
		    unsigned ace$v_control : 1; /* all privileges of the owner */
		    unsigned 		   : 3;
		} ace$r_access_bits;
	    } ace$r_access_overlay;
	    union {
		unsigned long ace$l_key;	/* start of the key fields */
		char ace$t_auditname[16];	/* start of the security journal name */
	    } ace$r_key_overlay;
	} ace$r_key_aud_type;
#define ace$l_access ace$r_ace_fields.ace$r_key_aud_type.ace$r_access_overlay.ace$l_access
#define ace$v_read ace$r_ace_fields.ace$r_key_aud_type.ace$r_access_overlay.ace$r_access_bits.ace$v_read
#define ace$v_write ace$r_ace_fields.ace$r_key_aud_type.ace$r_access_overlay.ace$r_access_bits.ace$v_write
#define ace$v_execute ace$r_ace_fields.ace$r_key_aud_type.ace$r_access_overlay.ace$r_access_bits.ace$v_execute
#define ace$v_delete ace$r_ace_fields.ace$r_key_aud_type.ace$r_access_overlay.ace$r_access_bits.ace$v_delete
#define ace$v_control ace$r_ace_fields.ace$r_key_aud_type.ace$r_access_overlay.ace$r_access_bits.ace$v_control
#define ace$l_key ace$r_ace_fields.ace$r_key_aud_type.ace$r_key_overlay.ace$l_key
#define ace$t_auditname ace$r_ace_fields.ace$r_key_aud_type.ace$r_key_overlay.ace$t_auditname

	struct {
	    union {
		unsigned long ace$l_info_flags; /* INFO type application flags */
		struct {
		    unsigned short ace$w_application_flags;	/* VMS application flags word */
		    unsigned short ace$w_application_facility;	/* VMS application facility code */
		} ace$r_info_flags_bits;
	    } ace$r_info_flags_overlay;
#define ace$l_info_flags ace$r_ace_fields.ace$r_info_type.ace$r_info_flags_overlay.ace$l_info_flags
#define ace$w_application_flags ace$r_ace_fields.ace$r_info_type.ace$r_info_flags_overlay.ace$r_info_flags_bits.ace$w_application_flags
#define ace$w_application_facility ace$r_ace_fields.ace$r_info_type.ace$r_info_flags_overlay.ace$r_info_flags_bits.ace$w_application_facility

	    union {
		char ace$t_info_start;		/* start of the information */
		struct {
		    unsigned short ace$w_rmsatr_variant;  /* which variant of the RMS attributes ACE */
		    unsigned char ace$b_rmsatr_fixlen;	  /* length of fixed format fields */
 /* (introduced at minor ID 3; older ACE's are assumed to be all fixed form) */
		    char ace$b_rmsatr_spare1;	/* currectly unused */
		    unsigned short ace$w_rmsatr_minor_id; /* RMS file attributes ACE minor ID */
		    unsigned short ace$w_rmsatr_major_id; /* RMS file attributes ACE major ID */
		    union {
			unsigned long ace$l_rms_attribute_flags; /* RMS file attributes flags definitions */
			struct {
			    unsigned ace$v_statistics : 1; /* statistics monitoring enabled on this file */
			    unsigned ace$v_xlate_dec  : 1; /* file semantics are DEC-local */
			    unsigned		      : 6;
			} ace$r_rmsatr_flags_bits;
		    } ace$r_rmsatr_flags_overlay;
		} ace$r_rmsatr_type;
	    } ace$r_info_data;
#define ace$t_info_start ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$t_info_start
#define ace$w_rmsatr_variant ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$w_rmsatr_variant
#define ace$b_rmsatr_fixlen ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$b_rmsatr_fixlen
#define ace$b_rmsatr_spare1 ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$b_rmsatr_spare1
#define ace$w_rmsatr_minor_id ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$w_rmsatr_minor_id
#define ace$w_rmsatr_major_id ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$w_rmsatr_major_id
#define ace$l_rms_attribute_flags ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$r_rmsatr_flags_overlay.ace$l_rms_attribute_flags
#define ace$v_statistics ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$r_rmsatr_flags_overlay.ace$r_rmsatr_flags_bits.ace$v_statistics
#define ace$v_xlate_dec ace$r_ace_fields.ace$r_info_type.ace$r_info_data.ace$r_rmsatr_type.ace$r_rmsatr_flags_overlay.ace$r_rmsatr_flags_bits.ace$v_xlate_dec

	} ace$r_info_type;

	struct {				/* used for all 5 RMSJNL_xxx ACEs */
	    char ace$t_volnam[12];		/* volume name of journal file */
	    unsigned char ace$b_volnam_len;	/* length of volume name of journal file */
	    unsigned char ace$b_rjrver;		/* RMS journal file structure level */
#define ace$t_volnam ace$r_ace_fields.ace$r_rmsjnl_type.ace$t_volnam
#define ace$b_volnam_len ace$r_ace_fields.ace$r_rmsjnl_type.ace$b_volnam_len
#define ace$b_rjrver ace$r_ace_fields.ace$r_rmsjnl_type.ace$b_rjrver

	    union {				/* file-id of journal file */
		unsigned short ace$w_fid[3];	/* file id */
		struct {
		    unsigned short ace$w_fid_num; /* file number */
		    unsigned short ace$w_fid_seq; /* sequence number */
		    union {
			unsigned short ace$w_fid_rvn; /* relative volume number */
			struct {
			    unsigned char ace$b_fid_rvn; /* alternate format RVN */
			    unsigned char ace$b_fid_nmx; /* alternate format file number extension */
			} ace$r_fid_rvn_fields;
		    } ace$r_fid_rvn_overlay;
		} ace$r_fid_fields;
	    } ace$r_fid_overlay;

#define ace$w_fid ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_fid_overlay.ace$w_fid
#define ace$w_fid_num ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_fid_overlay.ace$r_fid_fields.ace$w_fid_num
#define ace$w_fid_seq ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_fid_overlay.ace$r_fid_fields.ace$w_fid_seq
#define ace$w_fid_rvn ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_fid_overlay.ace$r_fid_fields.ace$r_fid_rvn_overlay.ace$w_fid_rvn
#define ace$b_fid_rvn ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_fid_overlay.ace$r_fid_fields.ace$r_fid_rvn_overlay.ace$r_fid_rvn_fields.ace$b_fid_rvn
#define ace$b_fid_nmx ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_fid_overlay.ace$r_fid_fields.ace$r_fid_rvn_overlay.ace$r_fid_rvn_fields.ace$b_fid_nmx

	    union {
		unsigned short ace$w_rmsjnl_flags;
		struct {
		    unsigned ace$v_journal_disabled : 1; /* journaling disabled (AI, BI, AT only; set by BACKUP) */
		    unsigned ace$v_backup_done	  : 1;	 /* BACKUP done on this file; RMS -*/
			/* needs to write a backup marker (AI, BI, AT only; set by BACKUP) */
		    unsigned 		  : 6;
		} ace$r_rmsjnl_flags_bits __attribute__ ((packed));
	    } ace$r_rmsjnl_flags_overlay __attribute__ ((packed));
#define ace$w_rmsjnl_flags ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_rmsjnl_flags_overlay.ace$w_rmsjnl_flags
#define ace$v_journal_disabled ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_rmsjnl_flags_overlay.ace$r_rmsjnl_flags_bits.ace$v_journal_disabled
#define ace$v_backup_done ace$r_ace_fields.ace$r_rmsjnl_type.ace$r_rmsjnl_flags_overlay.ace$r_rmsjnl_flags_bits.ace$v_backup_done

	    unsigned long ace$l_jnlidx;		/* journal stream index number */
	    unsigned long long ace$q_cdate;		/* creation date/time of journal */
	    unsigned long ace$l_backup_seqno;	/* BACKUP sequence number (to find where to start in journal). */
	    unsigned long long ace$q_modification_time; /* timestamp of last backup or last journal entry recovered. */
	} ace$r_rmsjnl_type __attribute__ ((packed));
#define ace$l_jnlidx ace$r_ace_fields.ace$r_rmsjnl_type.ace$l_jnlidx
#define ace$q_cdate ace$r_ace_fields.ace$r_rmsjnl_type.ace$q_cdate
#define ace$l_backup_seqno ace$r_ace_fields.ace$r_rmsjnl_type.ace$l_backup_seqno
#define ace$q_modification_time ace$r_ace_fields.ace$r_rmsjnl_type.ace$q_modification_time

	struct {
	    unsigned long ace$l_spare1;		/* for alignment */
	    unsigned long ace$l_sys_prot;	/* default system protection */
	    unsigned long ace$l_own_prot;	/* default owner protection */
	    unsigned long ace$l_grp_prot;	/* default group protection */
	    unsigned long ace$l_wor_prot;	/* default world protection */
	} ace$r_dirdef_type;
#define ace$l_sys_prot ace$r_ace_fields.ace$r_dirdef_type.ace$l_sys_prot
#define ace$l_own_prot ace$r_ace_fields.ace$r_dirdef_type.ace$l_own_prot
#define ace$l_grp_prot ace$r_ace_fields.ace$r_dirdef_type.ace$l_grp_prot
#define ace$l_wor_prot ace$r_ace_fields.ace$r_dirdef_type.ace$l_wor_prot

	struct {				/* protected subsystem ACE type */
	    unsigned long ace$l_spare2;		/* for alignment */
	    unsigned long long ace$q_image_ids;	/* start of the image ids (a quadword for each identifier) */
	} ace$r_image_id_type;
#define ace$q_image_ids ace$r_ace_fields.ace$r_image_id_type.ace$q_image_ids

	struct {				/* Object Information Label */
	    unsigned long ace$l_oil_flags;	/* for alignment */
	    unsigned long ace$l_brand_name;	/* OIL type-specific Info */
	    char ace$r_class_prot;		/* OIL class block */
	} ace$r_oil_type;
#define ace$l_oil_flags ace$r_ace_fields.ace$r_oil_type.ace$l_oil_flags
#define ace$l_brand_name ace$r_ace_fields.ace$r_oil_type.ace$l_brand_name
#define ace$r_class_prot ace$r_ace_fields.ace$r_oil_type.ace$r_class_prot
    } ace$r_ace_fields;

} __attribute__ ((packed));

#endif	/*_ACEDEF_H*/
