/* <dmtdef.h>
 *
 *	Flag bits for the $dismou (dismount) system service.
 */
#ifndef _DMTDEF_H
#define _DMTDEF_H

#define DMT$V_NOUNLOAD	0
#define DMT$V_UNIT	1
#define DMT$V_ABORT	2
#define DMT$V_CLUSTER	3
#define DMT$V_UNLOAD	4
#define DMT$V_OVR_CHECKS 5
#define DMT$V_CHECK_ONLY 6
#define DMT$V_REMOTE	 7
#define DMT$M_NOUNLOAD	(1<<DMT$V_NOUNLOAD)	/* 0x01 */
#define DMT$M_UNIT	(1<<DMT$V_UNIT)		/* 0x02 */
#define DMT$M_ABORT	(1<<DMT$V_ABORT)	/* 0x04 */
#define DMT$M_CLUSTER	(1<<DMT$V_CLUSTER)	/* 0x08 */
#define DMT$M_UNLOAD	(1<<DMT$V_UNLOAD)	/* 0x10 */
#define DMT$M_OVR_CHECKS (1<<DMT$V_OVR_CHECKS)	/* 0x20 */
#define DMT$M_CHECK_ONLY (1<<DMT$V_CHECK_ONLY)	/* 0x40 */
#define DMT$M_REMOTE	 (1<<DMT$V_REMOTE)	/* 0x80 */
union dmtdef {
    struct  {
	unsigned dmt$v_nounload : 1;	/* do not unload (spin down) the volume */
	unsigned dmt$v_unit	: 1;	/* dismount only the specified volume */
	unsigned dmt$v_abort	: 1;	/* forced dismount	 */
	unsigned dmt$v_cluster	: 1;	/* cluster-wide dismount */
	unsigned dmt$v_unload	: 1;	/* explicit unload (override ucb$x_unload) */
	unsigned dmt$v_ovr_checks : 1;	/* override open file checks */
	unsigned dmt$v_check_only : 1;	/* check only for open files - don't dismount */
	unsigned dmt$v_remote	: 1;	/* current dismounter is remote with respect to originator */
    } dmt$r_dmtdef_bits;
};

#endif	/*_DMTDEF_H*/
