/* <dtkdef.h>
 *
 *	Definitions for RTL DECtalk Management
 */
#ifndef _DTKDEF_H
#define _DTKDEF_H

/* phone keypad keys */
#define DTK$K_TRM_ZERO		48
#define DTK$K_TRM_ONE		49
#define DTK$K_TRM_TWO		50
#define DTK$K_TRM_THREE		51
#define DTK$K_TRM_FOUR		52
#define DTK$K_TRM_FIVE		53
#define DTK$K_TRM_SIX		54
#define DTK$K_TRM_SEVEN		55
#define DTK$K_TRM_EIGHT		56
#define DTK$K_TRM_NINE		57
#define DTK$K_TRM_A		65
#define DTK$K_TRM_B		66
#define DTK$K_TRM_C		67
#define DTK$K_TRM_D		68
#define DTK$K_TRM_NUMBER_SIGN	35
#define DTK$K_TRM_ASTERISK	42

/* conditions */
#define DTK$K_TRM_CANCELLED	508	/* I/O cancelled */
#define DTK$K_TRM_TIMEOUT	509	/* Timeout period expired */
#define DTK$K_TRM_BUFFER_FULL	510	/* Buffer is full */
#define DTK$K_TRM_UNKNOWN	511	/* Unknown terminator */

/* self-test constants */
#define DTK$K_TEST_POWER	1
#define DTK$K_TEST_HDATA	2
#define DTK$K_TEST_HCONTROL	3
#define DTK$K_TEST_DATA		4
#define DTK$K_TEST_SPEAK	5

/* phone dialing constants */
#define DTK$K_DIAL_TONE		0
#define DTK$K_DIAL_PULSE	1

/* DECtalk types */
#define DTK$K_DTC_UNKNOWN	0
#define DTK$K_DTC_01		1
#define DTK$K_DTC_03		2

/* keypad modes */
#define DTK$K_KEYPAD_OFF	0
#define DTK$K_KEYPAD_ON		1
#define DTK$K_KEYPAD_AUTO	2

/* voices */
#define DTK$K_VOICE_MALE	0
#define DTK$K_VOICE_FEMALE	1
#define DTK$K_VOICE_CHILD	2
#define DTK$K_VOICE_DEEP_MALE	3
#define DTK$K_VOICE_DEEP_FEMALE 4
#define DTK$K_VOICE_OLDER_MALE	5
#define DTK$K_VOICE_LIGHT_FEMALE 6

/* speaking modes */
#define DTK$K_SPEAK	0
#define DTK$K_STOP	1
#define DTK$K_HALT	2

/* return modes */
#define DTK$K_IMMED	0	/* return immedately after sending text */
#define DTK$K_WAIT	1	/* wait until text is completely spoken be returning */
#define DTK$K_STATUS	2	/* wait for text to be spoken and return phone status */

/* bit masks and values for mode attributes */
#define DTK$V_SQUARE	0
#define DTK$V_ASCII	1
#define DTK$V_MINUS	2
#define DTK$V_EUROPE	3
#define DTK$V_SPELL	4
#define DTK$M_SQUARE	(1<<DTK$V_SQUARE)	/* 0x01 */
#define DTK$M_ASCII	(1<<DTK$V_ASCII)	/* 0x02 */
#define DTK$M_MINUS	(1<<DTK$V_MINUS)	/* 0x04 */
#define DTK$M_EUROPE	(1<<DTK$V_EUROPE)	/* 0x08 */
#define DTK$M_SPELL	(1<<DTK$V_SPELL)	/* 0x10 */
#define DTK$M_NORMAL	0x00		/* no bits set */
#define DTK$K_SQUARE	0	/* mode square bitvector index */
#define DTK$K_ASCII	1	/* asky mode */
#define DTK$K_MINUS	2	/* say dash as minus bitvector index */
#define DTK$K_EUROPE	3	/* European type numbers */
#define DTK$K_SPELL	4	/* spell all words */
#define DTK$V_HOST	0
#define DTK$V_SPEAK_ALL 1
#define DTK$V_EDITED	2
#define DTK$V_HARD	3
#define DTK$V_SETUP	4
#define DTK$V_FILTER	5
#define DTK$M_HOST	(1<<DTK$V_HOST)		/* 0x01 */
#define DTK$M_SPEAK_ALL (1<<DTK$V_SPEAK_ALL)	/* 0x02 */
#define DTK$M_EDITED	(1<<DTK$V_EDITED)	/* 0x04 */
#define DTK$M_HARD	(1<<DTK$V_HARD)		/* 0x08 */
#define DTK$M_SETUP	(1<<DTK$V_SETUP)	/* 0x10 */
#define DTK$M_FILTER	(1<<DTK$V_FILTER)	/* 0x20 */
#define DTK$K_HOST	0	/* send all chars typed to host */
#define DTK$K_SPEAK_ALL 1	/* speak all chars typed */
#define DTK$K_EDITED	2	/* line edit all chars typed */
#define DTK$K_HARD	3	/* do local echo in hardcopy format */
#define DTK$K_SETUP	4	/* speak all chars displayed in setup mode */
#define DTK$K_FILTER	5	/* don't send DECtalk specific sequences */
#define DTK$V_TEXT	0
#define DTK$V_PHONEME	1
#define DTK$V_RAWHOST	2
#define DTK$V_INHOST	3
#define DTK$V_OUTHOST	4
#define DTK$V_ERROR	5
#define DTK$V_TRACE	6
#define DTK$V_DEBUG	7
#define DTK$M_TEXT	(1<<DTK$V_TEXT)		/* 0x01 */
#define DTK$M_PHONEME	(1<<DTK$V_PHONEME)	/* 0x02 */
#define DTK$M_RAWHOST	(1<<DTK$V_RAWHOST)	/* 0x04 */
#define DTK$M_INHOST	(1<<DTK$V_INHOST)	/* 0x08 */
#define DTK$M_OUTHOST	(1<<DTK$V_OUTHOST)	/* 0x10 */
#define DTK$M_ERROR	(1<<DTK$V_ERROR)	/* 0x20 */
#define DTK$M_TRACE	(1<<DTK$V_TRACE)	/* 0x40 */
#define DTK$M_DEBUG	(1<<DTK$V_DEBUG)	/* 0x80 */
#define DTK$K_TEXT	0	/* log ASCII text */
#define DTK$K_PHONEME	1	/* log phonemic text */
#define DTK$K_RAWHOST	2	/* log all chars without inspection */
#define DTK$K_INHOST	3	/* log text read from host */
#define DTK$K_OUTHOST	4	/* log text sent to host */
#define DTK$K_ERROR	5	/* log error messages */
#define DTK$K_TRACE	6	/* log sequences symbolically */
#define DTK$K_DEBUG	7	/* reserved */

union dtkdef {
    struct {
	unsigned dtk$v_square : 1;	/* set mode square on */
	unsigned dtk$v_ascii  : 1;	/* asky mode */
	unsigned dtk$v_minus  : 1;	/* say dash as minus */
	unsigned dtk$v_europe : 1;	/* Europe */
	unsigned dtk$v_spell  : 1;	/* spell all words */
	unsigned	      : 3;
    } dtk$r_dtkmode_bits;
    struct {
	unsigned dtk$v_host   : 1;	/* send all chars typed to host */
	unsigned dtk$v_speak_all : 1;	/* speak all chars typed */
	unsigned dtk$v_edited : 1;	/* line edit all chars typed */
	unsigned dtk$v_hard   : 1;	/* do local echo in hardcopy format */
	unsigned dtk$v_setup  : 1;	/* speak all chars displayed in setup mode */
	unsigned dtk$v_filter : 1;	/* don't send DECtalk specific sequences */
	unsigned	      : 2;
    } dtk$r_dtkterm_bits;
    struct {
	unsigned dtk$v_text   : 1;	/* log ASCII text */
	unsigned dtk$v_phoneme: 1;	/* log phonemic text */
	unsigned dtk$v_rawhost: 1;	/* log all chars without inspection */
	unsigned dtk$v_inhost : 1;	/* log text read from host */
	unsigned dtk$v_outhost: 1;	/* log text sent to host */
	unsigned dtk$v_error  : 1;	/* log error messages */
	unsigned dtk$v_trace  : 1;	/* log sequences symbolically */
	unsigned dtk$v_debug  : 1;	/* reserved */
    } dtk$r_dtklog_bits;
};

#endif	/*_DTKDEF_H*/
