/* <evidef.h>
 *
 *	Event Information codes
 */
#ifndef _EVIDEF_H
#define _EVIDEF_H

/*
	Generalized Event Notification definitions
   Item codes for the $GETEVI Get Event Information system
   service and offsets into P1 space buffers for $GETEVI.
 */
#define EVI$_FLAGS 0			/* event flags */
#define EVI$_NODE_CSID 1		/* declarer's node CSID */
#define EVI$_EPID 2			/* declarer's EPID */
#define EVI$_EVENT_FACILITY 3		/* event facility */
#define EVI$_EXASTLM_LOGGED 4		/* insufficient quota log count */
#define EVI$_DECLARED_LOGGED 5		/* fork log count */
#define EVI$_EVENT_TIME 6		/* event time */
#define EVI$_EVENT_NAME 7		/* event name */
#define EVI$_NODENAME 8			/* declarer's nodename */
#define EVI$_EVENT_DATA 9		/* optional data */
struct evidef {
/* Start of $GETEVI data.  For efficiency, this must agree with EDBDEF. */
    unsigned long evi$l_flags;		/* flags */
    unsigned long evi$l_csid;		/* CSID of declarer's node */
    unsigned long evi$l_epid;		/* declarer's extended PID */
    unsigned short evi$w_rsvd;
    unsigned short evi$w_facility;	/* event facility */
    union {				/* lost event counts */
	unsigned long evi$l_lost;
	struct {
	    unsigned short evi$w_ulost;
	    unsigned short evi$w_flost;
	} evi$r_lost_words;
    } evi$r_lost_ovrlay;
    int evi$q_event_time[2][2];		/* event time */
    char evi$t_event_name[32];		/* event name */
    char evi$t_event_data[128];		/* optional event related data */
/* End of GETEVI data */
    unsigned long evi$l_last_uniqid;	/* last unique id issued by $SETEVTAST */
};

#endif	/*_EVIDEF_H*/
