/* <facdef.h>
 *
 *	Facility codes
 */
#ifndef _FACDEF_H
#define _FACDEF_H
/*
	Event Facility Codes
   Note:  These codes are used by Generalized Event Notification,
	however, the value assigned to these symbols is the value
	assigned to the VMS facility by the facility registrar
	and may be used whereever needed.
 */
/* Special codes for generalized event notification */
#define FAC$V_FAC_NO	0
#define FAC$M_FAC_NO	0x07FF
#define FAC$S_FAC_NO	11
#define FAC$V_CUST_DEF	11
#define FAC$V_PRIVATE	12
#define FAC$V_WILDCARD	13
#define FAC$M_CUST_DEF	(1<<FAC$V_CUST_DEF)	/* 0x0800 */
#define FAC$M_PRIVATE	(1<<FAC$V_PRIVATE)	/* 0x1000 */
#define FAC$M_WILDCARD	(1<<FAC$V_WILDCARD)	/* 0x2000 */
#define FAC$C_PRIVATE	4096
#define FAC$C_WILDCARD	8192

/* VMS facility codes */
#define FAC$C_SYS	0
#define FAC$C_SYSTEM	0
#define FAC$C_RMS	1
#define FAC$C_DEBUG	2
#define FAC$C_CLI	3
#define FAC$C_DCL	3
#define FAC$C_JBC	4
#define FAC$C_OPCOM	5
#define FAC$C_RSX	6
#define FAC$C_ERF	8
#define FAC$C_TRACE	9
#define FAC$C_PRV	10
#define FAC$C_RUF	15
#define FAC$C_RMSREC	16
#define FAC$C_CDU	17
#define FAC$C_SMG	18
#define FAC$C_BLI	20
#define FAC$C_LIB	21
#define FAC$C_MTH	22
#define FAC$C_OTS	23
#define FAC$C_FOR	24
#define FAC$C_COB	25
#define FAC$C_BAS	26
#define FAC$C_B32	27
#define FAC$C_SORT	28
#define FAC$C_C74	29
#define FAC$C_PLI	30
#define FAC$C_SNO	31
#define FAC$C_XPO	32
#define FAC$C_PAS	33
#define FAC$C_COR	34
#define FAC$C_APL	35
#define FAC$C_STR	36
#define FAC$C_MAT	37
#define FAC$C_LBR	38
#define FAC$C_HIX	39
#define FAC$C_DBM	40
#define FAC$C_FDV	41
#define FAC$C_DBL	42
#define FAC$C_CDD	43
#define FAC$C_SCR	44
#define FAC$C_TSS	45
#define FAC$C_AUDSRV	48
#define FAC$C_ADA	49
#define FAC$C_PEA	50
#define FAC$C_C		53
#define FAC$C_ANLRMS	59
#define FAC$C_AUDIT	60
#define FAC$C_IMGACT	77
#define FAC$C_LINK	100
#define FAC$C_CREF	101
#define FAC$C_DSUP	102
#define FAC$C_COPY	103
#define FAC$C_BTRAN	104
#define FAC$C_SYSMSG	105
#define FAC$C_FORT	106
#define FAC$C_COB74	107
#define FAC$C_DIFF	108
#define FAC$C_PATCH	109
#define FAC$C_PAX	110
#define FAC$C_BLS32	111
#define FAC$C_BLS16	112
#define FAC$C_APPEND	113
#define FAC$C_MOUNT	114
#define FAC$C_DISM	115
#define FAC$C_UETP	116
#define FAC$C_INIT	117
#define FAC$C_HELP	118
#define FAC$C_SET	119
#define FAC$C_SHOW	120
#define FAC$C_DIRECT	121
#define FAC$C_AUTHOR	122
#define FAC$C_INSTALL	123
#define FAC$C_SYSGEN	124
#define FAC$C_MACRO	125
#define FAC$C_MAIL	126
#define FAC$C_DSM	127
#define FAC$C_PASCAL	128
#define FAC$C_CORAL	129
#define FAC$C_COBOL	130
#define FAC$C_BPA	131
#define FAC$C_SUM	132
#define FAC$C_EDT	133
#define FAC$C_LIBRAR	134
#define FAC$C_PLIG	135
#define FAC$C_DECMAIL	136
#define FAC$C_BASIC	137
#define FAC$C_DIBOL	138
#define FAC$C_FED	139
#define FAC$C_FUT	140
#define FAC$C_DTR	141
#define FAC$C_WPS	142
#define FAC$C_COB74T	143
#define FAC$C_RENAME	144
#define FAC$C_CREATE	145
#define FAC$C_UNLOCK	146
#define FAC$C_DELETE	147
#define FAC$C_PURGE	148
#define FAC$C_TYPE	149
#define FAC$C_RUNOFF	150
#define FAC$C_MESSAGE	151
#define FAC$C_DBO	152
#define FAC$C_DBQ	153
#define FAC$C_DDL	154
#define FAC$C_ACC	159
#define FAC$C_BACKUP	163
#define FAC$C_VERIFY	165
#define FAC$C_PHONE	166
#define FAC$C_ANALYZE	177
#define FAC$C_CONV	178
#define FAC$C_EDF	179
#define FAC$C_FDL	180
#define FAC$C_RDU	183
#define FAC$C_DEU	184
#define FAC$C_CC	185
#define FAC$C_SDL	186
#define FAC$C_PRINT	191
#define FAC$C_RUN	192
#define FAC$C_SUBMIT	193
#define FAC$C_TCNTRL	195
#define FAC$C_REGR	200
#define FAC$C_DUMP	205
#define FAC$C_MNR	206
#define FAC$C_LOGIN	211
#define FAC$C_RECOVER	214
#define FAC$C_SEARCH	215
#define FAC$C_THD	223
#define FAC$C_FDU	224
#define FAC$C_CMU	225
#define FAC$C_SWL	226
#define FAC$C_SWLUP	227
#define FAC$C_FMS	242
#define FAC$C_EXCHANGE	248
#define FAC$C_RPG	249
#define FAC$C_BAD	250
#define FAC$C_QUEMAN	251
#define FAC$C_INPSMB	261
#define FAC$C_PSM	262
#define FAC$C_SMB	272
#define FAC$C_ACLEDIT	277
#define FAC$C_ENCRYPT	282
#define FAC$C_UTIL	286
#define FAC$C_CNF	289
#define FAC$C_SCAN	305
#define FAC$C_SCN	306
#define FAC$C_LAT	374
#define FAC$C_JCOBOL	396
#define FAC$C_JCO	397
#define FAC$C_JLP	398
#define FAC$C_DTK	419
#define FAC$C_MASKIMG	450
#define FAC$C_NET	501
#define FAC$C_DAP	502
#define FAC$C_FAL	503
#define FAC$C_NCP	504
#define FAC$C_NIC	505
#define FAC$C_DLE	506
#define FAC$C_BSCPTP	507
#define FAC$C_HLD	508
#define FAC$C_PSI	509
#define FAC$C_REM	510
#define FAC$C_XK	513
#define FAC$C_NML	517
#define FAC$C_MOM	519
#define FAC$C_SCP	601
#define FAC$C_SCU	602
#define FAC$C_SDM	603
#define FAC$C_SED	604
#define FAC$C_SHJ	605
#define FAC$C_SIO	606
#define FAC$C_SLB	607
#define FAC$C_JBCUPGRAD 785
#define FAC$C_SYSTST	1000
#define FAC$C_RMSTST	1001

struct facdef {
    struct {
	unsigned fac$v_fac_no	: 11;	/* facility number */
	unsigned fac$v_cust_def : 1;	/* 1 if customer defined */
	unsigned fac$v_private	: 1;	/* 1 if private facility */
	unsigned fac$v_wildcard : 1;	/* 1 if wildcard facility */
	unsigned		: 2;
    } fac$r_control_bits;
};

#endif	/*_FACDEF_H*/
