/* <fiddef.h>
 *
 *	File Identification definitions.
 */
#ifndef _FIDDEF_H
#define _FIDDEF_H

#define FID$K_LENGTH 6
#define FID$C_LENGTH 6
/* file id's of the reserved files */
#define FID$C_INDEXF 1		/* index file */
#define FID$C_BITMAP 2		/* storage map file */
#define FID$C_BADBLK 3		/* bad block file */
#define FID$C_MFD    4		/* master file directory */
#define FID$C_CORIMG 5		/* core image file */
#define FID$C_VOLSET 6		/* volume set list file */
#define FID$C_CONTIN 7		/* stanrard continuation file */
#define FID$C_BACKUP 8		/* backup log file */
#define FID$C_BADLOG 9		/* bad block log file */
#define FID$C_FREFIL 10		/* free space file */

/* structure of a file id (FID) */
#ifndef NO_VMS_V6
struct fiddef {
    union {
	unsigned short fid$w_fid[3];		/* file identification number */
	struct {
	    unsigned short fid$w_num;		/* file number */
	    unsigned short fid$w_seq;		/* file sequence number */
	    union {
		unsigned short fid$w_rvn;	/* relative volume number */
		struct {
		    unsigned char fid$b_rvn;	/* byte form of RVN */
		    unsigned char fid$b_nmx;	/* file number extension */
		} fid$r_rvn_fields;
	    } fid$r_rvn_overlay;
	} fid$r_fid_fields;
	struct {				/* file ID fields for ISO 9660 */
	    unsigned short fid$w_dirnum;	/* directory number of File-Id */
	    unsigned int fid$l_recnum;		/* record number of File-ID */
	} fid$r_iso_9660_fields;
    } fid$r_fid_overlay;
};
#else
struct fiddef {
    unsigned short fid$w_num;		/* file number */
    unsigned short fid$w_seq;		/* file sequence number */
    union {
	unsigned short fid$w_rvn;	/* relative volume number */
	struct {
	    unsigned char fid$b_rvn;	/* byte form of RVN */
	    unsigned char fid$b_nmx;	/* file number extension */
	} fid$r_rvn_fields;
    } fid$r_rvn_overlay;
};
#endif

#endif	/*_FIDDEF_H*/
