/* <fordef.h>
 *
 *	Message/status codes for FORRTL
 */
#ifndef _FORDEF_H
#define _FORDEF_H

/*
   Symbols are defined following the standard for global names:
	FOR$_ABCMNOXYZ
   In addition, the library standards specify that the letters "ABC", "MNO",
   and "XYZ" are the first three letters of the first three words of the error
   message, not counting articles and prepositions.
 */
#define FOR$_FACILITY	24	/* 0x0018 */

 /* Never signaled.  Used only as a FORTRAN error number for ERRSNS   */
 /* to mean some other facility than FOR$ or MTH$ detected the error. */
#define FOR$_NOTFORSPE		0x0018800C	/* 1605644 */
#define FOR$_NOTIMP		0x00188014	/* 1605652 */
#define FOR$_IGNORED		0x00188018	/* 1605656 */
#define FOR$_IGNNOTDEL		0x00188020	/* 1605664 */
#define FOR$_SYNERRNAM		0x0018808C	/* 1605772 */
#define FOR$_TOOMANVAL		0x00188094	/* 1605780 */
#define FOR$_INVREFVAR		0x0018809C	/* 1605788 */
#define FOR$_REWERR		0x001880A4	/* 1605796 */
#define FOR$_DUPFILSPE		0x001880AC	/* 1605804 */
#define FOR$_INPRECTOO		0x001880B4	/* 1605812 */
#define FOR$_BACERR		0x001880BC	/* 1605820 */
#define FOR$_ENDDURREA		0x001880C4	/* 1605828 */
#define FOR$_RECNUMOUT		0x001880CC	/* 1605836 */
#define FOR$_OPEDEFREQ		0x001880D4	/* 1605844 */
#define FOR$_TOOMANREC		0x001880DC	/* 1605852 */
#define FOR$_CLOERR		0x001880E4	/* 1605860 */
#define FOR$_FILNOTFOU		0x001880EC	/* 1605868 */
#define FOR$_OPEFAI		0x001880F4	/* 1605876 */
#define FOR$_MIXFILACC		0x001880FC	/* 1605884 */
#define FOR$_INVLOGUNI		0x00188104	/* 1605892 */
#define FOR$_ENDFILERR		0x0018810C	/* 1605900 */
#define FOR$_UNIALROPE		0x00188114	/* 1605908 */
#define FOR$_SEGRECFOR		0x0018811C	/* 1605916 */
#define FOR$_ATTACCNON		0x00188124	/* 1605924 */
#define FOR$_INCRECLEN		0x0018812C	/* 1605932 */
#define FOR$_ERRDURWRI		0x00188134	/* 1605940 */
#define FOR$_ERRDURREA		0x0018813C	/* 1605948 */
#define FOR$_RECIO_OPE		0x00188144	/* 1605956 */
#define FOR$_INSVIRMEM		0x0018814C	/* 1605964 */
#define FOR$_NO_SUCDEV		0x00188154	/* 1605972 */
#define FOR$_FILNAMSPE		0x0018815C	/* 1605980 */
#define FOR$_INCRECTYP		0x00188164	/* 1605988 */
#define FOR$_KEYVALERR		0x0018816C	/* 1605996 */
#define FOR$_INCOPECLO		0x00188174	/* 1606004 */
#define FOR$_WRIREAFIL		0x0018817C	/* 1606012 */
#define FOR$_INVARGFOR		0x00188184	/* 1606020 */
#define FOR$_INVKEYSPE		0x0018818C	/* 1606028 */
#define FOR$_INCKEYCHG		0x00188194	/* 1606036 */
#define FOR$_INCFILORG		0x0018819C	/* 1606044 */
#define FOR$_SPERECLOC		0x001881A4	/* 1606052 */
#define FOR$_NO_CURREC		0x001881AC	/* 1606060 */
#define FOR$_REWRITERR		0x001881B4	/* 1606068 */
#define FOR$_DELERR		0x001881BC	/* 1606076 */
#define FOR$_UNLERR		0x001881C4	/* 1606084 */
#define FOR$_FINERR		0x001881CC	/* 1606092 */
#define FOR$_MORONEREC		0x001880DC	/* 1605852 */
#define FOR$_ATTREANON		0x00188124	/* 1605924 */
#define FOR$_LISIO_SYN		0x001881DC	/* 1606108 */
#define FOR$_INFFORLOO		0x001881E4	/* 1606116 */
#define FOR$_FORVARMIS		0x001881EC	/* 1606124 */
#define FOR$_SYNERRFOR		0x001881F4	/* 1606132 */
#define FOR$_OUTCONERR		0x001881FA	/* 1606138 */
#define FOR$_INPCONERR		0x00188204	/* 1606148 */
#define FOR$_OUTSTAOVE		0x00188214	/* 1606164 */
#define FOR$_INPSTAREQ		0x0018821C	/* 1606172 */
#define FOR$_VFEVALERR		0x00188224	/* 1606180 */
#define FOR$_ADJARRDIM		0x001882EC	/* 1606380 */
#define FOR$_INVMATKEY		0x001882F4	/* 1606388 */
/*
   The following messages are secondary messages, or are used only in
   exit handlers, and therefore do not need to be (and should not be)
   contiguous with the messages above.
 */
/* The next six messages are secondary messages for use with MIXFILACC in */
/* FOR$$IO_BEG and FOR$$CB.						  */
#define FOR$_UNFIO_FMT		0x00188804	/* 1607684 */
#define FOR$_FMTIO_UNF		0x0018880C	/* 1607692 */
#define FOR$_DIRIO_KEY		0x00188814	/* 1607700 */
#define FOR$_SEQIO_DIR		0x0018881C	/* 1607708 */
#define FOR$_KEYIO_DIR		0x00188824	/* 1607716 */
#define FOR$_IO_NONFOR		0x0018882C	/* 1607724 */
/* The next two messages are secondary messages for use with INPCONERR in */
/* FOR$$UDF_WF and FOR$$UDF_WL.						  */
#define FOR$_INVTEXREC		0x00188834	/* 1607732 */
#define FOR$_INVTEX		0x0018883C	/* 1607740 */
/* additional secondary messages */
#define FOR$_OPEREQDIS		0x00188844	/* 1607748 */
#define FOR$_OPEREQSEQ		0x0018884C	/* 1607756 */
/* The next message is a primary message used in the exit handler which */
/* is declared by FOR$HANDLER. */
#define FOR$_FLOUNDEXC		0x00188963	/* 1608035 */
#define FOR$_VECALIGNEXC	0x0018896B	/* 1608043 */
/* end of special messages */

/*
   the following messages are messages issued from FORRTL2, the
   VAX FORTRAN V5.0 parallel processing RTL support.
 */
#define FOR$_FATINTERR		0x00189004	/* 1609732 */
#define FOR$_SUBPRCDIED		0x0018900C	/* 1609740 */
#define FOR$_NOTIMPRET		0x00189014	/* 1609748 */
#define FOR$_FAIOWNERID		0x0018901C	/* 1609756 */
#define FOR$_FAIPRCID		0x00189024	/* 1609764 */
#define FOR$_FAIPRCNAME		0x0018902C	/* 1609772 */
#define FOR$_FAIACTCPU		0x00189034	/* 1609780 */
#define FOR$_FAIIDPRC		0x0018903C	/* 1609788 */
#define FOR$_FAIIMAGNAME	0x00189044	/* 1609796 */
#define FOR$_FAIDCLEXIT		0x0018904C	/* 1609804 */
#define FOR$_FAISUBPRC		0x00189054	/* 1609812 */
#define FOR$_INVNUMPRC		0x0018905C	/* 1609820 */
#define FOR$_MEMSHRERR		0x00189064	/* 1609828 */
#define FOR$_LOCALSHRERR	0x0018906C	/* 1609836 */
#define FOR$_LOCALACCESS	0x00189074	/* 1609844 */
#define FOR$_INVLCLADR		0x0018907C	/* 1609852 */
#define FOR$_COMSHRERR		0x00189084	/* 1609860 */
#define FOR$_INVCOMADR		0x0018908C	/* 1609868 */
#define FOR$_PARINITERR		0x00189094	/* 1609876 */
#define FOR$_STACKSHRERR	0x0018909C	/* 1609884 */
#define FOR$_FAISHRSTACK	0x001890A4	/* 1609892 */
#define FOR$_INVUNWIND		0x001890AC	/* 1609900 */
#define FOR$_STKBUFOVR		0x001890B4	/* 1609908 */
#define FOR$_SUBPRCDEL		0x001890BC	/* 1609916 */
#define FOR$_ASSERTFAIL		0x001890C4	/* 1609924 */
#define FOR$_INVLOGNAM		0x00189802	/* 1611778 */
#define FOR$_TOOMANPRC		0x0018980A	/* 1611786 */
#define FOR$_INVDSTRSIZE	0x00189812	/* 1611794 */
#define FOR$_DEFVALUSED		0x0018A803	/* 1615875 */
#define FOR$_UNIPROCESS		0x0018A80B	/* 1615883 */
#define FOR$_NOPARINIT		0x0018A813	/* 1615891 */
#define FOR$_NOTRUNINPP		0x0018A81B	/* 1615899 */
#define FOR$_NESTPPLOOP		0x0018A823	/* 1615907 */
#define FOR$_UNAWAKSUB		0x0018A82B	/* 1615915 */
/* end of FORRTL2 messages */

#endif	/*_FORDEF_H*/
