/* <gpsdef.h>
 *
 *	OBJFMT -- GSD entry - P-section definition
 */
#ifndef _GPSDEF_H
#define _GPSDEF_H

#define GPS$V_PIC	0
#define GPS$V_LIB	1
#define GPS$V_OVR	2
#define GPS$V_REL	3
#define GPS$V_GBL	4
#define GPS$V_SHR	5
#define GPS$V_EXE	6
#define GPS$V_RD	7
#define GPS$V_WRT	8
#define GPS$V_VEC	9
#define GPS$V_NOMOD	10
#define GPS$V_COM	11
#define GPS$M_PIC	(1<<GPS$V_PIC)		/* 0x01 */
#define GPS$M_LIB	(1<<GPS$V_LIB)		/* 0x02 */
#define GPS$M_OVR	(1<<GPS$V_OVR)		/* 0x04 */
#define GPS$M_REL	(1<<GPS$V_REL)		/* 0x08 */
#define GPS$M_GBL	(1<<GPS$V_GBL)		/* 0x10 */
#define GPS$M_SHR	(1<<GPS$V_SHR)		/* 0x20 */
#define GPS$M_EXE	(1<<GPS$V_EXE)		/* 0x40 */
#define GPS$M_RD	(1<<GPS$V_RD)		/* 0x80 */
#define GPS$M_WRT	(1<<GPS$V_WRT)		/* 0x0100 */
#define GPS$M_VEC	(1<<GPS$V_VEC)		/* 0x0200 */
#define GPS$M_NOMOD	(1<<GPS$V_NOMOD)	/* 0x0400 */
#define GPS$M_COM	(1<<GPS$V_COM)		/* 0x0800 */
#define GPS$K_NAME	9
#define GPS$C_NAME	9
struct gpsdef {
    unsigned char gps$b_gsdtyp;		/* typ field */
    unsigned char gps$b_align;		/* P-sect alignment */
    union {
	unsigned short gps$w_flags;	/* P-sect flags */
	struct {
	    unsigned gps$v_pic : 1;	/* position independent */
	    unsigned gps$v_lib : 1;	/* from a shareable image */
	    unsigned gps$v_ovr : 1;	/* overlaid memory allocation */
	    unsigned gps$v_rel : 1;	/* relocatable */
	    unsigned gps$v_gbl : 1;	/* global scope */
	    unsigned gps$v_shr : 1;	/* shareable */
	    unsigned gps$v_exe : 1;	/* executable */
	    unsigned gps$v_rd  : 1;	/* readable */
	    unsigned gps$v_wrt : 1;	/* writeable */
	    unsigned gps$v_vec : 1;	/* vector psect */
	    unsigned gps$v_nomod : 1;	/* not stored into */
	    unsigned gps$v_com : 1;	/* associated with COMM sym */
	    unsigned	       : 4;
	} gps$r_flags_bits;
    } gps$r_flags_overlay;
    unsigned long gps$l_alloc;		/* length of this contribution */
    unsigned char gps$b_namlng;		/* length of p-sect name */
    char gps$t_name[31];		/* name field */
};

#endif	/*_GPSDEF_H*/
