/* <gsdef.h>
 *
 *	OBJFMT -- global symbol definition record (GSD)
 */
#ifndef _GSDEF_H
#define _GSDEF_H

#define GSD$K_ENTRIES	1	/* offset to first entry in record */
#define GSD$C_ENTRIES	1	/* offset to first entry in record */
#define GSD$C_PSC	0	/* psect definition */
#define GSD$C_SYM	1	/* symbol specification */
#define GSD$C_EPM	2	/* entry point and mask definition */
#define GSD$C_PRO	3	/* procedure with formal arguments */
#define GSD$C_SYMW	4	/* symbol specification with word psect */
#define GSD$C_EPMW	5	/* entry point mask with word psect */
#define GSD$C_PROW	6	/* procedure with word psect */
#define GSD$C_IDC	7	/* random entity check */
#define GSD$C_ENV	8	/* define environment */
#define GSD$C_LSY	9	/* local symbol */
#define GSD$C_LEPM	10	/* local symbol entry point definition */
#define GSD$C_LPRO	11	/* local symbol procedure definition */
#define GSD$C_SPSC	12	/* shareable image psect definition */
/* Vectored symbol types are (regular + 12).  For example, SYMV = SYM + 12. */
#define GSD$C_VECTOR_TYPE_INCREMENT 12
#define GSD$C_SYMV	13	/*Vectored (dual-valued) versions of SYM, */
#define GSD$C_EPMV	14	/* EPM, */
#define GSD$C_PROV	15	/* PRO */
/* Mask symbol types are (regular + 15).  For example, SYMM = SYM + 15. */
#define GSD$C_MASK_TYPE_INCREMENT 15
#define GSD$C_SYMM	16	/*Masked versions of SYM, */
#define GSD$C_EPMM	17	/* EPM, */
#define GSD$C_PROM	18	/* PRO */
#define GSD$C_MAXRECTYP 18	/* maximum entry type defined */

struct gsdef {
    unsigned char gsd$b_rectyp;		/* record type (OBJ$C_GSD) */
    unsigned char gsd$b_gsdtyp;		/* type of entry (first byte of entry) */
};

#endif	/*_GSDEF_H*/
