/* <libdcfdef.h>
 *
 *	Definitions for LIB$DECODE_FAULT
 *	[Note: the "combined values" were wrong under V5.5.]
 */
#ifndef _LIBDCFDEF_H
#define _LIBDCFDEF_H

/* Operand definition codes */
#define LIB$V_DCFACC	0
#define LIB$M_DCFACC	0x07
#define LIB$S_DCFACC	3
#define LIB$V_DCFTYP	3
#define LIB$M_DCFTYP	0xF8
#define LIB$S_DCFTYP	5
struct lib$b_dcf_operand {
    unsigned lib$v_dcfacc : 3;		/* operand access type */
    unsigned lib$v_dcftyp : 5;		/* operand data type */
};

/* Operand access type codes */
#define LIB$K_DCFACC_R	1	/* operand is to be read */
#define LIB$K_DCFACC_M	2	/* operand is to be modified */
#define LIB$K_DCFACC_W	3	/* operand is to be written */
#define LIB$K_DCFACC_A	4	/* operand is an address */
#define LIB$K_DCFACC_V	5	/* operand is a field (may be register or address) */
#define LIB$K_DCFACC_B	6	/* operand is a branch displacement */

/* Operand data type codes */
#define LIB$K_DCFTYP_B	1	/* operand is a byte */
#define LIB$K_DCFTYP_W	2	/* operand is a word */
#define LIB$K_DCFTYP_L	3	/* operand is a longword */
#define LIB$K_DCFTYP_Q	4	/* operand is a quadword */
#define LIB$K_DCFTYP_O	5	/* operand is an octaword */
#define LIB$K_DCFTYP_F	6	/* operand is an F_floating */
#define LIB$K_DCFTYP_D	7	/* operand is a D_floating */
#define LIB$K_DCFTYP_G	8	/* operand is a G_floating */
#define LIB$K_DCFTYP_H	9	/* operand is an H_floating */

/* Combined operand access and data type codes */
#define LIB$K_DCFOPR_AB 12
#define LIB$K_DCFOPR_RB 9
#define LIB$K_DCFOPR_MB 10
#define LIB$K_DCFOPR_WB 11
#define LIB$K_DCFOPR_VB 13
#define LIB$K_DCFOPR_BB 14
#define LIB$K_DCFOPR_AW 20
#define LIB$K_DCFOPR_RW 17
#define LIB$K_DCFOPR_MW 18
#define LIB$K_DCFOPR_WW 19
#define LIB$K_DCFOPR_VW 21
#define LIB$K_DCFOPR_BW 22
#define LIB$K_DCFOPR_AL 28
#define LIB$K_DCFOPR_RL 25
#define LIB$K_DCFOPR_ML 26
#define LIB$K_DCFOPR_WL 27
#define LIB$K_DCFOPR_VL 29
#define LIB$K_DCFOPR_BL 30
#define LIB$K_DCFOPR_AQ 36
#define LIB$K_DCFOPR_RQ 33
#define LIB$K_DCFOPR_MQ 34
#define LIB$K_DCFOPR_WQ 35
#define LIB$K_DCFOPR_VQ 37
#define LIB$K_DCFOPR_AO 44
#define LIB$K_DCFOPR_RO 41
#define LIB$K_DCFOPR_MO 42
#define LIB$K_DCFOPR_WO 43
#define LIB$K_DCFOPR_VO 45
#define LIB$K_DCFOPR_AF 52
#define LIB$K_DCFOPR_RF 49
#define LIB$K_DCFOPR_MF 50
#define LIB$K_DCFOPR_WF 51
#define LIB$K_DCFOPR_VF 53
#define LIB$K_DCFOPR_AD 60
#define LIB$K_DCFOPR_RD 57
#define LIB$K_DCFOPR_MD 58
#define LIB$K_DCFOPR_WD 59
#define LIB$K_DCFOPR_VD 61
#define LIB$K_DCFOPR_AG 68
#define LIB$K_DCFOPR_RG 65
#define LIB$K_DCFOPR_MG 66
#define LIB$K_DCFOPR_WG 67
#define LIB$K_DCFOPR_VG 69
#define LIB$K_DCFOPR_AH 76
#define LIB$K_DCFOPR_RH 73
#define LIB$K_DCFOPR_MH 74
#define LIB$K_DCFOPR_WH 75
#define LIB$K_DCFOPR_VH 77
#define LIB$K_DCFOPR_END 0

#endif	/*_LIBDCFDEF_H*/
