/* <libvmdef.h>
 *
 *	Interface definitions for LIB$VM package
 */
#ifndef _LIBVMDEF_H
#define _LIBVMDEF_H

/* LIB$CREATE_VM_ZONE algorithm codes */
#define LIB$K_VM_FIRST_FIT	1	/* first fit */
#define LIB$K_VM_QUICK_FIT	2	/* quick fit, with fixed queues of preferred sizes */
#define LIB$K_VM_FREQ_SIZES	3	/* first fit, with frequent sizes cache */
#define LIB$K_VM_FIXED		4	/* fixed size blocks */

/* LIB$CREATE_VM_ZONE flag definitions */
#define LIB$V_VM_BOUNDARY_TAGS	0	/* boundary tagged blocks */
#define LIB$V_VM_GET_FILL0	1	/* 0-fill for LIB$GET_VM */
#define LIB$V_VM_GET_FILL1	2	/* 1-fill for LIB$GET_VM */
#define LIB$V_VM_FREE_FILL0	3	/* 0-fill for LIB$FREE_VM */
#define LIB$V_VM_FREE_FILL1	4	/* 1-fill for LIB$FREE_VM */
#define LIB$V_VM_EXTEND_AREA	5	/* add extent to existing area if possible */
#define LIB$V_VM_NO_EXTEND	6	/* area is not allowed to be extended */
#define LIB$V_VM_TAIL_LARGE	7	/* add larger than normal areas at the tail */
#define LIB$M_VM_BOUNDARY_TAGS	(1<<LIB$V_VM_BOUNDARY_TAGS)	/* 0x01 */
#define LIB$M_VM_GET_FILL0	(1<<LIB$V_VM_GET_FILL0)		/* 0x02 */
#define LIB$M_VM_GET_FILL1	(1<<LIB$V_VM_GET_FILL1)		/* 0x04 */
#define LIB$M_VM_FREE_FILL0	(1<<LIB$V_VM_FREE_FILL0)	/* 0x08 */
#define LIB$M_VM_FREE_FILL1	(1<<LIB$V_VM_FREE_FILL1)	/* 0x10 */
#define LIB$M_VM_EXTEND_AREA	(1<<LIB$V_VM_EXTEND_AREA)	/* 0x20 */
#define LIB$M_VM_NO_EXTEND	(1<<LIB$V_VM_NO_EXTEND)		/* 0x40 */
#define LIB$M_VM_TAIL_LARGE	(1<<LIB$V_VM_TAIL_LARGE)	/* 0x80 */

#endif	/*_LIBVMDEF_H*/
