/* <mmedef.h>
 */
#ifndef _MMEDEF_H
#define _MMEDEF_H

#define MME$_UNLOAD		1
#define MME$_ALLOC		2
#define MME$_BACKUP_FILE	3
#define MME$_CLOSE_READ		4
#define MME$_CLOSE_WRITE	5
#define MME$_CONTINUATION_VOLUME 6
#define MME$_DEALLOCATE		7
#define MME$_DEVICE_AVAIL	8
#define MME$_DEVICE_UNAVAIL	9
#define MME$_DISMOUNT		10
#define MME$_DISPLAY_MESSAGE	11
#define MME$_EOV_READ		12
#define MME$_EOV_WRITE		13
#define MME$_INITIALIZE		14
#define MME$_MOUNT		15
#define MME$_MOUNT_REQUEST	16
#define MME$_NEWVOL_REQUEST	17
#define MME$_NOTIFY_DEVICE	18
#define MME$_OPCOM_ACP		19
#define MME$_OPCOM_MOUNT	20
#define MME$_OPEN_READ		21
#define MME$_OPEN_WRITE		22
#define MME$_VOLUME_ONLINE	23
#define MME$_BACKUP_END		24
#define MME$_BACKUP_START	25
#define MME$_WRITE_REQUEST	26
#define MME$_MOUNT_END		27
#define MME$_INIT_END		28
#define MME$_NEWVOL_END		29
#define MME$_DISMNT_PROC_DEL	30

#define MME$S_ACMODE		4
#define MME$S_BLOCKSIZE		4
#define MME$S_DENSITY		4
#define MME$S_DEVICE_CONTEXT	4
#define MME$S_DMT_FLAGS		4
#define MME$S_ERASE		4
#define MME$S_EXPIRATION	8
#define MME$S_FILESEQNO		4
#define MME$S_FILESECNO		4
#define MME$S_IO_FUNCTION	4
#define MME$S_LABEL_ACCESS	1
#define MME$S_MOUNT_CONTEXT	4
#define MME$S_MNT_FLAGS		8
#define MME$S_OBJCNT		4
#define MME$S_OVR_ACCESS	4
#define MME$S_OVR_EXP		4
#define MME$S_OVR_VOLO		4
#define MME$S_OWNER_UIC		4
#define MME$S_PID		4
#define MME$S_RECORDSIZ		4
#define MME$S_RESPONSEREQ	4
#define MME$S_SETNEW1		4
#define MME$S_SETNEW2		4
#define MME$S_VPROT		4
#define MME$S_FILE_ID		6
#define MME$S_GROUPSIZE		4
#define MME$S_PROTECTION	4
#define MME$S_STATUS		4
#define MME$S_ASSIGNMENT_UNIT	4
#define MME$S_CARTRIDGE_SIDE	4
#define MME$S_DISPOSITION	4
#define MME$S_RECFORMAT		1

/* MME action routine argument item codes */
#define MME$_ACMODE		 1
#define MME$_BLOCKSIZE		 2
#define MME$_COMMENT		 3
#define MME$_DENSITY		 4
#define MME$_DEVICE_CONTEXT	 5
#define MME$_DMT_FLAGS		 6
#define MME$_EOF1		 7
#define MME$_EOF2		 8
#define MME$_EOF3		 9
#define MME$_EOF4		10
#define MME$_EOV1		11
#define MME$_EOV2		12
#define MME$_EOV3		13
#define MME$_EOV4		14
#define MME$_ERASE		15
#define MME$_FIB		16
#define MME$_FILESEQNO		17
#define MME$_HDR1		18
#define MME$_HDR2		19
#define MME$_HDR3		20
#define MME$_HDR4		21
#define MME$_IO_FUNCTION	22
#define MME$_LABEL_ACCESS	23
#define MME$_LABEL_VOLO		24
#define MME$_MOUNT_CONTEXT	25
#define MME$_MNT_FLAGS		26
#define MME$_MSG1		27
#define MME$_MSG2		28
#define MME$_NEWDEVNAM		29
#define MME$_NEWMSG1		30
#define MME$_NEWMSG2		31
#define MME$_NEWVOLNAM		32
#define MME$_NXTVOL		33
#define MME$_OBJCNT		34
#define MME$_OVR_ACCESS		35
#define MME$_OVR_EXP		36
#define MME$_OVR_VOLO		37
#define MME$_OWNER_UIC		38
#define MME$_PHYDEVNAM		39
#define MME$_PID		40
#define MME$_PREV_VOL		41
#define MME$_PROCESSOR		42
#define MME$_RECORDSIZ		43
#define MME$_REQDEVNAM		44
#define MME$_RESPONSEREQ	45
#define MME$_SETNEW1		46
#define MME$_SETNEW2		47
#define MME$_VOL1		48
#define MME$_VOL2		49
#define MME$_VOLNAM		50
#define MME$_VPROT		51
#define MME$_BACKUP_FILE_FLAGS	52
#define MME$_BACKUP_FLAGS	53
#define MME$_EXPIRATION		54
#define MME$_FILENAME		55
#define MME$_FILE_ID		56
#define MME$_GROUPSIZE		57
#define MME$_IN_SAVE		58
#define MME$_IN_SPECIFICATION	59
#define MME$_IN_VOLUME		60
#define MME$_OUT_SAVE		61
#define MME$_PROTECTION		62
#define MME$_STATUS		63
#define MME$_ASSIGNMENT_UNIT	64
#define MME$_CART_MEDIA_NAME	65
#define MME$_CARTRIDGE_NAME	66
#define MME$_CARTRIDGE_SIDE	67
#define MME$_COLLECTION		68
#define MME$_DEVICE_TYPE	69
#define MME$_DISPOSITION	70
#define MME$_LOCATION		71
#define MME$_MEDIA_NAME		72
#define MME$_LABEL_TYPE		73
#define MME$_EXPDATE		74
#define MME$_CREDATE		75
#define MME$_RECFORMAT		76
#define MME$_FILESECNO		77
#define MME$_REPLY		78

/* flag masks for MME$_BACKUP_FLAGS */
#define MME$V_IMAGE		0
#define MME$V_CRC		1
#define MME$V_DELETE		2
#define MME$V_IGN_INTERLOCK	3
#define MME$V_IGN_LABEL		4
#define MME$V_IGN_NOBACKUP	5
#define MME$V_INTERCHANGE	6
#define MME$V_RECORD		7
#define MME$V_REWIND		8
#define MME$V_VERIFY		9
#define MME$V_PHYSICAL		10
#define MME$V_COMPACTION	11
#define MME$M_IMAGE		(1<<MME$V_IMAGE)	/* 0x0001 */
#define MME$M_CRC		(1<<MME$V_CRC)		/* 0x0002 */
#define MME$M_DELETE		(1<<MME$V_DELETE)	/* 0x0004 */
#define MME$M_IGN_INTERLOCK	(1<<MME$V_IGN_INTERLOCK) /* 0x0008 */
#define MME$M_IGN_LABEL		(1<<MME$V_IGN_LABEL)	/* 0x0010 */
#define MME$M_IGN_NOBACKUP	(1<<MME$V_IGN_NOBACKUP) /* 0x0020 */
#define MME$M_INTERCHANGE	(1<<MME$V_INTERCHANGE)	/* 0x0040 */
#define MME$M_RECORD		(1<<MME$V_RECORD)	/* 0x0080 */
#define MME$M_REWIND		(1<<MME$V_REWIND)	/* 0x0100 */
#define MME$M_VERIFY		(1<<MME$V_VERIFY)	/* 0x0200 */
#define MME$M_PHYSICAL		(1<<MME$V_PHYSICAL)	/* 0x0400 */
#define MME$M_COMPACTION	(1<<MME$V_COMPACTION)	/* 0x0800 */

struct mme$backup_flags {
    union {
	unsigned mme$l_flags_mask;
	struct {
	    unsigned mme$v_image	: 1;
	    unsigned mme$v_crc		: 1;
	    unsigned mme$v_delete	: 1;
	    unsigned mme$v_ign_interlock : 1;
	    unsigned mme$v_ign_label	: 1;
	    unsigned mme$v_ign_nobackup : 1;
	    unsigned mme$v_interchange	: 1;
	    unsigned mme$v_record	: 1;
	    unsigned mme$v_rewind	: 1;
	    unsigned mme$v_verify	: 1;
	    unsigned mme$v_physical	: 1;
	    unsigned mme$v_compaction	: 1;
	    unsigned			: 20;
	} mme$r_flags_bits;
    } mme$r_flags_overlay;
};

/* flag masks for MME$_FILE_BACKUP_FLAGS */
#define MME$V_VERIF_ERR 0
#define MME$V_NOBACKUP	1
#define MME$V_FILE_OPEN 2
#define MME$V_ACC_CONF	3
#define MME$M_VERIF_ERR (1<<MME$V_VERIF_ERR)	/* 0x01 */
#define MME$M_NOBACKUP	(1<<MME$V_NOBACKUP)	/* 0x02 */
#define MME$M_FILE_OPEN (1<<MME$V_FILE_OPEN)	/* 0x04 */
#define MME$M_ACC_CONF	(1<<MME$V_ACC_CONF)	/* 0x08 */

struct mme$backup_file_flags {
    union {
	unsigned int mme$l_file_flags_mask;
	struct {
	    unsigned mme$v_verif_err	: 1;
	    unsigned mme$v_nobackup	: 1;
	    unsigned mme$v_file_open	: 1;
	    unsigned mme$v_acc_conf	: 1;
	    unsigned			: 28;
	} mme$r_file_flags_bits;
    } mme$r_file_flags_overlay;
};

#define MME$C_ANSI_1	1
#define MME$C_ANSI_2	2
#define MME$C_ANSI_3	3
#define MME$C_ANSI_4	4
#define MME$C_IBM_STD	5
#define MME$C_UNLABELLED 6
#define MME$C_ODS1	7
#define MME$C_ODS2	8

#endif	/*_MMEDEF_H*/
