/* <msgdef.h>
 *
 *	System wide mailbox message types
 */
#ifndef _MSGDEF_H
#define _MSGDEF_H

/* define codes as constants */
#define MSG$_TRMUNSOLIC 1	/* unsolicited terminal data */
#define MSG$_CRUNSOLIC	2	/* unsolicted card reader data */
#define MSG$_DELPROC	3	/* delete process */
#define MSG$_SNDSMB	4	/* send to symbiont manager */
#define MSG$_DEVOFFLIN	5	/* device offline */
#define MSG$_TRMHANGUP	6	/* terminal hang up */
#define MSG$_DEVONLIN	7	/* device online */
#define MSG$_OPRQST	8	/* operator request *** overlapped code *** */
#define MSG$_OPREPLY	9	/* operator reply *** overlapped code *** */
/* define symbiont response messages */
#define MSG$_SMBINI	8	/* symbiont has inited */
#define MSG$_SMBDON	9	/* symbiont finished */
#define MSG$_SNDACC	10	/* send message to accounting manager */
#define MSG$_PURPROC	11	/* purge process *** overlapped code *** */
#define MSG$_DELIMAG	12	/* delete image *** overlapped code *** */
#define MSG$_PURIMAG	13	/* purge image *** overlapped code *** */
#define MSG$_SYSFUNC	14	/* system function *** overlapped code *** */
#define MSG$_SNDJBC	15	/* send message to job controller */
#define MSG$_GETQUI	16	/* get queue information (from job controller) */
/* define DMC messages */
#define MSG$_XM_DATAVL	11	/* DMC unsolicited data */
#define MSG$_XM_SHUTDN	12	/* DMC line down */
#define MSG$_XM_ATTN	13	/* DMC attention message */
/* symbiont command messages */
#define MSG$_INIOPR	16	/* initiate printing a file */
#define MSG$_ABOOPR	17	/* abort printing a file */
#define MSG$_SUSOPR	18	/* pause printing the file */
#define MSG$_RESOPR	19	/* resume printing the file */
#define MSG$_DELSMB	20	/* symbiont should delete itself */
#define MSG$_REQUE	21	/* requeue a file for printing */
/* */
#define MSG$_SMBRSP	32	/* symbiont manager response */
#define MSG$_ACCRSP	33	/* accounting manager response */
/* file acp messages */
#define MSG$_SCANBAD	40	/* scan file for bad blocks */
#define MSG$_SCANRSP	41	/* response from file scanner */
/* network attention codes */
#define MSG$_ABORT	48	/* partner aborted link */
#define MSG$_CONFIRM	49	/* connect confirm */
#define MSG$_CONNECT	50	/* inbound connect initiate */
#define MSG$_DISCON	51	/* partner disconnected - hangup */
#define MSG$_EXIT	52	/* partner exited prematurely */
#define MSG$_INTMSG	53	/* interrupt message - unsolicited data */
#define MSG$_PATHLOST	54	/* NFW - path lost to partner */
#define MSG$_PROTOCOL	55	/* protocol error */
#define MSG$_REJECT	56	/* connect reject */
#define MSG$_THIRDPARTY 57	/* third party disconnect */
#define MSG$_TIMEOUT	58	/* connect timeout */
#define MSG$_NETSHUT	59	/* network shutting down */
#define MSG$_NODEACC	60	/* node has become accessible */
#define MSG$_NODEINACC	61	/* node has become inaccessible */
#define MSG$_EVTAVL	62	/* events are available to EVL */
#define MSG$_EVTRCVCHG	63	/* event receiver database change */
#define MSG$_INCDAT	64	/* X25 incoming data */
#define MSG$_RESET	65	/* X25 circuit reset */
#define MSG$_LINUP	66	/* X25 PVC line up */
#define MSG$_LINDWN	67	/* X25 PVC line down */
#define MSG$_EVTXMTCHG	68	/* event transmitter database change */
/* mount verification messages */
#define MSG$_DEVOFFLINX 80	/* device offline */
#define MSG$_WRONGVOL	81	/* wrong volume in device */
#define MSG$_DEVWRTLCK	82	/* device has been write locked */
#define MSG$_TRMBRDCST	83	/* terminal broadcast */
#define MSG$_MVCOMPLETE 84	/* mount verification completed */
#define MSG$_MVABORTED	85	/* mount verification aborted */
#define MSG$_DISMOUNTED 86	/* volume dismounted */
#define MSG$_UDA50MVER	87	/* UDA50 micorcode not upto rev */
#define MSG$_DUPUNITNO	88	/* MSCP controller - duplicate unit ! */
#define MSG$_CLUMBX	89	/* cnxmgr to opcom messages */
#define MSG$_TM78MVER	90	/* TM78 microcode not up to rev level */
#define MSG$_SHAMEMFAL	91	/* member failed out of shadow set */
#define MSG$_SHARDUCED	92	/* shadow set reduced */
#define MSG$_RC25MVER	93	/* RC25 micorcode not upto rev */
#define MSG$_RDRXMVER	94	/* RDRX micorcode not upto rev */
#define MSG$_TU81MVER	95	/* TU81 micorcode not upto rev */
#define MSG$_MAYAMVER	96	/* MAYA micorcode not upto rev */
#define MSG$_SHACHASTA	97	/* shadow set has changed state */
#define MSG$_SHACOPCOM	98	/* shadow copy operation has completed */
#define MSG$_SHAREDZER	99	/* shadow set reduced to zero members */
#define MSG$_SHAPOSMEM	100	/* possible shadow set member */
#define MSG$_SHAALLCOM	101	/* all shadow set copy operations completed */
#define MSG$_SHACOPBEG	102	/* shadow copy operation begun */
#define MSG$_SHAWROMEM	103	/* shadow member contains wrong volume */
#define MSG$_SHAORGMEM	104	/* shadow system disk missing VMB R3 member */
#define MSG$_TRMLOSE_KB 105	/* terminal lost physical KB */
#define MSG$_TRMGAIN_KB 106	/* terminal gained physical KB */
#define MSG$_TRMSHRINK	107	/* terminal window shrunk to icon */
#define MSG$_TRMEXPAND	108	/* terminal window icon expanded */
#define MSG$_TRMRESIZE	109	/* terminal window resized */
#define MSG$_TRMMOVE	110	/* terminal window moved */
#define MSG$_SNDMME	111	/* message to media management extensions */
#define MSG$_RETMME	112	/* message returned from media management software */
#ifndef NO_VMS_V6
#define MSG$_SHAADPBAD	113	/* shadow VMB R3 member not currently connected to original boot adapter type (PA versus PU)*/
#define MSG$_SHAEMUPTH	114	/* shadow VMB R3 member not currently connected to original boot adapter - on an emulated pa*/
#define MSG$_SHABENODMP 115	/* shadow VMB R3 member not on original adapter, current type unknown */
#define MSG$_SHABNODMP	116	/* shadow VMB R3 member not the master of set or not on PATH named to VMB */
#define MSG$_SHALOCDEV	117	/* a satellite's shadow master member is now on a local device, no reboot or dumps possible */
#define MSG$_SHANOBPOK	118	/* shadow VMB R3 member is not a member of the set */
#define MSG$_SHABDMPOK	119	/* shadow VMB R3 member is on the original adapter */
#define MSG$_BOOTDMPOK	120	/* system dump will has been redirected to the current master member */
#define MSG$_SHABDBCK	121	/* shadow VMB R3 member has returned to the original adapter */
#define MSG$_SHANODMP	122	/* shadow master changed. Dump will NOT be written if system crashes. */
#define MSG$_SHADMPOK	123	/* shadow master changed. Dump WILL be written if system crashes. */
#endif
/* define messages for use by qman */
#define MSG$_QMAN_INTERNAL 200	/* QMAN internal message */

#endif	/*_MSGDEF_H*/
