/* <vms/lib/nfbdef.h>
 *
 *	NETACP $QIO interface.				[not it Starlet]
 */
#ifndef _NFBDEF_H
#define _NFBDEF_H

/* the following generic field identifiers are defined for all databases */
#define NFB$C_ENDOFLIST 0	/* used to terminate the field ID */
#define NFB$C_WILDCARD	1	/* field ID used for "match all" database searches */
#define NFB$C_CTX_SIZE	64	/* length of context area in P2 buffer */

/* the following codes are passed in the second IOSB longword to qualify   */
/* as SS$_ILLCNTRFUNC error; the high order word of these error codes must */
/* be 0 so that they won't be confused with field IDs			   */
#define NFB$_ERR_FCT		 1	/* unrecognized NFB$B_FCT value */
#define NFB$_ERR_DB		 2	/* unrecognized NFB$B_DATABASE value */
#define NFB$_ERR_P1		 3	/* the P1 buffer is invalid */
#define NFB$_ERR_P2		 4	/* the P2 buffer is invalid */
#define NFB$_ERR_P3		 5	/* the P3 buffer is invalid */
#define NFB$_ERR_P4		 6	/* the P4 buffer is invalid */
#define NFB$_ERR_P5		 7	/* the P5 buffer should not have been specified */
#define NFB$_ERR_P6		 8	/* the P6 buffer should not have been specified */
#define NFB$_ERR_CELL		 9	/* unrecognized NFB$B_CELL value */
#define NFB$_ERR_OPER		10	/* unrecognized NFB$B_OPER value */
#define NFB$_ERR_SRCH		11	/* unrecognized NFB$L_SRCH_KEY field ID */
#define NFB$_ERR_SRCH2		12	/* unrecognized NFB$L_SRCH2_KEY field ID */
#define NFB$_ERR_OPER2		13	/* unrecognized NFB$B_OPER2 value */
#define NFB$_ERR_FLAGS		14	/* undefined bits in NFB$B_FLAGS were not zero */
#define NFB$_ERR_LOCK		15	/* lock was not granted */
/* define the P1 buffer format */
#define NFB$C_DECLNAME		21	/* declare name */
#define NFB$C_DECLOBJ		22	/* declare object */
#define NFB$C_DECLSERV		23	/* declare server process available */
/* resume defining function codes */
#define NFB$C_LOGEVENT		28	/* log a network event */
#define NFB$C_READEVENT		29	/* read current raw event queue (used by EVL only) */
#define NFB$C_FC_DELETE		33	/* remove an entry from the data base */
#define NFB$C_FC_SHOW		34	/* return specified field values */
#define NFB$C_FC_SET		35	/* set/modify the field values */
#define NFB$C_FC_CLEAR		36	/* clear specified field values */
#define NFB$C_FC_ZERCOU		37	/* zero (and optionally read) counters */
#define NFB$C_FC_LOOP		38	/* loop (used only to PSI to loop an X.25 line) */
#define NFB$C_REBUILD_PROXY	39	/* rebuild the proxy data base */
#define NFB$C_ADD_PROXY		40	/* add/modify proxy DB entry */
#define NFB$C_DELETE_PROXY	41	/* remove/delete proxy access */
#define NFB$C_FC_MAX		41	/* maximum FCT value */

#define NFB$V_ERRUPD	0
#define NFB$V_MULT	1
#define NFB$V_NOCTX	2
#define NFB$V_LOCAL	3
#define NFB$M_ERRUPD	(1<<NFB$V_ERRUPD)	/* 0x01 */
#define NFB$M_MULT	(1<<NFB$V_MULT)		/* 0x02 */
#define NFB$M_NOCTX	(1<<NFB$V_NOCTX)	/* 0x04 */
#define NFB$M_LOCAL	(1<<NFB$V_LOCAL)	/* 0x08 */

#define NFB$C_DB_LNI	1	/* local node */
#define NFB$C_DB_NDI	2	/* common nodes */
#define NFB$C_DB_OBI	3	/* network objects */
#define NFB$C_DB_CRI	4	/* circuits */
#define NFB$C_DB_PLI	5	/* lines */
#define NFB$C_DB_EFI	6	/* event logging filters */
#define NFB$C_DB_ESI	7	/* event logging sinks */
#define NFB$C_DB_LLI	8	/* logical-links */
#define NFB$C_DB_XNI	9	/* X.25 networks */
#define NFB$C_DB_XGI	10	/* X.25 groups */
#define NFB$C_DB_XDI	11	/* X.25 DTEs */
#define NFB$C_DB_XS5	12	/* X.25 server */
#define NFB$C_DB_XD5	13	/* X.25 destinations */
#define NFB$C_DB_XS9	14	/* X.29 server */
#define NFB$C_DB_XD9	15	/* X.29 destinations */
#define NFB$C_DB_XTI	16	/* X.25 trace facility */
#define NFB$C_DB_XTT	17	/* X.25 tracepoints */
#define NFB$C_DB_SPI	18	/* server Process */
#define NFB$C_DB_AJI	19	/* adjacency information */
#define NFB$C_DB_ARI	20	/* area information */
#define NFB$C_DB_XDTE	21	/* PSI reserved database */
#define NFB$C_DB_PSI2	22	/* PSI reserved database */
#define NFB$C_DB_PSI3	23	/* PSI reserved database */
#define NFB$C_DB_PSI4	24	/* PSI reserved database */
#define NFB$C_DB_PSI5	25	/* PSI reserved database */
#define NFB$C_DB_SDI	26	/* service (DLE) information */
#define NFB$C_DB_XAI	27	/* X.25 access database */
#define NFB$C_DB_PROXY	28	/* proxy data base */
#define NFB$C_DB_XXX	29	/* last database definition for NFB$C_DB_MAX calc */
#define NFB$C_DB_MAX	28	/* maximum DATABASE value */

/* function codes for the NFB */
#define NFB$C_OP_EQL	0	/* match if SEARCH_KEY value EQL database entry field */
#define NFB$C_OP_GTRU	1	/* match if SEARCH_KEY value GTRU database entry field */
#define NFB$C_OP_LSSU	2	/* match if SEARCH_KEY value LSSU database entry field */
#define NFB$C_OP_NEQ	3	/* match if SEARCH_KEY value NEQ database entry field */
	/* the following may only be used internally by NETACP */
#define NFB$C_OP_FNDMIN 4	/* find entry with minimum key value */
#define NFB$C_OP_FNDMAX 5	/* find entry with maximum key value */
#define NFB$C_OP_FNDPOS 6	/* find entry position in database */
	/* maximum operator function */
#define NFB$C_OP_MAXFCT 3	/* maximum operator function */
#define NFB$C_OP_MAXINT 6	/* maximum internal function */

#define NFB$K_LENGTH	16	/* minimum structure size */
#define NFB$C_LENGTH	16	/* minimum structure size */
#define NFB$S_NFBDEF	20	/* old size name - synonym */
#define NFB$S_NFB	20
struct nfbdef {
    unsigned char nfb$b_fct;		/* function code */
    union {
	unsigned char nfb$b_flags;	/* miscellaneous control flags */
	struct {
	    unsigned nfb$v_errupd : 1;	/* update position context, even on error */
	    unsigned nfb$v_mult   : 1;	/* process as many entries as can be fit into P4 */
	    unsigned nfb$v_noctx  : 1;	/* don't update position context, even if successful */
	    unsigned nfb$v_local  : 1;	/* signal that REBUILD_PROXY should only be performed locally */
	    unsigned		  : 4;
	} nfb$r_flags_bits;
    } nfb$r_flags_overlay;
    unsigned char nfb$b_database;	/* database code; ZERO is an illegal value for this field */
    unsigned char nfb$b_oper;		/* specifies the sense of the search (e.g. EQL, GEQU) */
					/* when comparing against the SRCH_KEY field */
    unsigned long nfb$l_srch_key;	/* Search key field identifier specifying the key used	*/
					/* to locate the entry in the database; this search is	*/
					/* controlled by the sense of the NFB$B_OPER field.	*/
					/* If this field has the value "NFB$C_WILDCARD", then	*/
					/* the very next entry in the list is assumed to be the */
					/* target of the search.				*/
					/* If this field is not specified (zero), then it	*/
					/* is assumed to be NFB$C_WILDCARD (no search key).	*/
    unsigned long nfb$l_srch2_key;	/* Secondary search key field ID specifying the key used */
					/* to locate the entry in the database; this search is	 */
					/* controlled by the sense of the NFB$B_OPER2 field.	 */
					/* If both SRCH_KEY and SRCH2_KEY are specified, then	 */
					/* only those database entries matching both search keys */
					/* will be processed.					 */
					/* If this field is not specified (zero), then it	 */
					/* is assumed to be NFB$C_WILDCARD (no search key).	 */
    unsigned char nfb$b_oper2;		/* specifies the sense of the search (e.g. EQL, GEQU) */
					/* when comparing against the SRCH2_KEY field */
    unsigned char nfb$b_mbz1;		/* reserved; must be zero */
    unsigned short nfb$w_cell_size;	/* some of the field values found in the P4 buffer are */
					/* counted strings; if the "cell size" is non-zero, it */
					/* indicates the number of bytes which each string in */
					/* the P4 buffer occupies; if it is zero then strings */
					/* fields are stored as variable lengthed strings */
    unsigned long nfb$l_fldid;		/* cell containing the first field ID -- the list */
					/* of field IDs begins here and continues to the */
					/* end of the structure; terminate with NFB$C_ENDOFLIST */
};

/* define the "field ID" format */
#define NFB$V_INX	0
#define NFB$V_TYP	16
#define NFB$V_SPARE	19
#define NFB$V_DB	24
#define NFB$S_INX	16
#define NFB$S_TYP	2
#define NFB$S_SPARE	6
#define NFB$S_DB	8
#define NFB$M_INX	0x0000FFFF
#define NFB$M_TYP	0x00030000
#define NFB$M_SPARE	0x00FC0000
#define NFB$M_DB	0xFF000000

#define NFB$C_TYP_BIT	0	/* field type for bits */
#define NFB$C_TYP_V	0	/* field type for bits */
#define NFB$C_TYP_LNG	1	/* field type for longwords */
#define NFB$C_TYP_L	1	/* field type for longwords */
#define NFB$C_TYP_STR	2	/* field type for strings */
#define NFB$C_TYP_S	2	/* field type for strings */

#define NFB$S_NFBDEF1	4	/* old size name - synonym */
#define NFB$S_NFB1	4
union nfbdef1 {
    unsigned long      nfb$l_param_id;	/* define parameter ID longword */
    struct {
	unsigned short nfb$v_inx;	/* index into semantic table */
	unsigned       nfb$v_typ   : 2; /* field type (string, bit, etc.) */
	unsigned       nfb$v_spare : 6; /* reserved, MBZ */
	unsigned char  nfb$v_db;	/* data-base ID */
    } nfb$r_param_id_fields;
};

/* define useless symbols for storing and retreiving binary and string */
/* values from the P2 and P4 buffers				       */

#define NFB$S_NFBDEF2	4	/* old size name - synonym */
#define NFB$S_NFB2	4
struct nfbdef2 {
    unsigned long nfb$l_lng_value;	/* longword value */
};

#define NFB$S_NFBDEF3	4	/* old size name - synonym */
#define NFB$S_NFB3	4
struct nfbdef3 {
    unsigned long nfb$l_bit_value;	/* boolean value */
};

#define NFB$S_NFBDEF4	2	/* old size name - synonym */
#define NFB$S_NFB4	2
struct nfbdef4 {
    unsigned short nfb$w_str_count;	/* string count field */
 /* char nfb$b_str_text[0]; */		/* start of string data */
};


/* define a field identifier index for each parameter in the NDI database */
	/* boolean */
#define NFB$C_NDI_LCK	0x02000001 /* set if conditionally writable fields are not writable */
#define NFB$C_NDI_LOO	0x02000002 /* set if CNF is for a "loopback" node */
#define NFB$C_NDI_REA	0x02000003 /* set if node is reachable */
	/* longword */
#define NFB$C_NDI_TAD	0x02010010 /* "transformed address" - uses local node address */
				   /* for the local NDI (instead of zero as does ADD) */
#define NFB$C_NDI_CTA	0x02010011 /* absolute due time for logging counters */
#define NFB$C_NDI_ADD	0x02010012 /* address */
#define NFB$C_NDI_CTI	0x02010013 /* counter timer */
#define NFB$C_NDI_ACL	0x02010014 /* active links */
#define NFB$C_NDI_DEL	0x02010015 /* delay */
#define NFB$C_NDI_DTY	0x02010016 /* destination type */
#define NFB$C_NDI_DCO	0x02010017 /* destination cost */
#define NFB$C_NDI_DHO	0x02010018 /* destination hops */
#define NFB$C_NDI_SDV	0x02010019 /* service Device */
#define NFB$C_NDI_CPU	0x0201001A /* CPU type */
#define NFB$C_NDI_STY	0x0201001B /* software type */
#define NFB$C_NDI_DAD	0x0201001C /* dump address */
#define NFB$C_NDI_DCT	0x0201001D /* dump count */
#define NFB$C_NDI_OHO	0x0201001E /* host */
#define NFB$C_NDI_IHO	0x0201001F /* host */
#define NFB$C_NDI_ACC	0x02010020 /* access switch (inbound, outbound, etc) */
#define NFB$C_NDI_PRX	0x02010021 /* ** obsolete ** (node proxy parameter) */
#define NFB$C_NDI_NND	0x02010022 /* next node address */
#define NFB$C_NDI_SNV	0x02010023 /* service node version */
#define NFB$C_NDI_INB	0x02010024 /* async line - inbound node type */
	/* string */
#define NFB$C_NDI_COL	0x02020040 /* collating field */
#define NFB$C_NDI_HAC	0x02020041 /* node address/loop linename combination */
#define NFB$C_NDI_CNT	0x02020042 /* counters */
#define NFB$C_NDI_NNA	0x02020043 /* name */
#define NFB$C_NDI_SLI	0x02020044 /* service line */
#define NFB$C_NDI_SPA	0x02020045 /* service password */
#define NFB$C_NDI_LOA	0x02020046 /* load file */
#define NFB$C_NDI_SLO	0x02020047 /* secondary loader */
#define NFB$C_NDI_TLO	0x02020048 /* tertiary loader */
#define NFB$C_NDI_SID	0x02020049 /* software ID */
#define NFB$C_NDI_DUM	0x0202004A /* dump file */
#define NFB$C_NDI_SDU	0x0202004B /* secondary dumper */
#define NFB$C_NDI_NLI	0x0202004C /* loopback line */
#define NFB$C_NDI_DLI	0x0202004D /* destination line */
#define NFB$C_NDI_PUS	0x0202004E /* privileged user ID */
#define NFB$C_NDI_PAC	0x0202004F /* privileged account */
#define NFB$C_NDI_PPW	0x02020050 /* privileged password */
#define NFB$C_NDI_NUS	0x02020051 /* non-privileged user ID */
#define NFB$C_NDI_NAC	0x02020052 /* non-privileged account */
#define NFB$C_NDI_NPW	0x02020053 /* non-privileged password */
#define NFB$C_NDI_RPA	0x02020054 /* receive password */
#define NFB$C_NDI_TPA	0x02020055 /* transmit password */
#define NFB$C_NDI_DFL	0x02020056 /* diagnostic load file */
#define NFB$C_NDI_HWA	0x02020057 /* hardware NI address (ROM address) */
#define NFB$C_NDI_LPA	0x02020058 /* loop assistant NI address */
#define NFB$C_NDI_NNN	0x02020059 /* next node name to destination (goes with NND) */
#define NFB$C_NDI_LAA	0x0202005A /* load assist agent */
#define NFB$C_NDI_LAP	0x0202005B /* load assist parameter */
#define NFB$C_NDI_MFL	0x0202005C /* management file */

/* define a field identifier index for each parameter in the LNI database */
	/* boolean */
#define NFB$C_LNI_LCK	0x01000001 /* set if conditionally writable fields are not writable */
#define NFB$C_LNI_ALI	0x01000002 /* set if ALIAS INBOUND has been enabled */
#define NFB$C_LNI_IPR	0x01000003 /* incoming proxy enabled/disabled */
#define NFB$C_LNI_OPR	0x01000004 /* outgoing proxy enabled/disabled */
	/* longword */
#define NFB$C_LNI_ADD	0x01010010 /* address */
#define NFB$C_LNI_ACL	0x01010011 /* total number of active links */
#define NFB$C_LNI_ITI	0x01010012 /* incoming timer */
#define NFB$C_LNI_OTI	0x01010013 /* outgoing timer */
#define NFB$C_LNI_STA	0x01010014 /* state */
#define NFB$C_LNI_MLK	0x01010015 /* maximum links */
#define NFB$C_LNI_DFA	0x01010016 /* delay factor */
#define NFB$C_LNI_DWE	0x01010017 /* delay weight */
#define NFB$C_LNI_IAT	0x01010018 /* inactivity timer */
#define NFB$C_LNI_RFA	0x01010019 /* retransmit factor */
#define NFB$C_LNI_ETY	0x0101001A /* executor type */
#define NFB$C_LNI_RTI	0x0101001B /* routing timer */
#define NFB$C_LNI_RSI	0x0101001C /* routing suppression timer */
#define NFB$C_LNI_SAD	0x0101001D /* subaddress (lower word = lower limit, upper word = upper limit) */
#define NFB$C_LNI_MAD	0x0101001E /* maximum address */
#define NFB$C_LNI_MLN	0x0101001F /* maximum lines */
#define NFB$C_LNI_MCO	0x01010020 /* maximum cost */
#define NFB$C_LNI_MHO	0x01010021 /* maximum hops */
#define NFB$C_LNI_MVI	0x01010022 /* maximum visits */
#define NFB$C_LNI_MBU	0x01010023 /* maximum buffers */
#define NFB$C_LNI_BUS	0x01010024 /* forwarding buffer size */
#define NFB$C_LNI_LPC	0x01010025 /* loop count */
#define NFB$C_LNI_LPL	0x01010026 /* loop length */
#define NFB$C_LNI_LPD	0x01010027 /* loop data type */
#define NFB$C_LNI_DAC	0x01010028 /* default access switch (inbound, outbound, etc) */
#define NFB$C_LNI_FILL1 0x01010029 /* place holder, used to be default proxy access (inbound, outbound, etc) */
#define NFB$C_LNI_PIQ	0x0101002A /* pipeline quota */
#define NFB$C_LNI_LPH	0x0101002B /* loop help type of assistance given to loop requestors */
#define NFB$C_LNI_BRT	0x0101002C /* broadcast routing timer */
#define NFB$C_LNI_MAR	0x0101002D /* maximum areas */
#define NFB$C_LNI_MBE	0x0101002E /* maximum nonrouters on NI */
#define NFB$C_LNI_MBR	0x0101002F /* maximum routers on NI */
#define NFB$C_LNI_AMC	0x01010030 /* area maximum cost */
#define NFB$C_LNI_AMH	0x01010031 /* area maximum hops */
#define NFB$C_LNI_SBS	0x01010032 /* segment buffer size */
#define NFB$C_LNI_ALA	0x01010033 /* alias local node address (cluster address) */
#define NFB$C_LNI_ALM	0x01010034 /* alias maximum links */
#define NFB$C_LNI_PSP	0x01010035 /* path split policy normal/interim */
#define NFB$C_LNI_MPS	0x01010036 /* maximum path split */
#define NFB$C_LNI_MDO	0x01010037 /* maximum declared object */
	/* string */
#define NFB$C_LNI_COL	0x01020040 /* collating field */
#define NFB$C_LNI_NAM	0x01020041 /* local node name */
#define NFB$C_LNI_CNT	0x01020042 /* counters */
#define NFB$C_LNI_IDE	0x01020043 /* identification */
#define NFB$C_LNI_MVE	0x01020044 /* management version */
#define NFB$C_LNI_NVE	0x01020045 /* NSP version */
#define NFB$C_LNI_RVE	0x01020046 /* routing version */
#define NFB$C_LNI_PHA	0x01020047 /* physical NI address (current address) */

/* define a field identifier index for each parameter in the OBI database */
	/* boolean */
#define NFB$C_OBI_LCK	0x03000001 /* set if conditionally writable fields are not writable */
#define NFB$C_OBI_SET	0x03000002 /* set if a "set" QIO has ever modified the CNF; if */
				   /* not then the CNF was due to a "declare name/obect" */
				   /* only and may be deleted when the declaring process */
				   /* breaks the channel over which the object was declared */
#define NFB$C_OBI_ALO	0x03000003 /* alias outgoing enabled/disabled */
#define NFB$C_OBI_ALI	0x03000004 /* alias incoming enabled/disabled */
	/* longword */
#define NFB$C_OBI_LPR	0x03010010 /* low order privileges */
#define NFB$C_OBI_HPR	0x03010011 /* high order privileges */
#define NFB$C_OBI_DOV	0x03010012 /* point to owners UCB */
#define NFB$C_OBI_CHN	0x03010013 /* owner's channel */
#define NFB$C_OBI_NUM	0x03010014 /* number */
#define NFB$C_OBI_PID	0x03010015 /* process ID */
#define NFB$C_OBI_PRX	0x03010016 /* proxy login switch (inbound, outbound, etc) */
	/* string */
#define NFB$C_OBI_COL	0x03020040 /* collating field */
#define NFB$C_OBI_ZNA	0x03020041 /* zero obj+name identifier */
#define NFB$C_OBI_SFI	0x03020042 /* parsed file ID */
#define NFB$C_OBI_IAC	0x03020043 /* default inbound combined access control string */
#define NFB$C_OBI_NAM	0x03020044 /* name */
#define NFB$C_OBI_FID	0x03020045 /* file ID */
#define NFB$C_OBI_USR	0x03020046 /* user ID */
#define NFB$C_OBI_ACC	0x03020047 /* account */
#define NFB$C_OBI_PSW	0x03020048 /* password */
#define NFB$C_OBI_OCPRV 0x03020049 /* outgoing connect privileges */

/* define a field identifier index for each parameter in the CRI database */
/*	C = common, E = Executor (used by transport), */
/*	X = Native X.25 network management, D = DECnet (not X.25) */
	/* boolean */
#define NFB$C_CRI_LCK	0x04000001 /* D set if conditionally writable fields are not writable */
#define NFB$C_CRI_SER	0x04000002 /* D set if Service functions not allowed */
#define NFB$C_CRI_BLK_FILL 0x04000003 /* filler (BLK retired) */
#define NFB$C_CRI_VER_FILL 0x04000004 /* filler (VER retired) */
#define NFB$C_CRI_DLM	0x04000005 /* E circuit to be used as X.25 datalink, if set; */
				   /* if clear, circuit is for X.25 native use */
	/* longword */
#define NFB$C_CRI_OWPID 0x04010010 /* D PID of temp owner of line in service state */
#define NFB$C_CRI_CTA	0x04010011 /* D absolute due time for counter logging */
#define NFB$C_CRI_SRV	0x04010012 /* D service substate qualifier */
#define NFB$C_CRI_STA	0x04010013 /* C state */
#define NFB$C_CRI_SUB	0x04010014 /* C substate */
#define NFB$C_CRI_LCT	0x04010015 /* C counter timer */
#define NFB$C_CRI_PNA	0x04010016 /* E adjacent node address */
#define NFB$C_CRI_BLO	0x04010017 /* E partner's receive block size */
#define NFB$C_CRI_COS	0x04010018 /* E cost */
#define NFB$C_CRI_HET	0x04010019 /* E hello timer */
#define NFB$C_CRI_LIT	0x0401001A /* E listen timer */
#define NFB$C_CRI_MRC	0x0401001B /* E maximum recalls */
#define NFB$C_CRI_RCT	0x0401001C /* E recall timer */
#define NFB$C_CRI_POL	0x0401001D /* D polling state */
#define NFB$C_CRI_PLS	0x0401001E /* D polling substate */
#define NFB$C_CRI_USE	0x0401001F /* X usage */
#define NFB$C_CRI_TYP	0x04010020 /* C type */
#define NFB$C_CRI_CHN	0x04010021 /* X X.25 Channel */
#define NFB$C_CRI_MBL	0x04010022 /* X maximum block */
#define NFB$C_CRI_MWI	0x04010023 /* X maximum window */
#define NFB$C_CRI_TRI	0x04010024 /* D tributary */
#define NFB$C_CRI_BBT	0x04010025 /* D babble timer */
#define NFB$C_CRI_TRT	0x04010026 /* D transmit timer */
#define NFB$C_CRI_MRB	0x04010027 /* D maximum receive buffers */
#define NFB$C_CRI_MTR	0x04010028 /* D maximum transmits */
#define NFB$C_CRI_ACB	0x04010029 /* D active base */
#define NFB$C_CRI_ACI	0x0401002A /* D active increment */
#define NFB$C_CRI_IAB	0x0401002B /* D inactive base */
#define NFB$C_CRI_IAI	0x0401002C /* D inactive increment */
#define NFB$C_CRI_IAT	0x0401002D /* D inactive threshold */
#define NFB$C_CRI_DYB	0x0401002E /* D dying base */
#define NFB$C_CRI_DYI	0x0401002F /* D dying increment */
#define NFB$C_CRI_DYT	0x04010030 /* D dying threshold */
#define NFB$C_CRI_DTH	0x04010031 /* D dead threshold */
#define NFB$C_CRI_MST	0x04010032 /* D maintenance mode state (0 => On, 1 => Off> */
#define NFB$C_CRI_XPT	0x04010033 /* E transport protocol to use */
#define NFB$C_CRI_MRT	0x04010034 /* E maximum routers on this NI */
#define NFB$C_CRI_RPR	0x04010035 /* E router priority */
#define NFB$C_CRI_DRT	0x04010036 /* E designated router on NI (node address) */
#define NFB$C_CRI_VER	0x04010037 /* D verification Enabled/Disabled/Inbound on circuit */
	/* string */
#define NFB$C_CRI_COL	0x04020040 /* D collating field */
#define NFB$C_CRI_NAM	0x04020041 /* C circuit name */
#define NFB$C_CRI_VMSNAM 0x04020042 /* D device name in VMS format */
#define NFB$C_CRI_CHR	0x04020043 /* D characteristics buffer for startup control QIO */
#define NFB$C_CRI_CNT	0x04020044 /* C counters */
#define NFB$C_CRI_P2P	0x04020045 /* D line's PhaseII partner name (for loopback) */
#define NFB$C_CRI_LOO	0x04020046 /* E loopback name */
#define NFB$C_CRI_PNN	0x04020047 /* E adjacent node name */
#define NFB$C_CRI_NUM	0x04020048 /* X call number */
#define NFB$C_CRI_DTE	0x04020049 /* X DTE */
#define NFB$C_CRI_DEVNAM 0x0402004A /* D device name in VMS format, with unit included */
#define NFB$C_CRI_NET	0x0402004B /* XD network name */

/* define a field identifier index for each parameter in the PLI database */
/*	C = common, L = LAPB (X.25), D = DDCMP (not X.25), E = Ethernet   */
	/* boolean */
#define NFB$C_PLI_LCK	0x05000001 /* D set if conditionally writable fields are not writable */
#define NFB$C_PLI_SER	0x05000002 /* D service */
#define NFB$C_PLI_DUP	0x05000003 /* C duplex (set if half) */
#define NFB$C_PLI_CON	0x05000004 /* C controller (set if loopback) */
#define NFB$C_PLI_CLO	0x05000005 /* C clock mode (set if internal) */
#define NFB$C_PLI_SWI	0x05000006 /* D async line - Switch */
#define NFB$C_PLI_HNG	0x05000007 /* D async line - Hangup */
	/* longword */
#define NFB$C_PLI_CTA	0x05010010 /* D absolute time for counter read and clear */
#define NFB$C_PLI_STA	0x05010011 /* C state */
#define NFB$C_PLI_SUB	0x05010012 /* C substate */
#define NFB$C_PLI_LCT	0x05010013 /* D counter timer */
#define NFB$C_PLI_PRO	0x05010014 /* C protocol */
#define NFB$C_PLI_STI	0x05010015 /* D service timer */
#define NFB$C_PLI_HTI	0x05010016 /* L holdback timer */
#define NFB$C_PLI_MBL	0x05010017 /* L maximum block */
#define NFB$C_PLI_MRT	0x05010018 /* L maximum retransmits */
#define NFB$C_PLI_MWI	0x05010019 /* L maximum window */
#define NFB$C_PLI_SLT	0x0501001A /* D scheduling timer */
#define NFB$C_PLI_DDT	0x0501001B /* D dead timer */
#define NFB$C_PLI_DLT	0x0501001C /* D delay timer */
#define NFB$C_PLI_SRT	0x0501001D /* D stream timer */
#define NFB$C_PLI_BFN	0x0501001E /* D receive buffers */
#define NFB$C_PLI_BUS	0x0501001F /* D action routine returns bufsiz used for line */
#define NFB$C_PLI_PLVEC 0x05010020 /* D PLVEC ID */
#define NFB$C_PLI_RTT	0x05010021 /* D retransmit timer */
#define NFB$C_PLI_MOD	0x05010022 /* L X.25 mode (DCE, DTE, etc) */
#define NFB$C_PLI_LPC	0x05010023 /* L loop count */
#define NFB$C_PLI_LPL	0x05010024 /* L loop length */
#define NFB$C_PLI_LPD	0x05010025 /* L loop data type */
#define NFB$C_PLI_EPT	0x05010026 /* E ethernet protocol type for datalink */
#define NFB$C_PLI_LNS	0x05010027 /* D async line - line speed */
#define NFB$C_PLI_BFS	0x05010028 /* C line buffer size (overrides executor bufsiz) */
#define NFB$C_PLI_TPI	0x05010029 /* D transmit Pipeline */
	/* string */
#define NFB$C_PLI_COL	0x05020040 /* D collating field */
#define NFB$C_PLI_NAM	0x05020041 /* C line name */
#define NFB$C_PLI_VMSNAM 0x05020042 /* D device name in VMS format */
#define NFB$C_PLI_CHR	0x05020043 /* D set-mode $QIO line characteristics buffer */
#define NFB$C_PLI_CNT	0x05020044 /* C counters */
#define NFB$C_PLI_MCD	0x05020045 /* L filespec for microcode dump (initiates dump) */
#define NFB$C_PLI_HWA	0x05020046 /* D NI hardware address (ROM address) */
#define NFB$C_PLI_DEVNAM 0x05020047 /* D device name in VMS format, with unit included */
#define NFB$C_PLI_NET	0x05020048 /* L network name */

/* define a field identifier index for each parameter in the EFI database */
	/* boolean */
#define NFB$C_EFI_LCK	0x06000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_EFI_SIN	0x06010010
#define NFB$C_EFI_SP1	0x06010011
#define NFB$C_EFI_B1	0x06010012
#define NFB$C_EFI_B2	0x06010013
	/* string */
#define NFB$C_EFI_COL	0x06020040 /* collating field */
#define NFB$C_EFI_EVE	0x06020041
#define NFB$C_EFI_SB1	0x06020042
#define NFB$C_EFI_SB2	0x06020043
#define NFB$C_EFI_SB3	0x06020044

/* define a field identifier index for each parameter in the ESI database */
	/* boolean */
#define NFB$C_ESI_LCK	0x07000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_ESI_SNK	0x07010010
#define NFB$C_ESI_STA	0x07010011
#define NFB$C_ESI_SP1	0x07010012
#define NFB$C_ESI_B1	0x07010013
#define NFB$C_ESI_B2	0x07010014
	/* string */
#define NFB$C_ESI_COL	0x07020040 /* collating field */
#define NFB$C_ESI_LNA	0x07020041
#define NFB$C_ESI_SB1	0x07020042
#define NFB$C_ESI_SB2	0x07020043
#define NFB$C_ESI_SB3	0x07020044

/* define a field identifier index for each parameter in the LLI database */
	/* boolean */
#define NFB$C_LLI_LCK	0x08000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_LLI_DLY	0x08010010 /* round trip delay time */
#define NFB$C_LLI_STA	0x08010011 /* state */
#define NFB$C_LLI_LLN	0x08010012 /* local link number */
#define NFB$C_LLI_RLN	0x08010013 /* remote link number */
#define NFB$C_LLI_PNA	0x08010014 /* partner's node address */
#define NFB$C_LLI_PID	0x08010015 /* external process ID */
#define NFB$C_LLI_IPID	0x08010016 /* internal process ID */
#define NFB$C_LLI_XWB	0x08010017 /* pointer to XWB */
#define NFB$C_LLI_CNT	0x08010018 /* counters */
	/* string */
#define NFB$C_LLI_COL	0x08020040 /* collating field */
#define NFB$C_LLI_USR	0x08020041 /* user name */
#define NFB$C_LLI_PRC	0x08020042 /* process name */
#define NFB$C_LLI_PNN	0x08020043 /* partner's node name */
#define NFB$C_LLI_RID	0x08020044 /* partner's process ID */

/* X.25 network parameters (part of MODULE X25-PROTOCOL) */
	/* boolean */
#define NFB$C_XNI_LCK	0x09000001 /* set if conditionally writable fields are not writable */
#define NFB$C_XNI_MNS_FILL 0x09000002 /* X.25 multi-network support (set if enabled) [no longer used] */
	/* longword */
#define NFB$C_XNI_CAT	0x09010010 /* call timer */
#define NFB$C_XNI_CLT	0x09010011 /* clear timer */
#define NFB$C_XNI_DBL	0x09010012 /* default data */
#define NFB$C_XNI_DWI	0x09010013 /* default window */
#define NFB$C_XNI_MBL	0x09010014 /* maximum data */
#define NFB$C_XNI_MCL	0x09010015 /* maximum clears */
#define NFB$C_XNI_MRS	0x09010016 /* maximum resets */
#define NFB$C_XNI_MST	0x09010017 /* maximum restarts */
#define NFB$C_XNI_MWI	0x09010018 /* maximum window */
#define NFB$C_XNI_RST	0x09010019 /* reset timer */
#define NFB$C_XNI_STT	0x0901001A /* restart timer */
	/* string */
#define NFB$C_XNI_COL	0x09020040 /* collating field */
#define NFB$C_XNI_NETENT 0x09020041 /* network */
#define NFB$C_XNI_PROF	0x09020042 /* profile name */

/* X.25 DTE parameters (qualified by a given network) */
	/* boolean */
#define NFB$C_XDI_LCK	0x0B000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XDI_ACH	0x0B010010 /* active channels */
#define NFB$C_XDI_ASW	0x0B010011 /* active switched */
#define NFB$C_XDI_CTM	0x0B010012 /* counter timer */
#define NFB$C_XDI_MCH	0x0B010013 /* maximum channels */
#define NFB$C_XDI_STA	0x0B010014 /* state */
#define NFB$C_XDI_SUB	0x0B010015 /* substate */
#define NFB$C_XDI_MCI	0x0B010016 /* maximum circuits [VMS only] */
#define NFB$C_XDI_CAT	0x0B010017 /* call timer */
#define NFB$C_XDI_CLT	0x0B010018 /* clear timer */
#define NFB$C_XDI_DBL	0x0B010019 /* default data */
#define NFB$C_XDI_DWI	0x0B01001A /* default window */
#define NFB$C_XDI_MBL	0x0B01001B /* maximum data */
#define NFB$C_XDI_MCL	0x0B01001C /* maximum clears */
#define NFB$C_XDI_MRS	0x0B01001D /* maximum resets */
#define NFB$C_XDI_MST	0x0B01001E /* maximum restarts */
#define NFB$C_XDI_MWI	0x0B01001F /* maximum window */
#define NFB$C_XDI_RST	0x0B010020 /* reset timer */
#define NFB$C_XDI_STT	0x0B010021 /* restart timer */
#define NFB$C_XDI_MODE	0x0B010022 /* DTE Mode */
#define NFB$C_XDI_ITT	0x0B010023 /* interrupt timer */
	/* string */
#define NFB$C_XDI_COL	0x0B020040 /* collating field */
#define NFB$C_XDI_DTE	0x0B020041 /* DTE address */
#define NFB$C_XDI_CHN	0x0B020042 /* channels */
#define NFB$C_XDI_LIN	0x0B020043 /* line */
#define NFB$C_XDI_DNT	0x0B020044 /* network */
#define NFB$C_XDI_CNT	0x0B020045 /* counters */

/* X.25 group parameters (qualified by a given DTE) */
	/* boolean */
#define NFB$C_XGI_LCK	0x0A000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XGI_GNM	0x0A010010 /* group number */
#define NFB$C_XGI_GTY	0x0A010011 /* group type */
	/* string */
#define NFB$C_XGI_COL	0x0A020040 /* collating field; this field must be unique across all entries in this database; */
				   /* it consists of the group-name string followed by the DTE address */
#define NFB$C_XGI_GRP	0x0A020041 /* group name */
#define NFB$C_XGI_GDT	0x0A020042 /* group DTE address */
#define NFB$C_XGI_GNT	0x0A020043 /* group network */

/* X.25 server parameters (global parameters for all destinations) */
	/* boolean */
#define NFB$C_XS5_LCK	0x0C000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XS5_MCI	0x0C010010 /* maximum circuits allowed */
#define NFB$C_XS5_STA	0x0C010011 /* state */
#define NFB$C_XS5_ACI	0x0C010012 /* active circuits */
#define NFB$C_XS5_CTM	0x0C010013 /* counter timer */
	/* string */
#define NFB$C_XS5_COL	0x0C020040 /* collating field; this field must be unique across all entries in this database */
#define NFB$C_XS5_CNT	0x0C020041 /* counters */

/* X.25 destination parameters (part of MODULE X25-SERVER) */
	/* boolean */
#define NFB$C_XD5_LCK	0x0D000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XD5_PRI	0x0D010010 /* priority */
#define NFB$C_XD5_SAD	0x0D010011 /* subaddress range (lower word = lower limit, upper word = upper limit) */
#define NFB$C_XD5_NOD	0x0D010012 /* remote node address containing server (gateways only) */
#define NFB$C_XD5_RED	0x0D010013 /* redirect reason */
	/* string */
#define NFB$C_XD5_COL	0x0D020040 /* collating field; this field must be unique across all entries in this database */
#define NFB$C_XD5_DST	0x0D020041 /* destination DTE address */
#define NFB$C_XD5_CMK	0x0D020042 /* call mask */
#define NFB$C_XD5_CVL	0x0D020043 /* call value */
#define NFB$C_XD5_GRP	0x0D020044 /* group name */
#define NFB$C_XD5_SDTE	0x0D020045 /* sending DTE address (formally number) */
#define NFB$C_XD5_OBJ	0x0D020046 /* && object name */
#define NFB$C_XD5_FIL	0x0D020047 /* command procedure to execute when starting object */
#define NFB$C_XD5_USR	0x0D020048 /* user name */
#define NFB$C_XD5_PSW	0x0D020049 /* password */
#define NFB$C_XD5_ACC	0x0D02004A /* account */
#define NFB$C_XD5_CDTE	0x0D02004B /* called DTE */
#define NFB$C_XD5_RDTE	0x0D02004C /* receiving DTE */
#define NFB$C_XD5_NET	0x0D02004D /* network */
#define NFB$C_XD5_EMK	0x0D02004E /* extension mask */
#define NFB$C_XD5_EVL	0x0D02004F /* extension value */
#define NFB$C_XD5_ACL	0x0D020050 /* ACL, a list of ACE'structure, parto of ORB */
#define NFB$C_XD5_IDTE	0x0D020051 /* incoming address */

/* X.29 server parameters (global parameters for all destinations) */
	/* boolean */
#define NFB$C_XS9_LCK	0x0E000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XS9_MCI	0x0E010010 /* maximum circuits allowed */
#define NFB$C_XS9_STA	0x0E010011 /* state */
#define NFB$C_XS9_ACI	0x0E010012 /* active circuits */
#define NFB$C_XS9_CTM	0x0E010013 /* counter timer */
	/* string */
#define NFB$C_XS9_COL	0x0E020040 /* collating field; this field must be unique across all entries in this database */
#define NFB$C_XS9_CNT	0x0E020041 /* counters */

/* X.29 destination parameters (part of MODULE X29-SERVER) */
	/* boolean */
#define NFB$C_XD9_LCK	0x0F000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XD9_PRI	0x0F010010 /* priority */
#define NFB$C_XD9_SAD	0x0F010011 /* subaddress range (lower word = lower limit, upper word = upper limit) */
#define NFB$C_XD9_NOD	0x0F010012 /* remote node address containing server (gateways only) */
#define NFB$C_XD9_RED	0x0F010013 /* redirect reason */
	/* string */
#define NFB$C_XD9_COL	0x0F020040 /* collating field; this field must be unique across all entries in this database */
#define NFB$C_XD9_DST	0x0F020041 /* destination DTE address */
#define NFB$C_XD9_CMK	0x0F020042 /* call mask */
#define NFB$C_XD9_CVL	0x0F020043 /* call value */
#define NFB$C_XD9_GRP	0x0F020044 /* group name */
#define NFB$C_XD9_SDTE	0x0F020045 /* sending DTE */
#define NFB$C_XD9_OBJ	0x0F020046 /* && object name */
#define NFB$C_XD9_FIL	0x0F020047 /* command procedure to execute when starting object */
#define NFB$C_XD9_USR	0x0F020048 /* user name */
#define NFB$C_XD9_PSW	0x0F020049 /* password */
#define NFB$C_XD9_ACC	0x0F02004A /* account */
#define NFB$C_XD9_CDTE	0x0F02004B /* caller DTE */
#define NFB$C_XD9_RDTE	0x0F02004C /* receiving DTE */
#define NFB$C_XD9_NET	0x0F02004D /* network */
#define NFB$C_XD9_EMK	0x0F02004E /* extension mask */
#define NFB$C_XD9_EVL	0x0F02004F /* extension value */
#define NFB$C_XD9_ACL	0x0F020050 /* ACL, a list of ACE'structure, parto of ORB */
#define NFB$C_XD9_IDTE	0x0F020051 /* incoming address */

/* X.25 tracing facility (global) parameters */
	/* boolean */
#define NFB$C_XTI_LCK	0x10000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XTI_STA	0x10010010 /* state */
#define NFB$C_XTI_BFZ	0x10010011 /* buffer size */
#define NFB$C_XTI_CPL	0x10010012 /* capture limit */
#define NFB$C_XTI_MBK	0x10010013 /* maximum blocks/file */
#define NFB$C_XTI_MBF	0x10010014 /* maximum number of buffers */
#define NFB$C_XTI_MVR	0x10010015 /* maximum trace file version number */
	/* string */
#define NFB$C_XTI_COL	0x10020040 /* collating field; this field must be unique across all entries in this database */
#define NFB$C_XTI_FNM	0x10020041 /* trace file name */

/* X.25 tracpoint (local) parameters */
	/* boolean */
#define NFB$C_XTT_LCK	0x11000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XTT_TST	0x11010010 /* state */
#define NFB$C_XTT_CPS	0x11010011 /* capture size */
	/* string */
#define NFB$C_XTT_COL	0x11020040 /* collating field; this field must be unique across all entries in this database */
#define NFB$C_XTT_TPT	0x11020041 /* tracepoint name */

/* X.25 Access (qualified by a given network) */
	/* boolean */
#define NFB$C_XAI_LCK	0x1B000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_XAI_NDA	0x1B010010 /* node address */
	/* string */
#define NFB$C_XAI_COL	0x1B020040 /* collating field */
#define NFB$C_XAI_NET	0x1B020041 /* network */
#define NFB$C_XAI_USR	0x1B020042 /* user ID */
#define NFB$C_XAI_PSW	0x1B020043 /* password */
#define NFB$C_XAI_ACC	0x1B020044 /* account */
#define NFB$C_XAI_NOD	0x1B020045 /* node ID */

/* X.25 Security (qualified by a given network) */
	/* boolean */
#define NFB$C_XDTE_LCK	0x15000001 /* set if conditionally writable fields are not writable */
	/* string */
#define NFB$C_XDTE_COL	0x15020040 /* collating field */
#define NFB$C_XDTE_NET	0x15020041 /* network */
#define NFB$C_XDTE_DTE	0x15020042 /* DTE address */
#define NFB$C_XDTE_ID	0x15020043 /* ID list, ARB rights list */
#define NFB$C_XDTE_ACL	0x15020044 /* ACL, a list of ACE's, part of ORB */

/* define SPI (Server Process) parameters */
	/* boolean */
#define NFB$C_SPI_LCK	0x12000001 /* set if conditionally writable fields are not writable */
#define NFB$C_SPI_PRL	0x12000002 /* proxy flag which initially started server process */
	/* longword */
#define NFB$C_SPI_PID	0x12010010 /* server PID */
#define NFB$C_SPI_IRP	0x12010011 /* IRP of waiting DECLSERV QIO (0 if process active) */
#define NFB$C_SPI_CHN	0x12010012 /* channel associated with DECLSERV IRP */
#define NFB$C_SPI_RNA	0x12010013 /* remote node address which initially started server */
	/* string */
#define NFB$C_SPI_COL	0x12020040 /* collating field */
#define NFB$C_SPI_ACS	0x12020041 /* ACS used to initally start server process */
#define NFB$C_SPI_RID	0x12020042 /* remote user ID which initially started server */
#define NFB$C_SPI_SFI	0x12020043 /* last (current) SFI given to server process */
#define NFB$C_SPI_NCB	0x12020044 /* last (current) NCB given to server process */
#define NFB$C_SPI_PNM	0x12020045 /* last (current) process name given to server */

/* define AJI (Adjacency) parameters */
	/* boolean */
#define NFB$C_AJI_LCK	0x13000001 /* set if conditionally writable fields are not writable */
#define NFB$C_AJI_REA	0x13000002 /* reachable (set if two-way communication established) */
#define NFB$C_AJI_RRA	0x13000003 /* reachable routing adjacency */
	/* longword */
#define NFB$C_AJI_ADD	0x13010010 /* node address */
#define NFB$C_AJI_TYP	0x13010011 /* node type */
#define NFB$C_AJI_LIT	0x13010012 /* listen timer for this adjacency */
#define NFB$C_AJI_BLO	0x13010013 /* partner's block size */
#define NFB$C_AJI_RPR	0x13010014 /* partner's router priority (on NI) */
	/* string */
#define NFB$C_AJI_COL	0x13020040 /* collating field */
#define NFB$C_AJI_NNA	0x13020041 /* node name */
#define NFB$C_AJI_CIR	0x13020042 /* circuit name */

/* define SDI (Service DLE) parameters */
	/* boolean */
#define NFB$C_SDI_LCK	0x1A000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_SDI_SUB	0x1A010010 /* service substate */
#define NFB$C_SDI_PID	0x1A010011 /* PID of process owning this DLE link */
	/* string */
#define NFB$C_SDI_COL	0x1A020040 /* collating field */
#define NFB$C_SDI_CIR	0x1A020041 /* circuit name */
#define NFB$C_SDI_PHA	0x1A020042 /* service physical address (BC only) */
#define NFB$C_SDI_PRC	0x1A020043 /* name of process owning this DLE link */

/* define the AREA database (read only) for level 2 Phase IV routers only */
	/* boolean */
#define NFB$C_ARI_LCK	0x14000001 /* set if conditionally writable fields are not writable */
#define NFB$C_ARI_REA	0x14000002 /* set if node is reachable */
	/* longword */
#define NFB$C_ARI_ADD	0x14010010 /* address */
#define NFB$C_ARI_DCO	0x14010011 /* destination cost */
#define NFB$C_ARI_DHO	0x14010012 /* destination hops */
#define NFB$C_ARI_NND	0x14010013 /* next node address */
	/* string */
#define NFB$C_ARI_COL	0x14020040 /* collating field */
#define NFB$C_ARI_DLI	0x14020041 /* circuit used for normal traffic to area */

/* define the PROXY database */
	/* boolean */
#define NFB$C_PROXY_LCK		0x1C000001 /* set if conditionally writable fields are not writable */
	/* longword */
#define NFB$C_PROXY_RUIC	0x1C010010 /* remote UIC */
	/* string */
#define NFB$C_PROXY_RNODE	0x1C020040 /* remote node */
#define NFB$C_PROXY_RNAME	0x1C020041 /* remote user name */
#define NFB$C_PROXY_DEFACCOUNT	0x1C020042 /* default local proxy account */
#define NFB$C_PROXY_ACCOUNT1	0x1C020043 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT2	0x1C020044 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT3	0x1C020045 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT4	0x1C020046 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT5	0x1C020047 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT6	0x1C020048 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT7	0x1C020049 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT8	0x1C02004A /* local proxy account */
#define NFB$C_PROXY_ACCOUNT9	0x1C02004B /* local proxy account */
#define NFB$C_PROXY_ACCOUNT10	0x1C02004C /* local proxy account */
#define NFB$C_PROXY_ACCOUNT11	0x1C02004D /* local proxy account */
#define NFB$C_PROXY_ACCOUNT12	0x1C02004E /* local proxy account */
#define NFB$C_PROXY_ACCOUNT13	0x1C02004F /* local proxy account */
#define NFB$C_PROXY_ACCOUNT14	0x1C020050 /* local proxy account */
#define NFB$C_PROXY_ACCOUNT15	0x1C020051 /* local proxy account */
#define NFB$C_PROXY_HASHKEY	0x1C020052 /* hash key lookup string */
#define NFB$C_PROXY_COL		0x1C020040 /* collating field */
#define NFB$C_PROXY_MAXACC	15 /* maximum numver of local proxy accounts including the default */

#endif	/*_NFBDEF_H*/
