/* <oprdef.h>
 *
 *	Operator communications message types and values
 */
#ifndef _OPRDEF_H
#define _OPRDEF_H

/* operator message types */
#define OPR$_TERMENABL	1	/* enable terminal */
#define OPR$_LOGINIT	2	/* initialize the log */
#define OPR$_OPRQST	3	/* operator request */
#define OPR$_OPREPLY	4	/* operator reply */

#define OPR$V_CENTRAL	0
#define OPR$V_PRINTER	1
#define OPR$V_TAPES	2
#define OPR$V_DISKS	3
#define OPR$V_DEVICES	4
#define OPR$M_CENTRAL	(1<<OPR$V_CENTRAL)	/* 0x01 */
#define OPR$M_PRINTER	(1<<OPR$V_PRINTER)	/* 0x02 */
#define OPR$M_TAPES	(1<<OPR$V_TAPES)	/* 0x04 */
#define OPR$M_DISKS	(1<<OPR$V_DISKS)	/* 0x08 */
#define OPR$M_DEVICES	(1<<OPR$V_DEVICES)	/* 0x10 */
#define OPR$V_USER1	5
#define OPR$M_USER1	0x0001FFE0
#define OPR$S_USER1	12
#define OPR$V_USER2	17
#define OPR$V_USER3	18
#define OPR$V_USER4	19
#define OPR$V_USER5	20
#define OPR$V_USER6	21
#define OPR$V_USER7	22
#define OPR$V_USER8	23
#define OPR$V_USER9	24
#define OPR$V_USER10	25
#define OPR$V_USER11	26
#define OPR$V_USER12	27
#define OPR$M_USER2	(1<<OPR$V_USER2)	/* 0x020000 */
#define OPR$M_USER3	(1<<OPR$V_USER3)	/* 0x040000 */
#define OPR$M_USER4	(1<<OPR$V_USER4)	/* 0x080000 */
#define OPR$M_USER5	(1<<OPR$V_USER5)	/* 0x100000 */
#define OPR$M_USER6	(1<<OPR$V_USER6)	/* 0x200000 */
#define OPR$M_USER7	(1<<OPR$V_USER7)	/* 0x400000 */
#define OPR$M_USER8	(1<<OPR$V_USER8)	/* 0x800000 */
#define OPR$M_USER9	(1<<OPR$V_USER9)	/* 0x01000000 */
#define OPR$M_USER10	(1<<OPR$V_USER10)	/* 0x02000000 */
#define OPR$M_USER11	(1<<OPR$V_USER11)	/* 0x04000000 */
#define OPR$M_USER12	(1<<OPR$V_USER12)	/* 0x08000000 */
union oprdef {
    struct {
	unsigned opr$v_central	: 1;
	unsigned opr$v_printer	: 1;
	unsigned opr$v_tapes	: 1;
	unsigned opr$v_disks	: 1;
	unsigned opr$v_devices	: 1;
	unsigned opr$v_user1	: 12;
	unsigned opr$v_user2	: 1;
	unsigned opr$v_user3	: 1;
	unsigned opr$v_user4	: 1;
	unsigned opr$v_user5	: 1;
	unsigned opr$v_user6	: 1;
	unsigned opr$v_user7	: 1;
	unsigned opr$v_user8	: 1;
	unsigned opr$v_user9	: 1;
	unsigned opr$v_user10	: 1;
	unsigned opr$v_user11	: 1;
	unsigned opr$v_user12	: 1;
	unsigned		: 4;
    } opr$r_oprdef_bits;
};

#endif	/*_OPRDEF_H*/
