/* <psldef.h>
 *
 *	Processor Status Longword mask and field definitions
 */
#ifndef _PSLDEF_H
#define _PSLDEF_H

/* this first portion corresponds to $PSWDEF */
#define PSL$V_C		0
#define PSL$V_V		1
#define PSL$V_Z		2
#define PSL$V_N		3
#define PSL$V_TBIT	4
#define PSL$V_IV	5
#define PSL$V_FU	6
#define PSL$V_DV	7
#define PSL$M_C		(1<<PSL$V_C )	/* 0x01 */
#define PSL$M_V		(1<<PSL$V_V )	/* 0x02 */
#define PSL$M_Z		(1<<PSL$V_Z )	/* 0x04 */
#define PSL$M_N		(1<<PSL$V_N )	/* 0x08 */
#define PSL$M_TBIT	(1<<PSL$V_TBIT) /* 0x10 */
#define PSL$M_IV	(1<<PSL$V_IV)	/* 0x20 */
#define PSL$M_FU	(1<<PSL$V_FU)	/* 0x40 */
#define PSL$M_DV	(1<<PSL$V_DV)	/* 0x80 */

#define PSL$V_IPL	16
#define PSL$M_IPL	0x001F0000
#define PSL$S_IPL	5
#define PSL$V_PRVMOD	22
#define PSL$M_PRVMOD	0x00C00000
#define PSL$S_PRVMOD	2
#define PSL$V_CURMOD	24
#define PSL$M_CURMOD	0x03000000
#define PSL$S_CURMOD	2
#define PSL$V_IS	26
#define PSL$M_IS	0x04000000
#define PSL$S_IS	1
#define PSL$V_FPD	27
#define PSL$M_FPD	0x08000000
#define PSL$S_FPD	1
#define PSL$V_TP	30
#define PSL$M_TP	0x40000000
#define PSL$S_TP	1
#define PSL$V_CM	31
#define PSL$M_CM	0x80000000
#define PSL$S_CM	1

#define PSL$M_SAFBITS	0x000037FF

/* mode symbol definitions */
#define PSL$C_KERNEL	0	/* kernel mode */
#define PSL$C_EXEC	1	/* exec mode */
#define PSL$C_SUPER	2	/* supervisor mode */
#define PSL$C_USER	3	/* user mode */

union psldef {
    unsigned long psl$l_psl;		/* complete longword */
    struct {
	unsigned psl$v_c	: 1;	/* Carry */
	unsigned psl$v_v	: 1;	/* oVerflow */
	unsigned psl$v_z	: 1;	/* Zero */
	unsigned psl$v_n	: 1;	/* Negative */
	unsigned psl$v_tbit	: 1;	/* TBIT enable */
	unsigned psl$v_iv	: 1;	/* integer overflow */
	unsigned psl$v_fu	: 1;	/* floating undefined */
	unsigned psl$v_dv	: 1;	/* divide by zero */
	unsigned		: 8;
	unsigned psl$v_ipl	: 5;	/* interrupt priority level */
	unsigned		: 1;
	unsigned psl$v_prvmod	: 2;	/* previous processor mode */
	unsigned psl$v_curmod	: 2;	/* current processor mode */
	unsigned psl$v_is	: 1;	/* interrupt stack bit */
	unsigned psl$v_fpd	: 1;	/* first part done */
	unsigned		: 2;	/* Must Be Zero */
	unsigned psl$v_tp	: 1;	/* trace trap pending */
	unsigned psl$v_cm	: 1;	/* compatibility mode bit and mask */
    } psl$r_psldef_bits;
};

#endif	/*_PSLDEF_H*/
