/* <vms/lib/pwdhisdef.h>
 *
 *	Password History definitions			[not in Starlet]
 */
#ifndef _PWDHISDEF_H
#define _PWDHISDEF_H

/*
   Password History Record - This structure defines the layout of the
   system password history file.  This is a variable record length
   indexed file (keyed by username) where each record contains the
   last "n" quadword hash values for the user's last "n" passwords.
 */

#define PWDHIS$C_ENTRY_LENGTH	16	/* size of one entry */
#define PWDHIS$K_ENTRY_LENGTH	16
#define PWDHIS$S_PWDENTDEF	16
#define PWDHIS$S_ENTRY	8
#define PWDHIS$S_CHANGE 8
struct pwdhis_entry_def {
    long pwdhis$q_entry[2];		/* the quadword hash */
    long pwdhis$q_change[2];		/* password change date */
};

#define PWDHIS$C_FIXED		32	/* fixed part of record */
#define PWDHIS$K_FIXED		32
#define PWDHIS$C_DEFAULT_LIFETIME 365	/* default history lifetime (days) */
#define PWDHIS$K_DEFAULT_LIFETIME 365
#define PWDHIS$C_DEFAULT_LIMIT	60	/* default # of history entries per user */
#define PWDHIS$K_DEFAULT_LIMIT	60
#define PWDHIS$C_MAXIMUM_LIMIT	2000	/* maximum # of history entries per user */
#define PWDHIS$K_MAXIMUM_LIMIT	2000
#define PWDHIS$S_PWDHISDEF	36	/* (useless) */
#define PWDHIS$S_HISTORY	4	/* (ditto) offset to start of list */
#define PWDHIS$S_USERNAME	32
struct pwdhis_record_def {
    char pwdhis$t_username[32];			/* username (key0) */
    struct pwdhis_entry_def pwdhis$r_entry[1];	/* [1..2000] */
};

#endif	/*_PWDHISDEF_H*/
