/* <quidef.h>
 *
 *	Get Queue Information Service ($GETQUI) definitions.
 */
#ifndef _QUIDEF_H
#define _QUIDEF_H

/* Function codes */
#define QUI$_CANCEL_OPERATION	1	/* cancel a wildcard operation */
#define QUI$_DISPLAY_CHARACTERISTIC 2	/* return characteristic attributes */
#define QUI$_DISPLAY_FILE	3	/* return file attributes */
#define QUI$_DISPLAY_FORM	4	/* return form attributes */
#define QUI$_DISPLAY_JOB	5	/* return job attributes */
#define QUI$_DISPLAY_QUEUE	6	/* return queue attributes */
#define QUI$_TRANSLATE_QUEUE	7	/* validate and translate queue name */
#define QUI$_DISPLAY_ENTRY	8	/* return entry (job) attributes (without first having to establish queue context) */
#ifndef ONLY_VMS_V6
#define QUI$_RESERVED_FUNC_9	9	/* reserved for Digital use */
#define QUI$_RESERVED_FUNC_10	10	/* reserved for Digital use */
#endif
#ifndef NO_VMS_V6
#define QUI$_DISPLAY_QMAN	9	/* reserved for Digital (used by job control to get qman information) */
#define QUI$_DISPLAY_MANAGER	10	/* return queue manager attributes */
#endif
#define QUI$K_MIN_FUNC	1	/* minimum GETQUI function code */
#define QUI$K_MAX_FUNC	10	/* maximum GETQUI function code */

/* Item codes */
#define QUI$_ACCOUNT_NAME	1	/* job: submitter's account name */
#define QUI$_CHARGE_CODE	1	/* synonym for QUI$_ACCOUNT_NAME */
#define QUI$_AFTER_TIME		2	/* job: /AFTER=time */
#define QUI$_ASSIGNED_QUEUE_NAME 3	/* queue: ASSIGN/QUEUE target */
#define QUI$_BASE_PRIORITY	4	/* queue: /BASE_PRIORITY=n */
#define QUI$_CHARACTERISTIC_NAME 5	/* characteristic: name */
#define QUI$_CHARACTERISTIC_NUMBER 6	/* characteristic: number */
#define QUI$_CHARACTERISTICS	7	/* job, queue: /CHARACTERISTICS=(c,...) */
#define QUI$_CHECKPOINT_DATA	8	/* job: checkpoint data */
#define QUI$_CLI		9	/* job: /CLI=filename */
#define QUI$_COMPLETED_BLOCKS	10	/* job: completed blocks including checkpoint */
#define QUI$_CONDITION_VECTOR	11	/* job: completion status */
#define QUI$_CPU_DEFAULT	12	/* queue: /CPUDEFAULT=t */
#define QUI$_CPU_LIMIT		13	/* job, queue: /CPUMAXIMUM=t */
#define QUI$_DEVICE_NAME	14	/* queue: /ON=device */
#define QUI$_ENTRY_NUMBER	15	/* job: entry number */
#define QUI$_FILE_COPIES	16	/* file: /COPIES=n */
#define QUI$_FILE_COPIES_CHKPT	17	/* file: file copies checkpoint (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_FILE_COPIES_DONE	18	/* file: file copies completed */
#define QUI$_FILE_FLAGS		19	/* file: boolean information */
#define QUI$_FILE_SETUP_MODULES 20	/* file: /SETUP=(module,...) */
#define QUI$_FILE_SPECIFICATION 21	/* file: full file specification */
#define QUI$_FILE_STATUS	22	/* file: status information */
#define QUI$_FIRST_PAGE		23	/* file: /PAGES=(n,"") */
#define QUI$_FORM_DESCRIPTION	24	/* form: /DESCRIPTION=string */
#define QUI$_FORM_FLAGS		25	/* form: boolean information */
#define QUI$_FORM_LENGTH	26	/* form: /LENGTH=n */
#define QUI$_FORM_MARGIN_BOTTOM 27	/* form: /MARGIN=BOTTOM=n */
#define QUI$_FORM_MARGIN_LEFT	28	/* form: /MARGIN=LEFT=n */
#define QUI$_FORM_MARGIN_RIGHT	29	/* form: /MARGIN=RIGHT=n */
#define QUI$_FORM_MARGIN_TOP	30	/* form: /MARGIN=TOP=n */
#define QUI$_FORM_NAME		31	/* form, job, queue: Form name */
#define QUI$_FORM_NUMBER	32	/* form: number */
#define QUI$_FORM_SETUP_MODULES 33	/* form: /SETUP=(module,...) */
#define QUI$_FORM_STOCK		34	/* form: /STOCK=stock-name */
#define QUI$_FORM_WIDTH		35	/* form: /WIDTH=n */
#define QUI$_GENERIC_TARGET	36	/* queue: /GENERIC=(queue-name,...) */
#define QUI$_INTERVENING_BLOCKS 37	/* job: intervening pending blocks */
#define QUI$_INTERVENING_JOBS	38	/* job: intervening pending jobs */
#define QUI$_JOB_COPIES		39	/* job: /JOB_COUNT=n */
#define QUI$_JOB_COPIES_CHKPT	40	/* job: job copies checkpoint (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_JOB_COPIES_DONE	41	/* job: job copies completed */
#define QUI$_JOB_FLAGS		42	/* job: boolean information */
#define QUI$_JOB_LIMIT		43	/* queue: /JOB_LIMIT=n */
#define QUI$_JOB_NAME		44	/* job: name */
#define QUI$_JOB_RESET_MODULES	45	/* queue: /SEPARATE=RESET=(module,...) */
#define QUI$_JOB_SIZE		46	/* job: total blocks in job */
#define QUI$_JOB_SIZE_MAXIMUM	47	/* queue: /BLOCK_LIMIT=n */
#define QUI$_JOB_SIZE_MINIMUM	48	/* queue: /BLOCK_LIMIT=(n,"") */
#define QUI$_JOB_STATUS		49	/* job: status information */
#define QUI$_LAST_PAGE		50	/* file: /PAGES=n */
#define QUI$_LIBRARY_SPECIFICATION 51	/* queue: /LIBRARY=file-specification */
#define QUI$_LOG_QUEUE		52	/* job: /PRINTER=queue-name */
#define QUI$_LOG_SPECIFICATION	53	/* job: /LOG_FILE=file-specification */
#define QUI$_NOTE		54	/* job: /NOTE=string */
#define QUI$_OPERATOR_REQUEST	55	/* job: /OPERATOR=string */
#define QUI$_OWNER_UIC		56	/* queue: /OWNER=uic */
#define QUI$_PAGE_SETUP_MODULES 57	/* form: /PAGE_SETUP=(module,...) */
#define QUI$_PARAMETER_1	58	/* job: /PARAMETER=string */
#define QUI$_PARAMETER_2	59
#define QUI$_PARAMETER_3	60
#define QUI$_PARAMETER_4	61
#define QUI$_PARAMETER_5	62
#define QUI$_PARAMETER_6	63
#define QUI$_PARAMETER_7	64
#define QUI$_PARAMETER_8	65
#define QUI$_PRIORITY		66	/* job: /PRIORITY=n */
#define QUI$_PROCESSOR		67	/* queue: /PROCESSOR=filename */
#define QUI$_PROTECTION		68	/* queue: /PROTECTION=mask */
#define QUI$_QUEUE_FLAGS	69	/* queue: boolean information */
#define QUI$_QUEUE_NAME		70	/* job, queue: Queue name */
#define QUI$_QUEUE_STATUS	71	/* queue: status information */
#define QUI$_REFUSAL_REASON	72	/* job: reason symbiont refused job (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_REQUEUE_PRIORITY	73	/* job: priority after requeue (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_REQUEUE_QUEUE_NAME 74	/* job: queue after requeue */
#define QUI$_SCSNODE_NAME	75	/* queue: /ON=node:: */
#define QUI$_SEARCH_FLAGS	76	/* flags to control search */
#define QUI$_SEARCH_NAME	77	/* object name to search for */
#define QUI$_SEARCH_NUMBER	78	/* object number to search for */
#define QUI$_SUBMISSION_TIME	79	/* job: submission time */
#define QUI$_UIC		80	/* job: submitter's UIC */
#define QUI$_USERNAME		81	/* job: submitter's username */
#define QUI$_WSDEFAULT		82	/* job, queue: /WSDEFAULT=n */
#define QUI$_WSEXTENT		83	/* job, queue: /WSEXTENT=n */
#define QUI$_WSQUOTA		84	/* job, queue: /WSQUOTA=n */
#define QUI$_RESERVED_OUTPUT_85		85	/* reserved for Digital use */
#define QUI$_RESERVED_OUTPUT_86		86	/* reserved for Digital use */
#ifndef ONLY_VMS_V6
#define QUI$_RESERVED_INPUT_87		87	/* reserved for Digital use */
#endif
#ifndef NO_VMS_V6
#define QUI$_JOB_CONTROL_GQC		87	/* reserved for Digital (Use to send GQC to job control process) */
#endif
#define QUI$_SEARCH_USERNAME		88	/* username of owner of job to modify search */
#define QUI$_DEFAULT_FORM_NAME		89	/* default form name on queue */
#define QUI$_DEFAULT_FORM_NUMBER	90	/* default form number on queue */
#define QUI$_DEFAULT_FORM_STOCK		91	/* stock name for default form */
#define QUI$_JOB_PID			92	/* pid of batch job */
#define QUI$_FILE_IDENTIFICATION	93	/* file identification (from RMS NAM block) */
#define QUI$_PENDING_JOB_BLOCK_COUNT	94	/* total number of blocks for all pending jobs */
#define QUI$_JOB_RETENTION_TIME		95	/* the amount of time the job should be retained (may be delta or absolute) */
#define QUI$_JOB_COMPLETION_TIME	96	/* the time the job completed execution */
#define QUI$_JOB_COMPLETION_QUEUE	97	/* the name of the queue the job completed execution on */
#define QUI$_RESERVED_OUTPUT_98		98	/* reserved for Digital use */
#define QUI$_RESERVED_OUTPUT_99		99	/* reserved for Digital use */
#define QUI$_RESERVED_OUTPUT_100	100	/* reserved for Digital use */
#define QUI$_RESERVED_OUTPUT_101	101	/* reserved for Digital use */
#define QUI$_RESERVED_OUTPUT_102	102	/* reserved for Digital use */
#ifndef ONLY_VMS_V6
#define QUI$_RESERVED_INPUT_103		103	/* reserved for Digital use */
#endif
#ifndef NO_VMS_V6
#define QUI$_SEARCH_BATCH_EPID		103	/* batch job EPID to search for */
#endif
#define QUI$_SEARCH_JOB_NAME		104	/* job name to search for */
#define QUI$_RESERVED_INPUT_105		105	/* reserved for Digital use */
#define QUI$_RESERVED_INPUT_106		106	/* reserved for Digital use */
#define QUI$_EXECUTING_JOB_COUNT	107	/* number of jobs that are executing */
#define QUI$_HOLDING_JOB_COUNT		108	/* number of holding jobs */
#define QUI$_TIMED_RELEASE_JOB_COUNT	109	/* number of jobs specified with /AFTER_TIME */
#define QUI$_PENDING_JOB_REASON		110	/* secondary status describing why job is pending */
#define QUI$_ORB			111	/* ORB data in TLV format */
#define QUI$_ORB_ADDRESS		111	/* address of in-memory ORB data structure (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_QUEUE_DESCRIPTION		112	/* queue: /DESCRIPTION */
#define QUI$_SYMBIONT_FLAGS		113	/* symbiont options (requests) passed to job controller */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_JOB_ACCESS_CLASS		114	/* job access class information (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_ORB_LOCK_KEY		115	/* key value for locking of in-memory ORB data structure (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for Digital use) */
#define QUI$_CHECKPOINT_FREQUENCY	116	/* number of pages in interval at which symbiont takes chkpts */
#define QUI$_PENDING_JOB_COUNT		117	/* number of pending jobs */
#define QUI$_RETAINED_JOB_COUNT		118	/* number of retained jobs */
#define QUI$_RESTART_QUEUE_NAME		119	/* name of queue into which a job would be restarted, if appropriate */
#define QUI$_FILE_COUNT			120	/* count of files in job */
#define QUI$_ATTRIBUTES			121	/* keywds and values of extens attribs associated with queue, job, or file */
#define QUI$_ATTRIBUTES_SIZE		122	/* length of list of extens attribs associated with queue, job, or file */
#define QUI$_QUEUE_SUPPORT		123	/* queue Support Images defined on this queue */
#define QUI$_QUEUE_ATTRIBUTES		124	/* valid keywords for operations that alter the queue */
#define QUI$_QUEUE_ATTRIBUTES_SIZE	125	/* length of list of keywords for queue-oriented extens attribs */
#define QUI$_JOB_ATTRIBUTES		126	/* valid keywords for operations that create or alter jobs */
#define QUI$_JOB_ATTRIBUTES_SIZE	127	/* length of list of keywords for job-oriented extens attribs */
#define QUI$_FILE_ATTRIBUTES		128	/* valid keywords for file submissions or alter_file's */
#define QUI$_FILE_ATTRIBUTES_SIZE	129	/* length of list of keywords for file-oriented extens attribs */
#define QUI$_AUTOSTART_ON		130	/* node(s) (and for print queues, device(s)) on which queue can be auto started */
#define QUI$_AGENT_PROFILE		131	/* security information */
#ifndef ONLY_VMS_V6
#define QUI$_RESERVED_OUTPUT_132	132	/* reserved for Digital use */
#define QUI$_RESERVED_OUTPUT_133	133	/* reserved */
#define QUI$_RESERVED_OUTPUT_135	135	/* reserved */
#define QUI$_RESERVED_OUTPUT_136	136	/* reserved */
#define QUI$_RESERVED_OUTPUT_137	137	/* reserved */
#endif
#define QUI$_RESERVED_OUTPUT_134	134	/* reserved */
#ifndef NO_VMS_V6
#define QUI$_MANAGER_NAME		132	/* queue manager name */
#define QUI$_MANAGER_STATUS		133	/* queue manager state and status information */
#define QUI$_MANAGER_NODES		135	/* preferred node listed specified on start queue manager */
#define QUI$_MANAGER_AUTOSTART		136	/* list of nodes that are autostart enabled */
#define QUI$_QUEUE_DIRECTORY		137	/* directory specification provided when queue manager was started */
#endif
#define QUI$_RESERVED_OUTPUT_138	138	/* reserved */
#define QUI$_RESERVED_OUTPUT_139	139	/* reserved */
#define QUI$_RESERVED_OUTPUT_140	140	/* reserved */
#define QUI$_RESERVED_OUTPUT_141	141	/* reserved */
#define QUI$_RESERVED_OUTPUT_142	142	/* reserved */
#define QUI$_RESERVED_OUTPUT_143	143	/* reserved */
#define QUI$_RESERVED_OUTPUT_144	144	/* reserved */
#define QUI$_RESERVED_OUTPUT_145	145	/* reserved */
#define QUI$_RESERVED_OUTPUT_146	146	/* reserved */
#define QUI$_RESERVED_OUTPUT_147	147	/* reserved */
#define QUI$_RESERVED_OUTPUT_148	148	/* reserved */
#define QUI$_RESERVED_OUTPUT_149	149	/* reserved */
#define QUI$_RESERVED_OUTPUT_150	150	/* reserved */
#define QUI$_RESERVED_OUTPUT_151	151	/* reserved */
#define QUI$_RESERVED_OUTPUT_152	152	/* reserved */
#define QUI$_RESERVED_OUTPUT_153	153	/* reserved */
#define QUI$_RESERVED_OUTPUT_154	154	/* reserved */
#define QUI$_RESERVED_OUTPUT_155	155	/* reserved */
#define QUI$_RESERVED_OUTPUT_156	156	/* reserved */
#define QUI$_RESERVED_OUTPUT_157	157	/* reserved */
#define QUI$_RESERVED_OUTPUT_158	158	/* reserved */
#define QUI$_RESERVED_OUTPUT_159	159	/* reserved */
#define QUI$_RESERVED_INPUT_160		160	/* reserved */
#define QUI$_RESERVED_INPUT_161		161	/* reserved */
#define QUI$_RESERVED_INPUT_162		162	/* reserved */
#define QUI$_RESERVED_INPUT_163		163	/* reserved */
#define QUI$_RESERVED_INPUT_164		164	/* reserved */
#define QUI$_RESERVED_INPUT_165		165	/* reserved */
#define QUI$K_MIN_ITEM	1	/* minimum GETQUI item code */
#define QUI$K_MAX_ITEM	165	/* maximum GETQUI item code */

/* Subfields of FILE_FLAGS item code. */
#define QUI$V_FILE_BURST	0
#define QUI$V_FILE_BURST_EXP	1
#define QUI$V_FILE_DELETE	2
#define QUI$V_FILE_DOUBLE_SPACE 3
#define QUI$V_FILE_FLAG		4
#define QUI$V_FILE_FLAG_EXP	5
#define QUI$V_FILE_TRAILER	6
#define QUI$V_FILE_TRAILER_EXP	7
#define QUI$V_FILE_PAGE_HEADER	8
#define QUI$V_FILE_PAGINATE	9
#define QUI$V_FILE_PASSALL	10
#define QUI$V_FILE_PAGINATE_EXP 11
#define QUI$M_FILE_BURST	(1<<QUI$V_FILE_BURST)		/* 0x01 */
#define QUI$M_FILE_BURST_EXP	(1<<QUI$V_FILE_BURST_EXP)	/* 0x02 */
#define QUI$M_FILE_DELETE	(1<<QUI$V_FILE_DELETE)		/* 0x04 */
#define QUI$M_FILE_DOUBLE_SPACE (1<<QUI$V_FILE_DOUBLE_SPACE)	/* 0x08 */
#define QUI$M_FILE_FLAG		(1<<QUI$V_FILE_FLAG)		/* 0x10 */
#define QUI$M_FILE_FLAG_EXP	(1<<QUI$V_FILE_FLAG_EXP)	/* 0x20 */
#define QUI$M_FILE_TRAILER	(1<<QUI$V_FILE_TRAILER)		/* 0x40 */
#define QUI$M_FILE_TRAILER_EXP	(1<<QUI$V_FILE_TRAILER_EXP)	/* 0x80 */
#define QUI$M_FILE_PAGE_HEADER	(1<<QUI$V_FILE_PAGE_HEADER)	/* 0x0100 */
#define QUI$M_FILE_PAGINATE	(1<<QUI$V_FILE_PAGINATE)	/* 0x0200 */
#define QUI$M_FILE_PASSALL	(1<<QUI$V_FILE_PASSALL)		/* 0x0400 */
#define QUI$M_FILE_PAGINATE_EXP (1<<QUI$V_FILE_PAGINATE_EXP)	/* 0x0800 */
struct qui$file_flags {
    unsigned qui$v_file_burst		: 1;	/* /BURST */
    unsigned qui$v_file_burst_exp	: 1;	/* /[NO]BURST explicit */
    unsigned qui$v_file_delete		: 1;	/* /DELETE */
    unsigned qui$v_file_double_space	: 1;	/* /SPACE */
    unsigned qui$v_file_flag		: 1;	/* /FLAG */
    unsigned qui$v_file_flag_exp	: 1;	/* /[NO]FLAG explicit */
    unsigned qui$v_file_trailer		: 1;	/* /TRAILER */
    unsigned qui$v_file_trailer_exp	: 1;	/* /[NO]TRAILER explicit */
    unsigned qui$v_file_page_header	: 1;	/* /HEADER */
    unsigned qui$v_file_paginate	: 1;	/* /FEED */
    unsigned qui$v_file_passall		: 1;	/* /PASSALL */
    unsigned qui$v_file_paginate_exp	: 1;	/* /[NO]FEED explicit */
    unsigned qui$v_filler		: 20;
};

/* Subfields of FILE_STATUS item code. */
#define QUI$V_FILE_CHECKPOINTED 0
#define QUI$V_FILE_EXECUTING	1
#define QUI$M_FILE_CHECKPOINTED (1<<QUI$V_FILE_CHECKPOINTED)	/* 0x01 */
#define QUI$M_FILE_EXECUTING	(1<<QUI$V_FILE_EXECUTING)	/* 0x02 */
struct qui$file_status {
    unsigned qui$v_file_checkpointed	: 1;	/* file checkpointed */
    unsigned qui$v_file_executing	: 1;	/* file currently executing */
    unsigned qui$v_filler		: 30;
};

/* Subfields of FORM_FLAGS item code. */
#define QUI$V_FORM_SHEET_FEED	0
#define QUI$V_FORM_TRUNCATE	1
#define QUI$V_FORM_WRAP		2
#define QUI$M_FORM_SHEET_FEED	(1<<QUI$V_FORM_SHEET_FEED)	/* 0x01 */
#define QUI$M_FORM_TRUNCATE	(1<<QUI$V_FORM_TRUNCATE)	/* 0x02 */
#define QUI$M_FORM_WRAP		(1<<QUI$V_FORM_WRAP)		/* 0x04 */
struct qui$form_flags {
    unsigned qui$v_form_sheet_feed	: 1;	/* /SHEET_FEED */
    unsigned qui$v_form_truncate	: 1;	/* /TRUNCATE */
    unsigned qui$v_form_wrap		: 1;	/* /WRAP */
    unsigned qui$v_filler		: 29;
};

/* Subfields of JOB_FLAGS item code. */
#define QUI$V_JOB_CPU_LIMIT	0
#define QUI$V_JOB_FILE_BURST	1
#define QUI$V_JOB_FILE_BURST_ONE 2
#define QUI$V_JOB_FILE_BURST_EXP 3
#define QUI$V_JOB_FILE_FLAG	4
#define QUI$V_JOB_FILE_FLAG_ONE 5
#define QUI$V_JOB_FILE_FLAG_EXP 6
#define QUI$V_JOB_FILE_TRAILER	7
#define QUI$V_JOB_FILE_TRAILER_ONE 8
#define QUI$V_JOB_FILE_TRAILER_EXP 9
#define QUI$V_JOB_LOG_DELETE	10
#define QUI$V_JOB_LOG_NULL	11
#define QUI$V_JOB_LOG_SPOOL	12
#define QUI$V_JOB_LOWERCASE	13
#define QUI$V_JOB_NOTIFY	14
#define QUI$V_JOB_RESTART	15
#define QUI$V_JOB_WSDEFAULT	16
#define QUI$V_JOB_WSEXTENT	17
#define QUI$V_JOB_WSQUOTA	18
#define QUI$V_JOB_FILE_PAGINATE 19
#define QUI$V_JOB_FILE_PAGINATE_EXP 20
#define QUI$V_JOB_RETENTION	21
#define QUI$V_JOB_ERROR_RETENTION 22
#define QUI$M_JOB_CPU_LIMIT	(1<<QUI$V_JOB_CPU_LIMIT)	/* 0x01 */
#define QUI$M_JOB_FILE_BURST	(1<<QUI$V_JOB_FILE_BURST)	/* 0x02 */
#define QUI$M_JOB_FILE_BURST_ONE (1<<QUI$V_JOB_FILE_BURST_ONE)	/* 0x04 */
#define QUI$M_JOB_FILE_BURST_EXP (1<<QUI$V_JOB_FILE_BURST_EXP)	/* 0x08 */
#define QUI$M_JOB_FILE_FLAG	(1<<QUI$V_JOB_FILE_FLAG)	/* 0x10 */
#define QUI$M_JOB_FILE_FLAG_ONE (1<<QUI$V_JOB_FILE_FLAG_ONE)	/* 0x20 */
#define QUI$M_JOB_FILE_FLAG_EXP (1<<QUI$V_JOB_FILE_FLAG_EXP)	/* 0x40 */
#define QUI$M_JOB_FILE_TRAILER	(1<<QUI$V_JOB_FILE_TRAILER)	/* 0x80 */
#define QUI$M_JOB_FILE_TRAILER_ONE (1<<QUI$V_JOB_FILE_TRAILER_ONE) /* 0x0100 */
#define QUI$M_JOB_FILE_TRAILER_EXP (1<<QUI$V_JOB_FILE_TRAILER_EXP) /* 0x0200 */
#define QUI$M_JOB_LOG_DELETE	(1<<QUI$V_JOB_LOG_DELETE)	/* 0x0400 */
#define QUI$M_JOB_LOG_NULL	(1<<QUI$V_JOB_LOG_NULL)		/* 0x0800 */
#define QUI$M_JOB_LOG_SPOOL	(1<<QUI$V_JOB_LOG_SPOOL)	/* 0x1000 */
#define QUI$M_JOB_LOWERCASE	(1<<QUI$V_JOB_LOWERCASE)	/* 0x2000 */
#define QUI$M_JOB_NOTIFY	(1<<QUI$V_JOB_NOTIFY)		/* 0x4000 */
#define QUI$M_JOB_RESTART	(1<<QUI$V_JOB_RESTART)		/* 0x8000 */
#define QUI$M_JOB_WSDEFAULT	(1<<QUI$V_JOB_WSDEFAULT)	/* 0x010000 */
#define QUI$M_JOB_WSEXTENT	(1<<QUI$V_JOB_WSEXTENT)		/* 0x020000 */
#define QUI$M_JOB_WSQUOTA	(1<<QUI$V_JOB_WSQUOTA)		/* 0x040000 */
#define QUI$M_JOB_FILE_PAGINATE (1<<QUI$V_JOB_FILE_PAGINATE)	/* 0x080000 */
#define QUI$M_JOB_FILE_PAGINATE_EXP (1<<QUI$V_JOB_FILE_PAGINATE_EXP) /* 0x100000 */
#define QUI$M_JOB_RETENTION	(1<<QUI$V_JOB_RETENTION)	/* 0x200000 */
#define QUI$M_JOB_ERROR_RETENTION (1<<QUI$V_JOB_ERROR_RETENTION) /* 0x400000 */
struct qui$job_flags {
    unsigned qui$v_job_cpu_limit	: 1;	/* /CPUTIME explicit */
    unsigned qui$v_job_file_burst	: 1;	/* /BURST=ALL */
    unsigned qui$v_job_file_burst_one	: 1;	/* /BURST=ONE */
    unsigned qui$v_job_file_burst_exp	: 1;	/* /[NO]BURST explicit */
    unsigned qui$v_job_file_flag	: 1;	/* /FLAG=ALL */
    unsigned qui$v_job_file_flag_one	: 1;	/* /FLAG=ONE */
    unsigned qui$v_job_file_flag_exp	: 1;	/* /[NO]FLAG explicit */
    unsigned qui$v_job_file_trailer	: 1;	/* /TRAILER=ALL */
    unsigned qui$v_job_file_trailer_one : 1;	/* /TRAILER=ONE */
    unsigned qui$v_job_file_trailer_exp : 1;	/* /[NO]TRAILER explicit */
    unsigned qui$v_job_log_delete	: 1;	/* /NOKEEP */
    unsigned qui$v_job_log_null		: 1;	/* /NOLOG_FILE */
    unsigned qui$v_job_log_spool	: 1;	/* /PRINTER */
    unsigned qui$v_job_lowercase	: 1;	/* /LOWERCASE */
    unsigned qui$v_job_notify		: 1;	/* /NOTIFY */
    unsigned qui$v_job_restart		: 1;	/* /RESTART */
    unsigned qui$v_job_wsdefault	: 1;	/* /WSDEFAULT explicit */
    unsigned qui$v_job_wsextent		: 1;	/* /WSEXTENT explicit */
    unsigned qui$v_job_wsquota		: 1;	/* /WSQUOTA explicit */
    unsigned qui$v_job_file_paginate	: 1;	/* /FEED */
    unsigned qui$v_job_file_paginate_exp: 1;	/* /[NO]FEED explicit */
    unsigned qui$v_job_retention	: 1;	/* /RETAIN=ALWAYS */
    unsigned qui$v_job_error_retention	: 1;	/* /RETAIN=ERROR */
    unsigned qui$v_filler		: 9;
};

/* Subfields of JOB_STATUS item code. */
#define QUI$V_JOB_ABORTING	0
#define QUI$V_JOB_EXECUTING	1
#define QUI$V_JOB_HOLDING	2
#define QUI$V_JOB_INACCESSIBLE	3
#define QUI$V_JOB_REFUSED	4
#define QUI$V_JOB_REQUEUE	5
#define QUI$V_JOB_RESTARTING	6
#define QUI$V_JOB_RETAINED	7
#define QUI$V_JOB_STARTING	8
#define QUI$V_JOB_TIMED_RELEASE 9
#define QUI$V_JOB_TIMED QUI$V_JOB_TIMED_RELEASE /* synonym for V4 compat */
#define QUI$V_JOB_SUSPENDED	10
#define QUI$V_JOB_PENDING	11
#define QUI$V_JOB_UNDEFINED	12
#define QUI$V_JOB_STALLED	13
#define QUI$V_JOB_INCOMPLETE	14
#define QUI$V_JOB_COMPLETING	15
#define QUI$M_JOB_ABORTING	(1<<QUI$V_JOB_ABORTING)		/* 0x01 */
#define QUI$M_JOB_EXECUTING	(1<<QUI$V_JOB_EXECUTING)	/* 0x02 */
#define QUI$M_JOB_HOLDING	(1<<QUI$V_JOB_HOLDING)		/* 0x04 */
#define QUI$M_JOB_INACCESSIBLE	(1<<QUI$V_JOB_INACCESSIBLE)	/* 0x08 */
#define QUI$M_JOB_REFUSED	(1<<QUI$V_JOB_REFUSED)		/* 0x10 */
#define QUI$M_JOB_REQUEUE	(1<<QUI$V_JOB_REQUEUE)		/* 0x20 */
#define QUI$M_JOB_RESTARTING	(1<<QUI$V_JOB_RESTARTING)	/* 0x40 */
#define QUI$M_JOB_RETAINED	(1<<QUI$V_JOB_RETAINED)		/* 0x80 */
#define QUI$M_JOB_STARTING	(1<<QUI$V_JOB_STARTING)		/* 0x0100 */
#define QUI$M_JOB_TIMED_RELEASE (1<<QUI$V_JOB_TIMED_RELEASE)	/* 0x0200 */
#define QUI$M_JOB_TIMED QUI$M_JOB_TIMED_RELEASE
#define QUI$M_JOB_SUSPENDED	(1<<QUI$V_JOB_SUSPENDED)	/* 0x0400 */
#define QUI$M_JOB_PENDING	(1<<QUI$V_JOB_PENDING)		/* 0x0800 */
#define QUI$M_JOB_UNDEFINED	(1<<QUI$V_JOB_UNDEFINED)	/* 0x1000 */
#define QUI$M_JOB_STALLED	(1<<QUI$V_JOB_STALLED)		/* 0x2000 */
#define QUI$M_JOB_INCOMPLETE	(1<<QUI$V_JOB_INCOMPLETE)	/* 0x4000 */
#define QUI$M_JOB_COMPLETING	(1<<QUI$V_JOB_COMPLETING)	/* 0x8000 */
struct qui$job_status {
    unsigned qui$v_job_aborting		: 1;	/* job is aborting */
    unsigned qui$v_job_executing	: 1;	/* job is executing */
    unsigned qui$v_job_holding		: 1;	/* job is holding for /HOLD */
    unsigned qui$v_job_inaccessible	: 1;	/* job is inaccessible */
    unsigned qui$v_job_refused		: 1;	/* job was refused by symbiont */
    unsigned qui$v_job_requeue		: 1;	/* job will requeue after abort (intentionally not documented) */
    unsigned qui$v_job_restarting	: 1;	/* job started execution at least once (intentionally not documented) */
    unsigned qui$v_job_retained		: 1;	/* job was retained by /RETAIN */
    unsigned qui$v_job_starting		: 1;	/* job is starting */
    unsigned qui$v_job_timed_release	: 1;	/* job is holding for /AFTER */
    unsigned qui$v_job_suspended	: 1;	/* job is suspended by STOP/QUEUE command */
    unsigned qui$v_job_pending		: 1;	/* job is pending (see QUI$_JOB_PENDING_REASON for more information) */
    unsigned qui$v_job_undefined	: 1;	/* job does not yet exist in db or is being removed from db */
    unsigned qui$v_job_stalled		: 1;	/* current job on stalled queue */
    unsigned qui$v_job_incomplete	: 1;	/* job was processed by the symbiont but further processing is necessary */
    unsigned qui$v_job_completing	: 1;	/* job has been completely processed */
    unsigned qui$v_filler		: 16;
};

/* Subfields of PENDING_JOB_REASON. */
/*  Note that in the descriptions below "queue" refers to the execution */
/*  queue in which a job resides, or to the set of execution queues	*/
/*  that is the target of the generic queue in which a job resides.	*/
#define QUI$V_PEND_CHAR_MISMATCH	0
#define QUI$V_PEND_JOB_SIZE_MAX		1
#define QUI$V_PEND_JOB_SIZE_MIN		2
#define QUI$V_PEND_LOWERCASE_MISMATCH	3
#define QUI$V_PEND_NO_ACCESS		4
#define QUI$V_PEND_QUEUE_BUSY		5
#define QUI$V_PEND_QUEUE_STATE		6
#define QUI$V_PEND_STOCK_MISMATCH	7
#define QUI$M_PEND_CHAR_MISMATCH	(1<<QUI$V_PEND_CHAR_MISMATCH)	/* 0x01 */
#define QUI$M_PEND_JOB_SIZE_MAX		(1<<QUI$V_PEND_JOB_SIZE_MAX)	/* 0x02 */
#define QUI$M_PEND_JOB_SIZE_MIN		(1<<QUI$V_PEND_JOB_SIZE_MIN)	/* 0x04 */
#define QUI$M_PEND_LOWERCASE_MISMATCH	(1<<QUI$V_PEND_LOWERCASE_MISMATCH) /* 0x08 */
#define QUI$M_PEND_NO_ACCESS		(1<<QUI$V_PEND_NO_ACCESS)	/* 0x10 */
#define QUI$M_PEND_QUEUE_BUSY		(1<<QUI$V_PEND_QUEUE_BUSY)	/* 0x20 */
#define QUI$M_PEND_QUEUE_STATE		(1<<QUI$V_PEND_QUEUE_STATE)	/* 0x40 */
#define QUI$M_PEND_STOCK_MISMATCH	(1<<QUI$V_PEND_STOCK_MISMATCH)	/* 0x80 */
struct qui$pending_job_reason {
    unsigned qui$v_pend_char_mismatch	: 1;	/* Queue's characteristics do not match job's requirements */
    unsigned qui$v_pend_job_size_max	: 1;	/* Print job's block size is too large to execute on queue (print job only) */
    unsigned qui$v_pend_job_size_min	: 1;	/* Print job's block size is too small to execute on queue (print job only) */
    unsigned qui$v_pend_lowercase_mismatch : 1; /* Queue's lowercase attribute does not match job's requirements (print job only) */
    unsigned qui$v_pend_no_access	: 1;	/* User does not have access to queue */
    unsigned qui$v_pend_queue_busy	: 1;	/* Job is ready to execute but must wait until other jobs ahead of it in the queue */
 /*  complete execution (this is a normal state that requires no user intervention) */
    unsigned qui$v_pend_queue_state	: 1;	/* Queue state prevents job from executing (see QUI$_QUEUE_STATUS for more info) */
    unsigned qui$v_pend_stock_mismatch	: 1;	/* Stock type of mounted form on output execution queue does not match */
 /*  stock stock type required by form associated with job (print job only) */
    unsigned qui$v_filler		: 24;
};

/* Subfields of QUEUE_FLAGS item code. */
#define QUI$V_QUEUE_BATCH		0
#define QUI$V_QUEUE_CPU_DEFAULT		1
#define QUI$V_QUEUE_CPU_LIMIT		2
#define QUI$V_QUEUE_FILE_BURST		3
#define QUI$V_QUEUE_FILE_BURST_ONE	4
#define QUI$V_QUEUE_FILE_FLAG		5
#define QUI$V_QUEUE_FILE_FLAG_ONE	6
#define QUI$V_QUEUE_FILE_TRAILER	7
#define QUI$V_QUEUE_FILE_TRAILER_ONE	8
#define QUI$V_QUEUE_GENERIC		9
#define QUI$V_QUEUE_GENERIC_SELECTION	10
#define QUI$V_QUEUE_JOB_BURST		11
#define QUI$V_QUEUE_JOB_FLAG		12
#define QUI$V_QUEUE_JOB_SIZE_SCHED	13
#define QUI$V_QUEUE_JOB_TRAILER		14
#define QUI$V_QUEUE_RETAIN_ALL		15
#define QUI$V_QUEUE_RETAIN_ERROR	16
#define QUI$V_QUEUE_SWAP		17
#define QUI$V_QUEUE_TERMINAL		18
#define QUI$V_QUEUE_WSDEFAULT		19
#define QUI$V_QUEUE_WSEXTENT		20
#define QUI$V_QUEUE_WSQUOTA		21
#define QUI$V_QUEUE_FILE_PAGINATE	22
#define QUI$V_QUEUE_RECORD_BLOCKING	23
#define QUI$V_QUEUE_PRINTER		24
#define QUI$V_QUEUE_ACL_SPECIFIED	25
#define QUI$V_QUEUE_NOTIFY_ON_INTERRUPT 26
#define QUI$V_QUEUE_CHECKPOINT_FREQ	27
#define QUI$V_QUEUE_AUTOSTART		28
#ifndef NO_VMS_V6
#define QUI$V_SECURITY_INACCESSIBLE	29
#endif
#define QUI$M_QUEUE_BATCH		(1<<QUI$V_QUEUE_BATCH)		/* 0x01 */
#define QUI$M_QUEUE_CPU_DEFAULT		(1<<QUI$V_QUEUE_CPU_DEFAULT)	/* 0x02 */
#define QUI$M_QUEUE_CPU_LIMIT		(1<<QUI$V_QUEUE_CPU_LIMIT)	/* 0x04 */
#define QUI$M_QUEUE_FILE_BURST		(1<<QUI$V_QUEUE_FILE_BURST)	/* 0x08 */
#define QUI$M_QUEUE_FILE_BURST_ONE	(1<<QUI$V_QUEUE_FILE_BURST_ONE) /* 0x10 */
#define QUI$M_QUEUE_FILE_FLAG		(1<<QUI$V_QUEUE_FILE_FLAG)	/* 0x20 */
#define QUI$M_QUEUE_FILE_FLAG_ONE	(1<<QUI$V_QUEUE_FILE_FLAG_ONE)	/* 0x40 */
#define QUI$M_QUEUE_FILE_TRAILER	(1<<QUI$V_QUEUE_FILE_TRAILER)	/* 0x80 */
#define QUI$M_QUEUE_FILE_TRAILER_ONE	(1<<QUI$V_QUEUE_FILE_TRAILER_ONE) /* 0x0100 */
#define QUI$M_QUEUE_GENERIC		(1<<QUI$V_QUEUE_GENERIC)	/* 0x0200 */
#define QUI$M_QUEUE_GENERIC_SELECTION	(1<<QUI$V_QUEUE_GENERIC_SELECTION) /* 0x0400 */
#define QUI$M_QUEUE_JOB_BURST		(1<<QUI$V_QUEUE_JOB_BURST)	/* 0x0800 */
#define QUI$M_QUEUE_JOB_FLAG		(1<<QUI$V_QUEUE_JOB_FLAG)	/* 0x1000 */
#define QUI$M_QUEUE_JOB_SIZE_SCHED	(1<<QUI$V_QUEUE_JOB_SIZE_SCHED) /* 0x2000 */
#define QUI$M_QUEUE_JOB_TRAILER		(1<<QUI$V_QUEUE_JOB_TRAILER)	/* 0x4000 */
#define QUI$M_QUEUE_RETAIN_ALL		(1<<QUI$V_QUEUE_RETAIN_ALL)	/* 0x8000 */
#define QUI$M_QUEUE_RETAIN_ERROR	(1<<QUI$V_QUEUE_RETAIN_ERROR)	/* 0x010000 */
#define QUI$M_QUEUE_SWAP		(1<<QUI$V_QUEUE_SWAP)		/* 0x020000 */
#define QUI$M_QUEUE_TERMINAL		(1<<QUI$V_QUEUE_TERMINAL)	/* 0x040000 */
#define QUI$M_QUEUE_WSDEFAULT		(1<<QUI$V_QUEUE_WSDEFAULT)	/* 0x080000 */
#define QUI$M_QUEUE_WSEXTENT		(1<<QUI$V_QUEUE_WSEXTENT)	/* 0x100000 */
#define QUI$M_QUEUE_WSQUOTA		(1<<QUI$V_QUEUE_WSQUOTA)	/* 0x200000 */
#define QUI$M_QUEUE_FILE_PAGINATE	(1<<QUI$V_QUEUE_FILE_PAGINATE)	/* 0x400000 */
#define QUI$M_QUEUE_RECORD_BLOCKING	(1<<QUI$V_QUEUE_RECORD_BLOCKING) /* 0x800000 */
#define QUI$M_QUEUE_PRINTER		(1<<QUI$V_QUEUE_PRINTER)	/* 0x01000000 */
#define QUI$M_QUEUE_ACL_SPECIFIED	(1<<QUI$V_QUEUE_ACL_SPECIFIED)	/* 0x02000000 */
#define QUI$M_QUEUE_NOTIFY_ON_INTERRUPT (1<<QUI$V_QUEUE_NOTIFY_ON_INTERRUPT) /* 0x04000000 */
#define QUI$M_QUEUE_CHECKPOINT_FREQ	(1<<QUI$V_QUEUE_CHECKPOINT_FREQ) /* 0x08000000 */
#define QUI$M_QUEUE_AUTOSTART		(1<<QUI$V_QUEUE_AUTOSTART)	/* 0x10000000 */
#ifndef NO_VMS_V6
#define QUI$M_SECURITY_INACCESSIBLE	(1<<QUI$V_SECURITY_INACCESSIBLE) /* 0x20000000 */
#endif
struct qui$queue_flags {
    unsigned qui$v_queue_batch		: 1;	/* /BATCH */
    unsigned qui$v_queue_cpu_default	: 1;	/* /CPUDEFAULT specified */
    unsigned qui$v_queue_cpu_limit	: 1;	/* /CPUMAXIMUM specified */
    unsigned qui$v_queue_file_burst	: 1;	/* /DEFAULT=BURST=ALL */
    unsigned qui$v_queue_file_burst_one : 1;	/* /DEFAULT=BURST=ONE */
    unsigned qui$v_queue_file_flag	: 1;	/* /DEFAULT=FLAG=ALL */
    unsigned qui$v_queue_file_flag_one	: 1;	/* /DEFAULT=FLAG=ONE */
    unsigned qui$v_queue_file_trailer	: 1;	/* /DEFAULT=TRAILER=ALL */
    unsigned qui$v_queue_file_trailer_one : 1;	/* /DEFAULT=TRAILER=ONE */
    unsigned qui$v_queue_generic	: 1;	/* /GENERIC */
    unsigned qui$v_queue_generic_selection : 1; /* /ENABLE_GENERIC */
    unsigned qui$v_queue_job_burst	: 1;	/* /SEPARATE=BURST */
    unsigned qui$v_queue_job_flag	: 1;	/* /SEPARATE=FLAG	 */
    unsigned qui$v_queue_job_size_sched : 1;	/* /SCHEDULE=SIZE */
    unsigned qui$v_queue_job_trailer	: 1;	/* /SEPARATE=TRAILER */
    unsigned qui$v_queue_retain_all	: 1;	/* /RETAIN=ALL */
    unsigned qui$v_queue_retain_error	: 1;	/* /RETAIN=ERROR */
    unsigned qui$v_queue_swap		: 1;	/* /NODISABLE_SWAPPING */
    unsigned qui$v_queue_terminal	: 1;	/* /DEVICE=TERMINAL or terminal device type reported by symbiont */
    unsigned qui$v_queue_wsdefault	: 1;	/* /WSDEFAULT specified */
    unsigned qui$v_queue_wsextent	: 1;	/* /WSEXTENT specified */
    unsigned qui$v_queue_wsquota	: 1;	/* /WSQUOTA specified */
    unsigned qui$v_queue_file_paginate	: 1;	/* /DEFAULT=FEED */
    unsigned qui$v_queue_record_blocking: 1;	/* /RECORD_BLOCKING */
    unsigned qui$v_queue_printer	: 1;	/* /DEVICE=PRINTER or printer device type reported by symbiont */
    unsigned qui$v_queue_acl_specified	: 1;	/* ACL has been specified for queue */
    unsigned qui$v_queue_notify_on_interrupt : 1; /* /NOTIFY=INTERRUPTION */
    unsigned qui$v_queue_checkpoint_freq: 1;	/* /CHECKPOINT_FREQUENCY specified */
    unsigned qui$v_queue_autostart	: 1;	/* /AUTOSTART_ON specified */
#ifndef NO_VMS_V6
    unsigned qui$v_security_inaccessible : 1;	/* requestor does not have access to security information */
    unsigned qui$v_filler		: 2;
#else
    unsigned qui$v_filler		: 3;
#endif
};

/* Subfields of QUEUE_STATUS item code. */
#define QUI$V_QUEUE_ALIGNING	0
#define QUI$V_QUEUE_IDLE	1
#define QUI$V_QUEUE_LOWERCASE	2
#define QUI$V_QUEUE_OPERATOR_REQUEST 3
#define QUI$V_QUEUE_PAUSED	4
#define QUI$V_QUEUE_PAUSING	5
#define QUI$V_QUEUE_REMOTE	6
#define QUI$V_QUEUE_RESETTING	7
#define QUI$V_QUEUE_RESUMING	8
#define QUI$V_QUEUE_SERVER	9
#define QUI$V_QUEUE_STALLED	10
#define QUI$V_QUEUE_STARTING	11
#define QUI$V_QUEUE_STOPPED	12
#define QUI$V_QUEUE_STOPPING	13
#define QUI$V_QUEUE_UNAVAILABLE 14
#define QUI$V_QUEUE_CLOSED	15
#define QUI$V_QUEUE_BUSY	16
#define QUI$V_QUEUE_UNDEFINED	17
#define QUI$V_QUEUE_AVAILABLE	18
#define QUI$V_QUEUE_DISABLED	19
#define QUI$V_QUEUE_AUTOSTART_INACTIVE 20
#define QUI$V_QUEUE_STOP_PENDING 21
#define QUI$M_QUEUE_ALIGNING	(1<<QUI$V_QUEUE_ALIGNING)	/* 0x01 */
#define QUI$M_QUEUE_IDLE	(1<<QUI$V_QUEUE_IDLE)		/* 0x02 */
#define QUI$M_QUEUE_LOWERCASE	(1<<QUI$V_QUEUE_LOWERCASE)	/* 0x04 */
#define QUI$M_QUEUE_OPERATOR_REQUEST (1<<QUI$V_QUEUE_OPERATOR_REQUEST) /* 0x08 */
#define QUI$M_QUEUE_PAUSED	(1<<QUI$V_QUEUE_PAUSED)		/* 0x10 */
#define QUI$M_QUEUE_PAUSING	(1<<QUI$V_QUEUE_PAUSING)	/* 0x20 */
#define QUI$M_QUEUE_REMOTE	(1<<QUI$V_QUEUE_REMOTE)		/* 0x40 */
#define QUI$M_QUEUE_RESETTING	(1<<QUI$V_QUEUE_RESETTING)	/* 0x80 */
#define QUI$M_QUEUE_RESUMING	(1<<QUI$V_QUEUE_RESUMING)	/* 0x0100 */
#define QUI$M_QUEUE_SERVER	(1<<QUI$V_QUEUE_SERVER)		/* 0x0200 */
#define QUI$M_QUEUE_STALLED	(1<<QUI$V_QUEUE_STALLED)	/* 0x0400 */
#define QUI$M_QUEUE_STARTING	(1<<QUI$V_QUEUE_STARTING)	/* 0x0800 */
#define QUI$M_QUEUE_STOPPED	(1<<QUI$V_QUEUE_STOPPED)	/* 0x1000 */
#define QUI$M_QUEUE_STOPPING	(1<<QUI$V_QUEUE_STOPPING)	/* 0x2000 */
#define QUI$M_QUEUE_UNAVAILABLE (1<<QUI$V_QUEUE_UNAVAILABLE)	/* 0x4000 */
#define QUI$M_QUEUE_CLOSED	(1<<QUI$V_QUEUE_CLOSED)		/* 0x8000 */
#define QUI$M_QUEUE_BUSY	(1<<QUI$V_QUEUE_BUSY)		/* 0x010000 */
#define QUI$M_QUEUE_UNDEFINED	(1<<QUI$V_QUEUE_UNDEFINED)	/* 0x020000 */
#define QUI$M_QUEUE_AVAILABLE	(1<<QUI$V_QUEUE_AVAILABLE)	/* 0x040000 */
#define QUI$M_QUEUE_DISABLED	(1<<QUI$V_QUEUE_DISABLED)	/* 0x080000 */
#define QUI$M_QUEUE_AUTOSTART_INACTIVE (1<<QUI$V_QUEUE_AUTOSTART_INACTIVE) /* 0x100000 */
#define QUI$M_QUEUE_STOP_PENDING (1<<QUI$V_QUEUE_STOP_PENDING)	/* 0x200000 */
struct qui$queue_status {
    unsigned qui$v_queue_aligning	: 1;	/* queue is aligning */
    unsigned qui$v_queue_idle		: 1;	/* queue is idle */
    unsigned qui$v_queue_lowercase	: 1;	/* lowercase device */
    unsigned qui$v_queue_operator_request : 1;	/* queue is doing /OPERATOR (intentionally not documented) */
    unsigned qui$v_queue_paused		: 1;	/* queue is paused */
    unsigned qui$v_queue_pausing	: 1;	/* queue is pausing */
    unsigned qui$v_queue_remote		: 1;	/* remote device */
    unsigned qui$v_queue_resetting	: 1;	/* incomplete remote request to reset */
    unsigned qui$v_queue_resuming	: 1;	/* queue is resuming */
    unsigned qui$v_queue_server		: 1;	/* /DEVICE=SERVER or reported to be a served queue by the symbiont */
    unsigned qui$v_queue_stalled	: 1;	/* device is stalled */
    unsigned qui$v_queue_starting	: 1;	/* queue is starting */
    unsigned qui$v_queue_stopped	: 1;	/* queue is stopped */
    unsigned qui$v_queue_stopping	: 1;	/* queue is stopping */
    unsigned qui$v_queue_unavailable	: 1;	/* device is unavailable */
    unsigned qui$v_queue_closed		: 1;	/* queue is closed */
    unsigned qui$v_queue_busy		: 1;	/* queue is executing as many jobs as it is capable of executing */
    unsigned qui$v_queue_undefined	: 1;	/* queue does not yet exist in db or is being removed from db */
    unsigned qui$v_queue_available	: 1;	/* at least one job is executing, but the queue is capable of executing more */
    unsigned qui$v_queue_disabled	: 1;	/* queue is not able to accept or process jobs; its QSIs are inactive */
    unsigned qui$v_queue_autostart_inactive : 1; /* AUTOSTART queue explicitly stopped */
    unsigned qui$v_queue_stop_pending	: 1;	/* queue will be stopped when work currently in progress has completed */
    unsigned qui$v_filler		: 10;
};

/* Subfields of SEARCH_FLAGS item code. */
#define QUI$V_SEARCH_ALL_JOBS		0
#define QUI$V_SEARCH_WILDCARD		1
#define QUI$V_SEARCH_BATCH		2
#define QUI$V_SEARCH_SYMBIONT		3
#define QUI$V_SEARCH_THIS_JOB		4
#define QUI$V_SEARCH_PRINTER		5
#define QUI$V_SEARCH_SERVER		6
#define QUI$V_SEARCH_TERMINAL		7
#define QUI$V_SEARCH_GENERIC		8
#define QUI$V_SEARCH_GENERIC_TARGET	9
#define QUI$V_SEARCH_PENDING_JOBS	10
#define QUI$V_SEARCH_EXECUTING_JOBS	11
#define QUI$V_SEARCH_TIMED_RELEASE_JOBS 12
#define QUI$V_SEARCH_HOLDING_JOBS	13
#define QUI$V_SEARCH_RETAINED_JOBS	14
#define QUI$V_SEARCH_FREEZE_CONTEXT	15
#define QUI$M_SEARCH_ALL_JOBS		(1<<QUI$V_SEARCH_ALL_JOBS)	/* 0x01 */
#define QUI$M_SEARCH_WILDCARD		(1<<QUI$V_SEARCH_WILDCARD)	/* 0x02 */
#define QUI$M_SEARCH_BATCH		(1<<QUI$V_SEARCH_BATCH)		/* 0x04 */
#define QUI$M_SEARCH_SYMBIONT		(1<<QUI$V_SEARCH_SYMBIONT)	/* 0x08 */
#define QUI$M_SEARCH_THIS_JOB		(1<<QUI$V_SEARCH_THIS_JOB)	/* 0x10 */
#define QUI$M_SEARCH_PRINTER		(1<<QUI$V_SEARCH_PRINTER)	/* 0x20 */
#define QUI$M_SEARCH_SERVER		(1<<QUI$V_SEARCH_SERVER)	/* 0x40 */
#define QUI$M_SEARCH_TERMINAL		(1<<QUI$V_SEARCH_TERMINAL)	/* 0x80 */
#define QUI$M_SEARCH_GENERIC		(1<<QUI$V_SEARCH_GENERIC)	/* 0x0100 */
#define QUI$M_SEARCH_GENERIC_TARGET	(1<<QUI$V_SEARCH_GENERIC_TARGET) /* 0x0200 */
#define QUI$M_SEARCH_PENDING_JOBS	(1<<QUI$V_SEARCH_PENDING_JOBS)	/* 0x0400 */
#define QUI$M_SEARCH_EXECUTING_JOBS	(1<<QUI$V_SEARCH_EXECUTING_JOBS) /* 0x0800 */
#define QUI$M_SEARCH_TIMED_RELEASE_JOBS (1<<QUI$V_SEARCH_TIMED_RELEASE_JOBS) /* 0x1000 */
#define QUI$M_SEARCH_HOLDING_JOBS	(1<<QUI$V_SEARCH_HOLDING_JOBS)	/* 0x2000 */
#define QUI$M_SEARCH_RETAINED_JOBS	(1<<QUI$V_SEARCH_RETAINED_JOBS) /* 0x4000 */
#define QUI$M_SEARCH_FREEZE_CONTEXT	(1<<QUI$V_SEARCH_FREEZE_CONTEXT) /* 0x8000 */
struct qui$search_flags {
    unsigned qui$v_search_all_jobs	: 1;	/* select all jobs (else only those with same username as caller) */
    unsigned qui$v_search_wildcard	: 1;	/* force a wildcard operation */
    unsigned qui$v_search_batch		: 1;	/* select batch queues */
    unsigned qui$v_search_symbiont	: 1;	/* select symbiont (output) queues (note that QUI$V_SEARCH_SYMBIONT is equivalent */
 /*  to setting QUI$V_SEARCH_PRINTER, QUI$V_SEARCH_SERVER, and QUI$V_SEARCH_TERMINAL) */
    unsigned qui$v_search_this_job	: 1;	/* select only caller's batch job (forcing new context) */
    unsigned qui$v_search_printer	: 1;	/* select printer queues */
    unsigned qui$v_search_server	: 1;	/* select server queues */
    unsigned qui$v_search_terminal	: 1;	/* select terminal queues */
    unsigned qui$v_search_generic	: 1;	/* select generic queues */
    unsigned qui$v_search_generic_target: 1;	/* select generic target queues */
 /*  after selecting generic queue (for internal use) (note this option is NOT */
 /*  supported; it is intentionally not documented and reserved for Digital use) */
    unsigned qui$v_search_pending_jobs	: 1;	/* select only pending jobs */
    unsigned qui$v_search_executing_jobs: 1;	/* select only executing jobs */
    unsigned qui$v_search_timed_release_jobs : 1; /* select only timed release jobs */
    unsigned qui$v_search_holding_jobs	: 1;	/* select only holding jobs */
    unsigned qui$v_search_retained_jobs : 1;	/* select only retained jobs */
    unsigned qui$v_search_freeze_context: 1;	/* do not advance wildcard context to next object in list at end of operation */
    unsigned qui$v_filler		: 16;
};

/* Subfields of SYMBIONT_FLAGS item code. */
/* Note: this item code is intentionally not documented and reserved for Digital use. */
#define QUI$V_SYM_NOTIFIES		0
#define QUI$V_SYM_REQUESTS_OPER		1
#define QUI$V_SYM_COPIES_FILE		2
#define QUI$V_SYM_COPIES_JOB		3
#define QUI$V_SYM_ACCEPTS_ALL_FORMS	4
#define QUI$V_SYM_NO_JOB_CHECKPOINT	5
#define QUI$M_SYM_NOTIFIES		(1<<QUI$V_SYM_NOTIFIES)		/* 0x01 */
#define QUI$M_SYM_REQUESTS_OPER		(1<<QUI$V_SYM_REQUESTS_OPER)	/* 0x02 */
#define QUI$M_SYM_COPIES_FILE		(1<<QUI$V_SYM_COPIES_FILE)	/* 0x04 */
#define QUI$M_SYM_COPIES_JOB		(1<<QUI$V_SYM_COPIES_JOB)	/* 0x08 */
#define QUI$M_SYM_ACCEPTS_ALL_FORMS	(1<<QUI$V_SYM_ACCEPTS_ALL_FORMS) /* 0x10 */
#define QUI$M_SYM_NO_JOB_CHECKPOINT	(1<<QUI$V_SYM_NO_JOB_CHECKPOINT) /* 0x20 */
struct qui$symbiont_flags {
    unsigned qui$v_sym_notifies		: 1; /* symbiont notifies for job completions */
    unsigned qui$v_sym_requests_oper	: 1; /* symbiont generates operator messages */
    unsigned qui$v_sym_copies_file	: 1; /* symbiont generates multiple file copies */
    unsigned qui$v_sym_copies_job	: 1; /* symbiont generates multiple job copies */
    unsigned qui$v_sym_accepts_all_forms: 1; /* symbiont processes all form types */
    unsigned qui$v_sym_no_job_checkpoint: 1; /* always reprocess full job on a restart */
    unsigned qui$v_filler		: 26;
};

#ifndef NO_VMS_V6
/* Subfields of MANAGER_STATUS item code. */
#define QUI$V_MANAGER_START_PENDING	0
#define QUI$V_MANAGER_STARTING		1
#define QUI$V_MANAGER_RUNNING		2
#define QUI$V_MANAGER_FAILOVER		3
#define QUI$V_MANAGER_STOPPING		4
#define QUI$V_MANAGER_STOPPED		5
#define QUI$M_MANAGER_START_PENDING	(1<<QUI$V_MANAGER_START_PENDING) /* 0x01 */
#define QUI$M_MANAGER_STARTING		(1<<QUI$V_MANAGER_STARTING)	/* 0x02 */
#define QUI$M_MANAGER_RUNNING		(1<<QUI$V_MANAGER_RUNNING)	/* 0x04 */
#define QUI$M_MANAGER_FAILOVER		(1<<QUI$V_MANAGER_FAILOVER)	/* 0x08 */
#define QUI$M_MANAGER_STOPPING		(1<<QUI$V_MANAGER_STOPPING)	/* 0x10 */
#define QUI$M_MANAGER_STOPPED		(1<<QUI$V_MANAGER_STOPPED)	/* 0x20 */
struct qui$manager_status {
    unsigned qui$v_manager_start_pending: 1; /* queue manager will start when a node is available */
    unsigned qui$v_manager_starting	: 1; /* queue manager is starting */
    unsigned qui$v_manager_running	: 1; /* queue manager is processing work */
    unsigned qui$v_manager_failover	: 1; /* queue manager is failing over to pick up new startup values */
    unsigned qui$v_manager_stopping	: 1; /* queue manager is shutting down */
    unsigned qui$v_manager_stopped	: 1; /* queue manager is stopped */
    unsigned qui$v_filler		: 26;
};
#endif	/*!NO_VMS_V6*/

#endif	/*_QUIDEF_H*/
