/* <sjcdef.h>
 *
 *	Send to job controller service ($SNDJBC) definitions.
 */
#ifndef _SJCDEF_H
#define _SJCDEF_H

/* function codes */
#define SJC$_ABORT_JOB		1	/* abort current job in a queue */
#define SJC$_ADD_FILE		2	/* add a file to an open job */
#define SJC$_ALTER_JOB		3	/* alter parameters of a job */
#define SJC$_ALTER_QUEUE	4	/* alter parameters of a queue */
#define SJC$_ASSIGN_QUEUE	5	/* assign a logical queue to an execution queue */
#define SJC$_BATCH_CHECKPOINT	6	/* establish a checkpoint in a batch job */
#define SJC$_BATCH_SERVICE	7	/* LOGINOUT communication */
#define SJC$_CLOSE_DELETE	8	/* close and delete an open job */
#define SJC$_CLOSE_JOB		9	/* close and enqueue an open job */
#define SJC$_CREATE_JOB		10	/* create an open job */
#define SJC$_CREATE_QUEUE	11	/* create a queue */
#define SJC$_DEASSIGN_QUEUE	12	/* deassign a logical queue */
#define SJC$_DEFINE_CHARACTERISTIC 13	/* create a characteristic definition */
#define SJC$_DEFINE_FORM	14	/* create a form definition */
#define SJC$_DELETE_CHARACTERISTIC 15	/* delete a characteristic definition */
#define SJC$_DELETE_FORM	16	/* delete a form definition */
#define SJC$_DELETE_JOB		17	/* delete a job */
#define SJC$_DELETE_QUEUE	18	/* delete a queue */
#define SJC$_ENTER_FILE		19	/* enter a single file job in a queue */
#define SJC$_MERGE_QUEUE	20	/* requeue all jobs in one queue to another */
#define SJC$_PAUSE_QUEUE	21	/* suspend processing from a queue */
#define SJC$_RESET_QUEUE	22	/* reset a queue */
#define SJC$_START_ACCOUNTING	23	/* start accounting manager */
#define SJC$_START_QUEUE	24	/* start processing from a queue */
#define SJC$_START_QUEUE_MANAGER 25	/* start system job queue manager */
#define SJC$_STOP_ACCOUNTING	26	/* stop accounting manager */
#define SJC$_STOP_QUEUE		27	/* stop processing from a queue */
#define SJC$_STOP_QUEUE_MANAGER 28	/* stop system job queue manager */
#define SJC$_SYNCHRONIZE_JOB	29	/* synchronize with job completion */
#define SJC$_WRITE_ACCOUNTING	30	/* write user accounting record */
#define SJC$_CONTROL_DIAGNOSTICS 31	/* control diagnostic functions (for internal use only) */
 /* (note this function code is intentionally not documented and reserved for digital use) */
#define SJC$_DELETE_QUEUE_MANAGER 32	/* remove all references to specified qmgr from shared master file */
#define SJC$_ALTER_FILE		33	/* modify the processing of a file within a job */
#define SJC$_STOP_ALL_QUEUES_ON_NODE 34 /* stop all batch/print job processing on the node */
#define SJC$_DISABLE_QUEUE	35	/* cause all QSIs on the queue to be inactive */
#define SJC$_ENABLE_QUEUE	36	/* allow disabled queue to be restarted */
#define SJC$_SYMBIONT_SERVICE	37	/* Symbiont-Qman communication */
#define SJC$_JOBCTL_SERVICE	38	/* Jobctl-Qman communication */
#define SJC$_ENABLE_AUTOSTART	39	/* start all AUTOSTART queues on node and allow queues to fail over to node */
#define SJC$_DISABLE_AUTOSTART	40	/* Prevent AUTOSTART queues from failing over to this node */
#define SJC$_SHUTDOWN_NODE	41	/* Perform orderly shutdown of queuing system on node */
#define SJC$_RESERVED_FUNC_41	41	/* obsolete name */
#define SJC$_RESERVED_FUNC_42	42	/* reserved for Digital use */
#define SJC$_RESERVED_FUNC_43	43	/* reserved */
#define SJC$_RESERVED_FUNC_44	44	/* reserved */
#define SJC$_RESERVED_FUNC_45	45	/* reserved */
#define SJC$_RESERVED_FUNC_46	46	/* reserved */
#define SJC$_RESERVED_FUNC_47	47	/* reserved */
#define SJC$_RESERVED_FUNC_48	48	/* reserved */
#define SJC$_RESERVED_FUNC_49	49	/* reserved */
#define SJC$_RESERVED_FUNC_50	50	/* reserved */
#define SJC$K_MIN_FUNC	1	/* minimum SNDJBC function code */
#define SJC$K_MAX_FUNC	50	/* maximum SNDJBC function code */

/* item codes */
#define SJC$_ACCOUNTING_MESSAGE 1	/* user accounting message */
#define SJC$_ACCOUNTING_TYPES	2	/* mask of accounting record types */
#define SJC$_AFTER_TIME		3	/* hold until time */
#define SJC$_NO_AFTER_TIME	4
#define SJC$_ALIGNMENT_MASK	5	/* mask alignment data */
#define SJC$_ALIGNMENT_PAGES	6	/* number of alignment pages */
#define SJC$_BASE_PRIORITY	7	/* batch process base priority */
#define SJC$_BATCH		8	/* batch queue */
#define SJC$_NO_BATCH		9
/* SERVICE item codes are used for communications with LOGINOUT, symbionts, and jobctl. */
#define SJC$_SERVICE_INPUT	10
#define SJC$_SERVICE_OUTPUT	11
#define SJC$_BATCH_INPUT	10	/* LOGINOUT communication (retired, see SERVICE_INPUT) */
#define SJC$_BATCH_OUTPUT	11	/* for use by LOGINOUT (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_CHARACTERISTIC_NAME 12	/* printer characteristic */
#define SJC$_CHARACTERISTIC_NUMBER 13
#define SJC$_NO_CHARACTERISTICS 14
#define SJC$_CHECKPOINT_DATA	15	/* batch checkpoint string */
#define SJC$_NO_CHECKPOINT_DATA 16
#define SJC$_CLI		17	/* batch process CLI */
#define SJC$_NO_CLI		18
#define SJC$_CPU_DEFAULT	19	/* default CPU time limit */
#define SJC$_NO_CPU_DEFAULT	20
#define SJC$_CPU_LIMIT		21	/* maximum CPU time limit */
#define SJC$_NO_CPU_LIMIT	22
#define SJC$_CREATE_START	23	/* start queue after creation */
#define SJC$_DELETE_FILE	24	/* delete file after processing */
#define SJC$_NO_DELETE_FILE	25
#define SJC$_DESTINATION_QUEUE	26	/* destination queue name */
#define SJC$_DEVICE_NAME	27	/* output device name */
#define SJC$_DOUBLE_SPACE	28	/* double space output */
#define SJC$_NO_DOUBLE_SPACE	29
#define SJC$_ENTRY_NUMBER	30	/* job entry number */
#define SJC$_ENTRY_NUMBER_OUTPUT 31
#define SJC$_FILE_BURST		32	/* print file burst page */
#define SJC$_FILE_BURST_ONE	33
#define SJC$_NO_FILE_BURST	34
#define SJC$_FILE_COPIES	35	/* print n copies of file */
#define SJC$_FILE_FLAG		36	/* print file flag page */
#define SJC$_FILE_FLAG_ONE	37
#define SJC$_NO_FILE_FLAG	38
#define SJC$_FILE_IDENTIFICATION 39	/* DVI, FID, DID of file */
#define SJC$_FILE_SETUP_MODULES 40	/* device control modules for file */
#define SJC$_NO_FILE_SETUP_MODULES 41
#define SJC$_FILE_SPECIFICATION 42	/* file specification of file */
#define SJC$_FILE_TRAILER	43	/* print file trailer page */
#define SJC$_FILE_TRAILER_ONE	44
#define SJC$_NO_FILE_TRAILER	45
#define SJC$_FIRST_PAGE		46	/* starting page number */
#define SJC$_NO_FIRST_PAGE	47
#define SJC$_FORM_DESCRIPTION	48	/* textual description of form */
#define SJC$_FORM_LENGTH	49	/* form length in lines */
#define SJC$_FORM_MARGIN_BOTTOM 50	/* form bottom margin in lines */
#define SJC$_FORM_MARGIN_LEFT	51	/* form left margin in characters */
#define SJC$_FORM_MARGIN_RIGHT	52	/* form right margin in characters */
#define SJC$_FORM_MARGIN_TOP	53	/* form top margin in lines */
#define SJC$_FORM_NAME		54	/* printer form */
#define SJC$_FORM_NUMBER	55
#define SJC$_FORM_SETUP_MODULES 56	/* device control modules for form */
#define SJC$_NO_FORM_SETUP_MODULES 57
#define SJC$_FORM_SHEET_FEED	58	/* form is sheet fed */
#define SJC$_NO_FORM_SHEET_FEED 59
#define SJC$_FORM_STOCK		60	/* stock name for form */
#define SJC$_FORM_TRUNCATE	61	/* truncate long lines */
#define SJC$_NO_FORM_TRUNCATE	62
#define SJC$_FORM_WIDTH		63	/* form width in characters */
#define SJC$_FORM_WRAP		64	/* wrap long lines */
#define SJC$_NO_FORM_WRAP	65
#define SJC$_GENERIC_QUEUE	66	/* queue is a generic queue */
#define SJC$_NO_GENERIC_QUEUE	67
#define SJC$_GENERIC_SELECTION	68	/* queue can take work from generic queue */
#define SJC$_NO_GENERIC_SELECTION 69
#define SJC$_GENERIC_TARGET	70	/* possible execution queue for generic queue */
#define SJC$_HOLD		71	/* place job on hold */
#define SJC$_NO_HOLD		72
#define SJC$_JOB_BURST		73	/* print job burst page */
#define SJC$_NO_JOB_BURST	74
#define SJC$_JOB_COPIES		75	/* print n copies of entire job */
#define SJC$_JOB_FLAG		76	/* print job flag page */
#define SJC$_NO_JOB_FLAG	77
#define SJC$_JOB_LIMIT		78	/* number of concurrent jobs */
#define SJC$_JOB_NAME		79	/* identifying name of job */
#define SJC$_JOB_RESET_MODULES	80	/* device control modules between jobs */
#define SJC$_NO_JOB_RESET_MODULES 81
#define SJC$_JOB_SIZE_MAXIMUM	82	/* largest job accepted by printer */
#define SJC$_NO_JOB_SIZE_MAXIMUM 83
#define SJC$_JOB_SIZE_MINIMUM	84	/* smallest job accepted by printer */
#define SJC$_NO_JOB_SIZE_MINIMUM 85
#define SJC$_JOB_SIZE_SCHEDULING 86	/* schedule printer queues by size */
#define SJC$_NO_JOB_SIZE_SCHEDULING 87
#define SJC$_JOB_STATUS_OUTPUT	88	/* status message for submitted job */
#define SJC$_JOB_TRAILER	89	/* print job trailer page */
#define SJC$_NO_JOB_TRAILER	90
#define SJC$_LAST_PAGE		91	/* ending page number */
#define SJC$_NO_LAST_PAGE	92
#define SJC$_LIBRARY_SPECIFICATION 93	/* filename of device control library */
#define SJC$_NO_LIBRARY_SPECIFICATION 94
#define SJC$_LOG_DELETE		95	/* delete log file */
#define SJC$_NO_LOG_DELETE	96
#define SJC$_LOG_QUEUE		97	/* log file's print queue */
#define SJC$_LOG_SPECIFICATION	98	/* file specification of log file */
#define SJC$_NO_LOG_SPECIFICATION 99
#define SJC$_LOG_SPOOL		100	/* print log file */
#define SJC$_NO_LOG_SPOOL	101
#define SJC$_LOWERCASE		102	/* print on lowercase printer */
#define SJC$_NO_LOWERCASE	103
#define SJC$_NEW_VERSION	104	/* create new version of file */
#define SJC$_NEXT_JOB		105	/* resume at next job */
#define SJC$_NOTE		106	/* flag page note text */
#define SJC$_NO_NOTE		107
#define SJC$_NOTIFY		108	/* notify user on job completion */
#define SJC$_NO_NOTIFY		109	/* don't notify user on completion (for jobs) */
					/* don't notify user on interruption (for print queues) */
#define SJC$_OPERATOR_REQUEST	110	/* operator service text */
#define SJC$_NO_OPERATOR_REQUEST 111
#define SJC$_OWNER_UIC		112	/* queue owner UIC */
#define SJC$_PAGE_HEADER	113	/* print page headers */
#define SJC$_NO_PAGE_HEADER	114
#define SJC$_PAGE_SETUP_MODULES 115	/* device control modules for form page */
#define SJC$_NO_PAGE_SETUP_MODULES 116
#define SJC$_PAGINATE		117	/* paginate output with free form feeds */
#define SJC$_NO_PAGINATE	118
#define SJC$_PARAMETER_1	119	/* batch job parameters */
#define SJC$_PARAMETER_2	120
#define SJC$_PARAMETER_3	121
#define SJC$_PARAMETER_4	122
#define SJC$_PARAMETER_5	123
#define SJC$_PARAMETER_6	124
#define SJC$_PARAMETER_7	125
#define SJC$_PARAMETER_8	126
#define SJC$_NO_PARAMETERS	127
#define SJC$_PASSALL		128	/* print file passall */
#define SJC$_NO_PASSALL		129
#define SJC$_PRIORITY		130	/* job scheduling priority */
#define SJC$_PROCESSOR		131	/* filename of symbiont image */
#define SJC$_NO_PROCESSOR	132
#define SJC$_PROTECTION		133	/* queue protection mask */
#define SJC$_QUEUE		134	/* queue on which to operate */
#define SJC$_QUEUE_FILE_SPECIFICATION 135 /* file specification of queue file */
#define SJC$_QUEUE_DIRECTORY	135	/* disk & directory for non-shared job queue database */
#define SJC$_RELATIVE_PAGE	136	/* resume after forward or back space */
#define SJC$_REQUEUE		137	/* requeue job */
#define SJC$_RESTART		138	/* job can restart */
#define SJC$_NO_RESTART		139
#define SJC$_RETAIN_ALL_JOBS	140	/* retain completed jobs */
#define SJC$_RETAIN_ERROR_JOBS	141
#define SJC$_NO_RETAIN_JOBS	142
#define SJC$_SCSNODE_NAME	143	/* node name of execution node */
#define SJC$_SEARCH_STRING	144	/* resume after finding string */
#define SJC$_SWAP		145	/* swap batch processes */
#define SJC$_NO_SWAP		146
#define SJC$_TERMINAL		147	/* queue is a (generic) terminal queue */
#define SJC$_NO_TERMINAL	148
#define SJC$_TOP_OF_FILE	149	/* resume at top of file */
#define SJC$_USER_IDENTIFICATION 150	/* proxy user identification (not supported and is obsolete) */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_WSDEFAULT		151	/* working set default */
#define SJC$_NO_WSDEFAULT	152
#define SJC$_WSEXTENT		153	/* working set extent */
#define SJC$_NO_WSEXTENT	154
#define SJC$_WSQUOTA		155	/* working set quota */
#define SJC$_NO_WSQUOTA		156
#define SJC$_ACCOUNT_NAME	157	/* proxy account name (requires CMKRNL privilege) */
#define SJC$_CHARGE_CODE	157	/* synonym for SJC$_ACCOUNT_NAME */
#define SJC$_UIC		158	/* proxy UIC (requires CMKRNL privilege) */
#define SJC$_USERNAME		159	/* proxy username (requires CMKRNL privilege) */
#define SJC$_BUFFER_COUNT	160	/* multibuffer count for queue file */
#define SJC$_EXTEND_QUANTITY	161	/* allocation and extend quantity for queue file */
#define SJC$_RECORD_BLOCKING	162	/* symbiont record blocking of output stream */
#define SJC$_NO_RECORD_BLOCKING 163
#define SJC$_QUEMAN_RESTART	164	/* qualifier on SJC$_START_QUEUE_MANAGER, restart queue manager after an abort */
#define SJC$_NO_QUEMAN_RESTART	165
#define SJC$_DEFAULT_FORM_NAME	166	/* default queue form name */
#define SJC$_DEFAULT_FORM_NUMBER	167	/* default queue form number */
#define SJC$_SECURITY_CLASSIFICATION	168	/* used by SeVMS to specify security classification of the job */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_QUEUE_SUPPORT		169	/* queue support images */
#define SJC$_JOB_COMPLETION_STATUS	170	/* status of completed job -- used instead of IOSB when specified */
#define SJC$_RESERVED_OUTPUT_170	170	/* obsolete name */
#define SJC$_DIAGNOSTIC_BUFFER_OUTPUT	171	/* job controller's in-memory diagnostic buffer (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_OPEN_QUEUE			172	/* open queue - allow job submission */
#define SJC$_CLOSE_QUEUE		173	/* close queue - do not allow job submission */
#define SJC$_SERVER			174	/* server queue */
#define SJC$_PRINTER			175	/* printer queue */
#define SJC$_UPDATE_ORB			176	/* update ORB information in queue file (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_NO_QUEUE_DESCRIPTION	177	/* no queue description supplied */
#define SJC$_JOB_RETAIN			178	/* retain this job */
#define SJC$_JOB_ERROR_RETAIN		179	/* retain this job on error */
#define SJC$_JOB_DEFAULT_RETAIN		180	/* use queue's job retention setting */
#define SJC$_NOTIFY_ON_INTERRUPT	181	/* notify users if their print jobs are interrupted */
#define SJC$_RESERVED_BOOLEAN_182	182	/* reserved for Digital use */
#define SJC$_ACCEPT_ALL_ATTRIBUTES	183	/* inhibits queue manager validation of QSI keywords */
#define SJC$_DIAGNOSTIC_FLAGS		184	/* diagnostic flags bitmask (for internal use only) */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_QUEUE_DESCRIPTION		185	/* queue description */
#define SJC$_CHECKPOINT_FREQUENCY	186	/* symbiont takes checkpoint at intervals of this many pages */
#define SJC$_RESERVED_INPUT_187		187	/* for DQS only */
#define SJC$_DISPLAY_USERNAME		187	/* used by DQS to pass a username to the remote system */
 /* (note this item code is intentionally not documented and reserved for digital use) */
#define SJC$_FILE_NUMBER		188	/* file sequence number within job */
#define SJC$_FILE_ATTRIBUTE		189	/* "keyword = (optional) value" for extensible attrib on file */
#define SJC$_JOB_ATTRIBUTE		190	/* "keyword = (optional) value" for extensible attrib on job */
#define SJC$_QUEUE_ATTRIBUTE		191	/* "keyword = (optional) value" for extensible attrib on queue */
#define SJC$_REMOVE_ATTRIBUTE		192	/* remove extensible attribs for queue, job, or file */
#define SJC$_QUEUE_MANAGER_NAME		193	/* queue manager process */
#define SJC$_QUEUE_MANAGER_NODES	194	/* failover list of nodes on which queue manager process may run */
#define SJC$_AUTOSTART_ON		195	/* node(s) (and for print queues, device(s)) on which queue can be auto started */
#define SJC$_RESERVED_OUTPUT_196	196	/* reserved for Digital use */
#define SJC$_RESERVED_OUTPUT_197	197	/* reserved for Digital use */
#define SJC$_RESERVED_OUTPUT_198	198	/* reserved for Digital use */
#define SJC$_RESERVED_OUTPUT_199	199	/* reserved for Digital use */
#define SJC$_SET_CONDITION_VECTOR	200	/* QSI can alter job's completion status */
#define SJC$_NOTIFY_MESSAGE		201	/* QSI check job can replace job completion message sent to user */
#define SJC$_DEFINE_FILE_ATTRIBUTES	202	/* legal keywds for file submissions or alter_file's */
#define SJC$_DEFINE_JOB_ATTRIBUTES	203	/* legal keywds in oper'ns that create or alter jobs */
#define SJC$_DEFINE_QUEUE_ATTRIBUTES	204	/* legal keywords in operations that alter the queue */
#define SJC$_AGENT_PROFILE		205	/* security information */
#define SJC$_ADD_QUEUE_MANAGER		206	/* boolean item code telling sjc_start_queue_manager to add a new database */
#define SJC$_OUTSTANDING_JOBS		207	/* boolean item code telling queue manager to not delete outstanding open jobs */
#define SJC$_RESERVED_BOOLEAN_206	206
#define SJC$_RESERVED_BOOLEAN_207	207
#define SJC$_RESERVED_BOOLEAN_208	208	/* reserved for Digital use */
#define SJC$_RESERVED_BOOLEAN_209	209	/* reserved */
#define SJC$_RESERVED_BOOLEAN_210	210	/* reserved */
#define SJC$_RESERVED_BOOLEAN_211	211	/* reserved */
#define SJC$_RESERVED_BOOLEAN_212	212	/* reserved */
#define SJC$_RESERVED_BOOLEAN_213	213	/* reserved */
#define SJC$_RESERVED_BOOLEAN_214	214	/* reserved */
#define SJC$_RESERVED_BOOLEAN_215	215	/* reserved */
#define SJC$_RESERVED_BOOLEAN_216	216	/* reserved */
#define SJC$_RESERVED_BOOLEAN_217	217	/* reserved */
#define SJC$_RESERVED_BOOLEAN_218	218	/* reserved */
#define SJC$_RESERVED_BOOLEAN_219	219	/* reserved */
#define SJC$_RESERVED_BOOLEAN_220	220	/* reserved */
#define SJC$_RESERVED_BOOLEAN_221	221	/* reserved */
#define SJC$_RESERVED_BOOLEAN_222	222	/* reserved */
#define SJC$_RESERVED_BOOLEAN_223	223	/* reserved */
#define SJC$_RESERVED_BOOLEAN_224	224	/* reserved */
#define SJC$_RESERVED_BOOLEAN_225	225	/* reserved */
#define SJC$_RESERVED_BOOLEAN_226	226	/* reserved */
#define SJC$_RESERVED_BOOLEAN_227	227	/* reserved */
#define SJC$_RESERVED_BOOLEAN_228	228	/* reserved */
#define SJC$_RESERVED_BOOLEAN_229	229	/* reserved */
#define SJC$_RESERVED_BOOLEAN_230	230	/* reserved */
#define SJC$_RESERVED_BOOLEAN_231	231	/* reserved */
#define SJC$_RESERVED_BOOLEAN_232	232	/* reserved */
#define SJC$_RESERVED_BOOLEAN_233	233	/* reserved */
#define SJC$_RESERVED_BOOLEAN_234	234	/* reserved */
#define SJC$_JOB_RETAIN_TIME		235	/* the time the job should be retained (delta or absolute) */
#define SJC$_MANAGER_ATTRIBUTE		236	/* any application specific queue manager attributes */
#define SJC$_RESERVED_INPUT_236		236
#define SJC$_RESERVED_INPUT_237		237	/* reserved for Digital use */
#define SJC$_RESERVED_INPUT_238		238	/* reserved */
#define SJC$_RESERVED_INPUT_239		239	/* reserved */
#define SJC$_RESERVED_INPUT_240		240	/* reserved */
#define SJC$_RESERVED_INPUT_241		241	/* reserved */
#define SJC$_RESERVED_INPUT_242		242	/* reserved */
#define SJC$_RESERVED_INPUT_243		243	/* reserved */
#define SJC$_RESERVED_INPUT_244		244	/* reserved */
#define SJC$_RESERVED_INPUT_245		245	/* reserved */
#define SJC$_RESERVED_INPUT_246		246	/* reserved */
#define SJC$_RESERVED_INPUT_247		247	/* reserved */
#define SJC$_RESERVED_INPUT_248		248	/* reserved */
#define SJC$_RESERVED_INPUT_249		249	/* reserved */
#define SJC$_RESERVED_INPUT_250		250	/* reserved */
#define SJC$_RESERVED_OUTPUT_251	251	/* reserved */
#define SJC$_RESERVED_OUTPUT_252	252	/* reserved */
#define SJC$_RESERVED_OUTPUT_253	253	/* reserved */
#define SJC$_RESERVED_OUTPUT_254	254	/* reserved */
#define SJC$_RESERVED_OUTPUT_255	255	/* reserved */
#define SJC$K_MIN_ITEM	1	/* minimum SNDJBC item code */
#define SJC$K_MAX_ITEM	255	/* maximum SNDJBC item code */

/* Subfields of accounting_types item code.  these definitions must track exe$gl_acmflags. */
#define SJC$V_ACCT_PROCESS	0
#define SJC$V_ACCT_IMAGE	1
#define SJC$V_ACCT_INTERACTIVE	2
#define SJC$V_ACCT_LOGIN_FAILURE 3
#define SJC$V_ACCT_SUBPROCESS	4
#define SJC$V_ACCT_DETACHED	5
#define SJC$V_ACCT_BATCH	6
#define SJC$V_ACCT_NETWORK	7
#define SJC$V_ACCT_PRINT	8
#define SJC$V_ACCT_MESSAGE	9
#define SJC$V_ACCT_ACM_FUNC	10
#define SJC$V_ACCT_ACM_SYS	11
#define SJC$V_ACCT_CCAENAB	12
#define SJC$V_ACCT_CCVENAB	13
#define SJC$M_ACCT_PROCESS	(1<<SJC$V_ACCT_PROCESS)		/* 0x01 */
#define SJC$M_ACCT_IMAGE	(1<<SJC$V_ACCT_IMAGE)		/* 0x02 */
#define SJC$M_ACCT_INTERACTIVE	(1<<SJC$V_ACCT_INTERACTIVE)	/* 0x04 */
#define SJC$M_ACCT_LOGIN_FAILURE (1<<SJC$V_ACCT_LOGIN_FAILURE)	/* 0x08 */
#define SJC$M_ACCT_SUBPROCESS	(1<<SJC$V_ACCT_SUBPROCESS)	/* 0x10 */
#define SJC$M_ACCT_DETACHED	(1<<SJC$V_ACCT_DETACHED)	/* 0x20 */
#define SJC$M_ACCT_BATCH	(1<<SJC$V_ACCT_BATCH)		/* 0x40 */
#define SJC$M_ACCT_NETWORK	(1<<SJC$V_ACCT_NETWORK)		/* 0x80 */
#define SJC$M_ACCT_PRINT	(1<<SJC$V_ACCT_PRINT)		/* 0x0100 */
#define SJC$M_ACCT_MESSAGE	(1<<SJC$V_ACCT_MESSAGE)		/* 0x0200 */
#define SJC$M_ACCT_ACM_FUNC	(1<<SJC$V_ACCT_ACM_FUNC)	/* 0x0400 */
#define SJC$M_ACCT_ACM_SYS	(1<<SJC$V_ACCT_ACM_SYS)		/* 0x0800 */
#define SJC$M_ACCT_CCAENAB	(1<<SJC$V_ACCT_CCAENAB)		/* 0x1000 */
#define SJC$M_ACCT_CCVENAB	(1<<SJC$V_ACCT_CCVENAB)		/* 0x2000 */
struct sjc$accounting_types {
    unsigned sjc$v_acct_process    : 1; /* process termination */
    unsigned sjc$v_acct_image	   : 1; /* image termination */
    unsigned sjc$v_acct_interactive: 1; /* interactive processes */
    unsigned sjc$v_acct_login_failure : 1; /* login failures */
    unsigned sjc$v_acct_subprocess : 1; /* subprocesses */
    unsigned sjc$v_acct_detached   : 1; /* detached processes */
    unsigned sjc$v_acct_batch	   : 1; /* batch processes */
    unsigned sjc$v_acct_network    : 1; /* network processes */
    unsigned sjc$v_acct_print	   : 1; /* print job termination */
    unsigned sjc$v_acct_message    : 1; /* user messages */
    unsigned sjc$v_acct_acm_func   : 1; /* acm function */
    unsigned sjc$v_acct_acm_sys    : 1; /* system function */
    unsigned sjc$v_acct_ccaenab    : 1; /* charge code accounting */
    unsigned sjc$v_acct_ccvenab    : 1; /* charge code validation */
    unsigned sjc$v_acct_unused	   : 18;
};

/* Subfields of diagnostic_flags item code. */
#define SJC$V_DIAG_COPY_QF		0
#define SJC$V_DIAG_CREATE_MF		1
#define SJC$V_DIAG_CLOSE_MF		2
#define SJC$V_DIAG_OPEN_MF		3
#define SJC$V_DIAG_CLEAR_FLAGS		4
#define SJC$V_DIAG_LOG_ALL_TRANS	5
#define SJC$V_DIAG_JOURNAL_PUTS		6
#define SJC$V_DIAG_DUMP_DIAG_BUFFER	7
#define SJC$V_DIAG_INIT_DIAG_BUFFER	8
#define SJC$M_DIAG_COPY_QF	    (1<<SJC$V_DIAG_COPY_QF)	     /* 0x01 */
#define SJC$M_DIAG_CREATE_MF	    (1<<SJC$V_DIAG_CREATE_MF)	     /* 0x02 */
#define SJC$M_DIAG_CLOSE_MF	    (1<<SJC$V_DIAG_CLOSE_MF)	     /* 0x04 */
#define SJC$M_DIAG_OPEN_MF	    (1<<SJC$V_DIAG_OPEN_MF)	     /* 0x08 */
#define SJC$M_DIAG_CLEAR_FLAGS	    (1<<SJC$V_DIAG_CLEAR_FLAGS)      /* 0x10 */
#define SJC$M_DIAG_LOG_ALL_TRANS    (1<<SJC$V_DIAG_LOG_ALL_TRANS)    /* 0x20 */
#define SJC$M_DIAG_JOURNAL_PUTS     (1<<SJC$V_DIAG_JOURNAL_PUTS)     /* 0x40 */
#define SJC$M_DIAG_DUMP_DIAG_BUFFER (1<<SJC$V_DIAG_DUMP_DIAG_BUFFER) /* 0x80 */
#define SJC$M_DIAG_INIT_DIAG_BUFFER (1<<SJC$V_DIAG_INIT_DIAG_BUFFER) /* 0x0100 */
struct sjc$diagnostic_flags {
    unsigned sjc$v_diag_copy_qf      : 1; /* make copy of the queue file */
    unsigned sjc$v_diag_create_mf    : 1; /* create new monitor log file and begin monitoring */
    unsigned sjc$v_diag_close_mf     : 1; /* stop monitoring and close monitor log file */
    unsigned sjc$v_diag_open_mf      : 1; /* open existing monitor log file and resume monitoring */
    unsigned sjc$v_diag_clear_flags  : 1; /* clear monitoring flags in queue file header record */
    unsigned sjc$v_diag_log_all_trans: 1; /* log read-only transactions in addition to basic monitoring */
    unsigned sjc$v_diag_journal_puts : 1; /* journal queue file $PUT operations in addition to basic monitoring */
    unsigned sjc$v_diag_dump_diag_buffer : 1; /* return contents of diagnostic buffer to caller */
    unsigned sjc$v_diag_init_diag_buffer : 1; /* initialize diagnostic buffer and zero cumulative counters */
    unsigned sjc$v_diag_unused	     : 23;
};

#endif	/*_SJCDEF_H*/
