/* Ported to GNU C openVMS/Alpha by Klaus Kmpf, kkaempf@progis.de  */
/* <sys$routines.h>
 *
 *	System Service routines from Starlet.
 */
#ifndef _SYS$ROUTINES_H
#define _SYS$ROUTINES_H
# ifdef __cplusplus
extern "C" {
# endif
	/* part of <starlet.h> */

/*  $ABORT_TRANS[W]    Abort a transaction */
/*	$ABORT_TRANS[W]  [efn], [flags], iosb [, [astadr], [astprm], */
/*			 [tid], [reason], [bid]] */
#define sys$abort_trans SYS$ABORT_TRANS
unsigned long sys$abort_trans(), sys$abort_transw();
/*  $ACK_EVENT		acknowledge a resource manager transaction event */
/*	$ACK_EVENT [flags],report_id,report_reply,[,[reason],[beftime], -*/
/*+		   [afttime],[part_name],[rm_context],[timout]]		 */
#define sys$ack_event SYS$ACK_EVENT
unsigned long sys$ack_event();
/* $ADD_BRANCH[W]	add a transaction branch */
/*	$ADD_BRANCH[W] [efn],[flags],iosb,[astadr],[astprm],tid,tm_name,bid */
#define sys$add_branch SYS$ADD_BRANCH
unsigned long sys$add_branch(), sys$add_branchw();
/*  $ADD_HOLDER		add holder record to the rights database */
/*	$ADD_HOLDER id,holder,[attrib] */
#define sys$add_holder SYS$ADD_HOLDER
unsigned long sys$add_holder();
/*  $ADD_IDENT		add identifier to the rights database */
/*	$ADD_IDENT name,[id],[attrib],[resid] */
#define sys$add_ident SYS$ADD_IDENT
unsigned long sys$add_ident();
/*  $ADJSTK		adjust outer mode stack pointer */
/*	$ADJSTK [acmode],[adjust],newadr */
#define sys$adjstk SYS$ADJSTK
unsigned long sys$adjstk();
/*  $ADD_PROXY		add proxy record */
/*	$ADD_PROXY rem_node,rem_user,local_user,[flags] */
#define sys$add_proxy SYS$ADD_PROXY
unsigned long sys$add_proxy();
/*  $ADJWSL		adjust working set limit */
/*	$ADJWSL [pagcnt],[wsetlm] */
#define sys$adjwsl SYS$ADJWSL
unsigned long sys$adjwsl();
/*  $ALLOC		allocate device */
/*	$ALLOC devnam,[phylen],[phybuf],[acmode],[flags] */
#define sys$alloc SYS$ALLOC
unsigned long sys$alloc();
/*  $ASCEFC		associate common event flag cluster */
/*	$ASCEFC efn,name,[prot],[perm] */
#define sys$ascefc SYS$ASCEFC
unsigned long sys$ascefc();
/*  $ASCTIM		convert binary time to ASCII string */
/*	$ASCTIM [timlen],timbuf,[timadr],[cvtflg] */
#define sys$asctim SYS$ASCTIM
unsigned long sys$asctim();
/*  $ASCTOID		ASCII to identifier conversion */
/*	$ASCTOID name,[id],[attrib] */
#define sys$asctoid SYS$ASCTOID
unsigned long sys$asctoid();
/*  $ASCUTC		convert binary UTC time into ASCII time string */
/*	$ASCUTC [timlen],timbuf,[utcadr(octaword!)],[cvtflg] */
#define sys$ascutc SYS$ASCUTC
unsigned long sys$ascutc();
/*  $ASSIGN		assign I/O channel */
/*	$ASSIGN devnam,chan,[acmode],[mbxnam][,[flags]] */
#define sys$assign SYS$ASSIGN
unsigned long sys$assign();
/*  $AUDIT_EVENT	audit security relevant event */
/*	$AUDIT_EVENT[W] [efn],[flags],itmlst,[audsts],[astadr],[astprm] */
#define sys$audit_event SYS$AUDIT_EVENT
unsigned long sys$audit_event(), sys$audit_eventw();
/*  $BINTIM		convert ASCII string to binary time */
/*	$BINTIM timbuf,timadr */
#define sys$bintim SYS$BINTIM
unsigned long sys$bintim();
/*  $BINUTC		convert ASCII UTC time to a binary format */
/*	$BINUTC timbuf,utcadr(octaword!) */
#define sys$binutc SYS$BINUTC
unsigned long sys$binutc();
/*  $BRDCST		broadcast (obsolete -- use $brkthru[w]) */
/*	$BRDCST msgbuf,[devnam] */
#define sys$brdcst SYS$BRDCST
unsigned long sys$brdcst();
/*  $BRKTHRU		write to terminal breakthru */
/*	$BRKTHRU[W] [efn],msgbuf,[sendto],[sndtyp],[iosb],		-*/
/*+		    [carcon],[flags],[reqid],[timout],[astadr],[astprm]  */
#define sys$brkthru SYS$BRKTHRU
unsigned long sys$brkthru(), sys$brkthruw();
/*  $CANCEL		cancel I/O on channel */
/*	$CANCEL chan */
#define sys$cancel SYS$CANCEL
unsigned long sys$cancel();
/*  $CANCEL_SELECTIVE	selective cancel I/O on channel */
/*	$CANCEL_SELECTIVE chan,[iosblst],[lenlst] */
#define sys$cancel_selective SYS$CANCEL_SELECTIVE
unsigned long sys$cancel_selective();
/*  $CANEVTAST		cancel an event AST routine */
/*	$CANEVTAST [evtnam],[evtadr],[evtfac],[acmode],[flags],[reqid],[evtid] */
#define sys$canevtast SYS$CANEVTAST
unsigned long sys$canevtast();
/*  $CANEXH		cancel exit handler */
/*	$CANEXH [desblk] */
#define sys$canexh SYS$CANEXH
unsigned long sys$canexh();
/*  $CANRNH		cancel restart handler */
/*	$CANRNH [desblk] */
#define sys$canrnh SYS$CANRNH
unsigned long sys$canrnh();
/*  $CANTIM		cancel timer request */
/*	$CANTIM [reqidt],[acmode] */
#define sys$cantim SYS$CANTIM
unsigned long sys$cantim();
/*  $CANWAK		cancel wakeup */
/*	$CANWAK [pidadr],[prcnam] */
#define sys$canwak SYS$CANWAK
unsigned long sys$canwak();
/*  $CHANGE_ACL		set or modify an object's ACL */
/*	$CHANGE_ACL [chan],objtyp,[objnam],itmlst,[acmode],[iosb],	-*/
/*+		    [contxt],[routin],[orbadr]				 */
#define sys$change_acl SYS$CHANGE_ACL
unsigned long sys$change_acl();
/*  $CHANGE_CLASS	modify an objects access class */
/*	$CHANGE_CLASS objtyp,[objnam],itmlst,[acmode],[orbadr] */
#define sys$change_class SYS$CHANGE_CLASS
unsigned long sys$change_class();
/*  $CHECK_ACCESS	check user access to an object */
/*	$CHECK_ACCESS [objtyp],[objnam],[usrnam],itmlst,[contxt(orbadr)],[clsnam],[objpro],[usrpro] */
#define sys$check_access SYS$CHECK_ACCESS
unsigned long sys$check_access();
/*  $CHECK_PRIVILEGE[W] check for process privilege and perform security audit */
/*	$CHECK_PRIVILEGE[W] [efn],prvadr,[altprv],[flags],[itmlst],[audsts],[astadr],[astprm] */
#define sys$check_privilege SYS$CHECK_PRIVILEGE
unsigned long sys$check_privilege(), sys$check_privilegew();
/*  $CHKPRO		check access protection */
/*	$CHKPRO itmlst [,[objpro],[usrpro]] */
#define sys$chkpro SYS$CHKPRO
unsigned long sys$chkpro();
/*  $CLRCLUEVT		clear cluster event notification */
/*     $CLRCLUEVT [handle],[acmode],[event] */
#define sys$clrcluevt SYS$CLRCLUEVT
unsigned long sys$clrcluevt();
/*  $CLREF		clear event flag */
/*	$CLREF	efn */
#define sys$clref SYS$CLREF
unsigned long sys$clref();
/*  $CMEXEC		change to executive mode */
/*	$CMEXEC routin,[arglst] */
#define sys$cmexec SYS$CMEXEC
unsigned long sys$cmexec();
/*  $CMKRNL		change to kernel mode */
/*	$CMKRNL routin,[arglst] */
#define sys$cmkrnl SYS$CMKRNL
unsigned long sys$cmkrnl();
/*  $CNTREG		contract program/control region (obsolete) */
/*	$CNTREG pagcnt,[retadr],[acmode],[region] */
#define sys$cntreg SYS$CNTREG
unsigned long sys$cntreg();
/* $CREATE_BRANCH[W]	create a transaction branch */
/*	$CREATE_BRANCH[W] [efn],[flags],iosb,[astadr],[astprm],tid,	-*/
/*+			  bid[,[timout],[acmode],[tx_class]]		 */
#define sys$create_branch SYS$CREATE_BRANCH
unsigned long sys$create_branch(), sys$create_branchw();
/*  $CREATE_BUFOBJ	create I/O buffer object */
/*	$CREATE_BUFOBJ inadr,[retadr],[acmode],[flags],buffer_handle */
#define sys$create_bufobj SYS$CREATE_BUFOBJ
unsigned long sys$create_bufobj();
/*  $CREATE_PROXY	create proxy database */
/*	$CREATE_PROXY */
#define sys$create_proxy SYS$CREATE_PROXY
unsigned long sys$create_proxy(void);
/*  $CREATE_RDB		create the rights database */
/*	$CREATE_RDB [sysid] */
#define sys$create_rdb SYS$CREATE_RDB
unsigned long sys$create_rdb();
/*  $CREATE_UID		create a universal identifier */
/*	$CREATE_UID uid */
#define sys$create_uid SYS$CREATE_UID
unsigned long sys$create_uid();
/*  $CREATE_USER_PROFILE create a user security profile */
/*	$CREATE_USER_PROFILE [usrnam],[itmlst],[flags],usrpro,usrprolen,[context] */
#define sys$create_user_profile SYS$CREATE_USER_PROFILE
unsigned long sys$create_user_profile();
/*  $CRELNM		create logical name */
/*	$CRELNM [attr],tabnam,lognam,[acmode],[itemlist] */
#define sys$crelnm SYS$CRELNM
unsigned long sys$crelnm();
/*  $CRELNT		create logical name table */
/*	$CRELNT [attr],[resnam],[reslen],[quota],[promsk],[tabnam],[acmode],[partab] */
#define sys$crelnt SYS$CRELNT
unsigned long sys$crelnt();
/*  $CRELOG		create logical name */
/*	$CRELOG [tblflg],lognam,eqlnam,[acmode] (obsolete) */
#define sys$crelog SYS$CRELOG
unsigned long sys$crelog();
/*  $CREMBX		create mailbox and assign channel */
/*     $CREMBX	[prmflg],chan,[maxmsg],[bufquo],[promsk],[acmode],[lognam][,[flags]] */
#define sys$crembx SYS$CREMBX
unsigned long sys$crembx();
/*  $CREPRC		create process */
/*	$CREPRC [pidadr],[image],[input],[output],[error],[prvadr],	  -*/
/*+		[quota],[prcnam],[baspri],[uic],[mbxunt],[stsflg],[itmlst] */
#define sys$creprc SYS$CREPRC
unsigned long sys$creprc();
/*  $CRETVA		create virtual address space */
/*	$CRETVA inadr,[retadr],[acmode] */
#define sys$cretva SYS$CRETVA
unsigned long sys$cretva();
/*  $CRMPSC		create and map section */
/*	$CRMPSC [inadr],[retadr],[acmode],[flags],[gsdnam],[ident],	-*/
/*+		[relpag],[chan],[pagcnt],[vbn],[prot],[pfc]		 */
#define sys$crmpsc SYS$CRMPSC
unsigned long sys$crmpsc();
/*  $DACEFC		disassociate common event flag cluster */
/*	$DACEFC efn */
#define sys$dacefc SYS$DACEFC
unsigned long sys$dacefc();
/*  $DALLOC		deallocate device */
/*	$DALLOC [devnam],[acmode] */
#define sys$dalloc SYS$DALLOC
unsigned long sys$dalloc();
/*  $DASSGN		deassign I/O channel */
/*	$DASSGN chan */
#define sys$dassgn SYS$DASSGN
unsigned long sys$dassgn();
/*  $DECLARE_RM[W]	declare resource manager to DDTM */
/*	$DECLARE_RM[W] [efn],[flags],iosb,[astadr],[astprm],rm_name,	-*/
/*+		       rm_id,evt_rtn,[acmode]				 */
#define sys$declare_rm SYS$DECLARE_RM
unsigned long sys$declare_rm(), sys$declare_rmw();
/*  $DCLAST		declare AST */
/*	$DCLAST astadr,[astprm],[acmode] */
#define sys$dclast SYS$DCLAST
unsigned long sys$dclast();
/*  $DCLCMH		declare change mode or compatibility mode handler */
/*	$DCLCMH addres,[prvhnd],[type] */
#define sys$dclcmh SYS$DCLCMH
unsigned long sys$dclcmh();
/*  $DCLEVT		declare an event */
/*	$DCLEVT evtnam,[rcvacl],[evtfac],[acmode],[flags],	 -*/
/*+		[evtdata],[nullarg],[nullarg],[nullarg],[nullarg] */
#define sys$dclevt SYS$DCLEVT
unsigned long sys$dclevt();
/*  $DCLEXH		declare exit handler */
/*	$DCLEXH desblk */
#define sys$dclexh SYS$DCLEXH
unsigned long sys$dclexh();
/*  $DCLRNH		declare restart handler */
/*	$DCLRNH desblk */
#define sys$dclrnh SYS$DCLRNH
unsigned long sys$dclrnh();
/*  $DECLARE_RM[W]	declare resource manager to DDTM */
/*	$DECLARE_RM[W] [efn],[flags],iosb,[astadr],[astprm],rm_id,event_handler     -*/
/*+		       [,[part_name],[rm_context],[acmode],[tm_log_id],[event_mask]] */
#define sys$declare_rm SYS$DECLARE_RM
unsigned long sys$declare_rm(), sys$declare_rmw();
/*  $DELETE_BUFOBJ	delete I/O buffer object */
/*	$DELETE_BUFOBJ	buffer_handle */
#define sys$delete_bufobj SYS$DELETE_BUFOBJ
unsigned long sys$delete_bufobj();
/*  $DELETE_INTRUSION	delete intrusion record */
/*	$DELETE_INTRUSION user_criteria,[flags] */
#define sys$delete_intrusion SYS$DELETE_INTRUSION
unsigned long sys$delete_intrusion();
/*  $DELETE_PROXY	delete proxy record */
/*	$DELETE_PROXY rem_node,rem_user,local_user,[flags] */
#define sys$delete_proxy SYS$DELETE_PROXY
unsigned long sys$delete_proxy();
/*  $DELLNM		delete logical name and/or table */
/*	$DELLNM [tabnam],[lognam],[acmode] */
#define sys$dellnm SYS$DELLNM
unsigned long sys$dellnm();
/*  $DELLOG		delete logical name (obsolete) */
/*	$DELLOG [tblflg],[lognam],[acmode] */
#define sys$dellog SYS$DELLOG
unsigned long sys$dellog();
/*  $DELMBX		delete mailbox */
/*	$DELMBX chan */
#define sys$delmbx SYS$DELMBX
unsigned long sys$delmbx();
/*  $DELPRC		delete process */
/*	$DELPRC [pidadr],[prcnam] */
#define sys$delprc SYS$DELPRC
unsigned long sys$delprc();
/*  $DELTVA		delete virtual address space */
/*	$DELTVA inadr,[retadr],[acmode] */
#define sys$deltva SYS$DELTVA
unsigned long sys$deltva();
/*  $DEQ		dequeue lock */
/*	$DEQ	[lkid],[valblk],[acmode],[flags] */
#define sys$deq SYS$DEQ
unsigned long sys$deq();
/*  $DEVICE_SCAN	wildcard device scan */
/*	$DEVICE_SCAN return_devnam,retlen,[search_devnam],[itmlst],[contxt] */
#define sys$device_scan SYS$DEVICE_SCAN
unsigned long sys$device_scan();
/*  $DGBLSC		delete global section */
/*	$DGBLSC [flags],gsdnam,[ident] */
#define sys$dgblsc SYS$DGBLSC
unsigned long sys$dgblsc();
/*  $DIAGNOSE		system service for diagnostics programmers */
/*	$DIAGNOSE function,P2,[cpu_id,[flags]] */
#define sys$diagnose SYS$DIAGNOSE
unsigned long sys$diagnose();
/*  $DISABLE_VP_USE[_INT] disable use of the vector processor [,internal form] */
/*	$DISABLE_VP_USE[_INT] flags,[curflg],[prvflg] */
#define sys$disable_vp_use SYS$DISABLE_VP_USE
unsigned long sys$disable_vp_use(), sys$disable_vp_use_int();
/*  $DISMOU		dismount volume */
/*	$DISMOU devnam,[flags] */
#define sys$dismou SYS$DISMOU
unsigned long sys$dismou();
/*  $DISPLAY_PROXY	display proxy record */
/*	$DISPLAY_PROXY rem_node,rem_user,buffer_sizes,proxy_node,	-*/
/*+		proxy_user,default_user,local_users,[flags],[context]	 */
#define sys$display_proxy SYS$DISPLAY_PROXY
unsigned long sys$display_proxy();
/*  $DLCEFC		delete common event flag cluster */
/*	$DLCEFC name */
#define sys$dlcefc SYS$DLCEFC
unsigned long sys$dlcefc();
/*  $DNS[W]		DNS clerk system service */
/*	$DNS[W] [efn],func,itmlst,[dnsb],[astadr],[astprm] */
#define sys$dns SYS$DNS
unsigned long sys$dns(), sys$dnsw();
/*  $EMAA		call entity management assist agent */
/*	$EMAA	(void) */
#define sys$emaa SYS$EMAA
unsigned long sys$emaa();
/*  $ENABLE_VP_USE[_INT] enable use of the vector processor [,internal form] */
/*	$ENABLE_VP_USE[_INT] flags,[curflg],[prvflg] */
#define sys$enable_vp_use SYS$ENABLE_VP_USE
unsigned long sys$enable_vp_use(), sys$enable_vp_use_int();
/*  $END_BRANCH[W]	end an active branch of a transaction */
/*	$END_BRANCH[W] [efn],[flags],iosb,[astadr],[astprm],tid,bid */
#define sys$end_branch SYS$END_BRANCH
unsigned long sys$end_branch(), sys$end_branchw();
/*  $END_TRANS[W]	commit a transaction */
/*	$END_TRANS[W] [efn],[flags],iosb[,[astadr],[astprm],[tid]] */
#define sys$end_trans SYS$END_TRANS
unsigned long sys$end_trans(), sys$end_transw();
/*  $ENQ[W]		enqueue lock request */
/*     $ENQ[W]	[efn],lkmode,lksb,[flags],[resnam],[parid],[astadr],	 -*/
/*+		[astprm],[blkast],[acmode],[rsdm_id][,[range],[priority]] */
#define sys$enq SYS$ENQ
unsigned long sys$enq(), sys$enqw();
/*  $ERAPAT		generate a security erase pattern. */
/*	$ERAPAT type,[count],patadr */
#define sys$erapat SYS$ERAPAT
unsigned long sys$erapat();
/*  $EVDPOSTEVENT	post event to EVD */
/*	$EVDPOSTEVENT event */
#define sys$evdpostevent SYS$EVDPOSTEVENT
unsigned long sys$evdpostevent();
/*  $EXIT		exit image */
/*	$EXIT	[code] */
#if (__GNUC__ == 2 && !__STRICT_ANSI__)
#if (__GNUC_MINOR__ >= 5)
#define sys$exit SYS$EXIT
void sys$exit() __attribute__((noreturn));
#else
volatile void sys$exit();
#endif
#else
#define sys$exit SYS$EXIT
void sys$exit();
#endif
/*  $EXPREG		expand program/control region */
/*	$EXPREG pagcnt,[retadr],[acmode],[region] */
#define sys$expreg SYS$EXPREG
unsigned long sys$expreg();
/*  $FAO		formatted ASCII output */
/*	$FAO	ctrstr,[outlen],outbuf,[p1],[p2]...[pn] */
#define sys$fao SYS$FAO
unsigned long sys$fao();
/*  $FAOL		formatted ASCII output with list parameter */
/*	$FAOL	ctrstr,[outlen],outbuf,prmlst */
#define sys$faol SYS$FAOL
unsigned long sys$faol();
/*  $FILESCAN		scan a string and identify a file specification */
/*	$FILESCAN srcstr,[valuelst],[fldflags] [,[auxout],[retlen]] */
#define sys$filescan SYS$FILESCAN
unsigned long sys$filescan();
/*  $FIND_HELD		find identifiers held by holder */
/*	$FIND_HELD holder,[id],[attrib],[contxt] */
#define sys$find_held SYS$FIND_HELD
unsigned long sys$find_held();
/*  $FIND_HOLDER	find holder of identifier */
/*	$FIND_HOLDER id,[holder],[attrib],[contxt] */
#define sys$find_holder SYS$FIND_HOLDER
unsigned long sys$find_holder();
/*  $FINISH_RDB		clean up RMS stream */
/*	$FINISH_RDB contxt */
#define sys$finish_rdb SYS$FINISH_RDB
unsigned long sys$finish_rdb();
/*  $FINISH_RMOP[W]	finish resource manager transaction event operation */
/*	$FINISH_RMOP[W] [efn],[flags],iosb,[astadr],[astprm],part_id,	-*/
/*+			retsts[,[reason],[beftime],[afttime]		 */
#define sys$finish_rmop SYS$FINISH_RMOP
unsigned long sys$finish_rmop(), sys$finish_rmopw();
/*  $FORCEX		force exit */
/*	$FORCEX [pidadr],[prcnam],[code] */
#define sys$forcex SYS$FORCEX
unsigned long sys$forcex();
/*  $FORGE_WORD		forge random word */
/*	$FORGE_WORD [minlen],[maxlen],[mindata],[flags],[retdata],outlen,outstr */
#define sys$forge_word SYS$FORGE_WORD
unsigned long sys$forge_word();
/*  $FORGET_RM[W]	forget a resource manager previously declared to DECdtm */
/*	$FORGET_RM[W] [efn],[flags],iosb,[astadr],[astprm],rm_id */
#define sys$forget_rm SYS$FORGET_RM
unsigned long sys$forget_rm(), sys$forget_rmw();
/*  $FORMAT_ACL		format an access control list entry */
/*	$FORMAT_ACL acl-entry,[acl-length],acl-string,[line-width],	-*/
/*+		    [term-desc],[line-indent],[bit-names],[routin]	 */
#define sys$format_acl SYS$FORMAT_ACL
unsigned long sys$format_acl();
/*  $FORMAT_AUDIT	format security auditing event message */
/*	$FORMAT_AUDIT fmttyp,audmsg,[outlen],outbuf,	-*/
/*+		      [width],[trmdsc],[routin],[fmtflg] */
#define sys$format_audit SYS$FORMAT_AUDIT
unsigned long sys$format_audit();
/*  $FORMAT_CLASS	format access class strings */
/*	$FORMAT_CLASS itmlst,[routin] */
#define sys$format_class SYS$FORMAT_CLASS
unsigned long sys$format_class();
/*  $GET_DEFAULT_TRANS	get the current process default transaction */
/*	$GET_DEFAULT_TRANS tid */
#define sys$get_default_trans SYS$GET_DEFAULT_TRANS
unsigned long sys$get_default_trans();
/*  $GET_SECURITY	get object securty profile */
/*     $GET_SECURITY [clsnam],[objnam],[objhan],[flags],[itmlst],[context],[acmode] */
#define sys$get_security SYS$GET_SECURITY
unsigned long sys$get_security();
/*  $GETCHN		get I/O channel information (obsolete) */
/*	$GETCHN chan,[prilen],[pribuf],[scdlen],[scdbuf] */
#define sys$getchn SYS$GETCHN
unsigned long sys$getchn();
/*  $GETDEV		get I/O device information (obsolete) */
/*	$GETDEV devnam,[prilen],[pribuf],[scdlen],[scdbuf] */
#define sys$getdev SYS$GETDEV
unsigned long sys$getdev();
/*  $GETDTI[W]		get distributed transaction information */
/*	$GETDTI[W] [efn],[flags],iosb,[astadr],[astprm],[log_id],	-*/
/*+		   context,search,itmlst				 */
#define sys$getdti SYS$GETDTI
unsigned long sys$getdti(), sys$getdtiw();
/*  $GETDVI[W]		get device/volume information */
/*	$GETDVI[W] [efn],[chan],[devnam],itmlst,[iosb],[astadr],	-*/
/*+		   [astprm],[nullarg]					 */
#define sys$getdvi SYS$GETDVI
unsigned long sys$getdvi(), sys$getdviw();
/*  $GETEVI		get event information */
/*	$GETEVI itmlst,[nullarg] */
#define sys$getevi SYS$GETEVI
unsigned long sys$getevi();
/*  $GETJPI[W]		get job/process information */
/*	$GETJPI[W] [efn],[pidadr],[prcnam],itmlst,[iosb],[astadr],[astprm] */
#define sys$getjpi SYS$GETJPI
#define sys$getjpiw SYS$GETJPIW
unsigned long sys$getjpi(), sys$getjpiw();
/*  $GETLKI[W]		get lock information */
/*	$GETLKI[W] [efn],lkidadr,itmlst,[iosb],[astadr],[astprm],[reserved] */
#define sys$getlki SYS$GETLKI
unsigned long sys$getlki(), sys$getlkiw();
/*  $GETMSG		get message */
/*	$GETMSG msgid,msglen,bufadr,[flags],[outadr] */
#define sys$getmsg SYS$GETMSG
unsigned long sys$getmsg();
/*  $GETPTI		get page table information */
/*	$GETPTI [inadr],[retadr],[acmode],[mask],[pagcnt] */
#define sys$getpti SYS$GETPTI
unsigned long sys$getpti();
/*  $GETQUI[W]		get queue information */
/*	$GETQUI[W] [efn],func,[context],[itmlst],[iosb],[astadr],[astprm] */
#define sys$getqui SYS$GETQUI
unsigned long sys$getqui(), sys$getquiw();
/*  $GETSYI[W]		get system-wide information */
/*	$GETSYI[W] [efn],[csidadr],[nodename],itmlst,[iosb],[astadr],[astprm] */
#define sys$getsyi SYS$GETSYI
unsigned long sys$getsyi(), sys$getsyiw();
/*  $GETTIM		get time */
/*	$GETTIM timadr */
#define sys$gettim SYS$GETTIM
unsigned long sys$gettim();
/*  $GETUAI		get user authorization information */
/*	$GETUAI [efn],[contxt],usrnam,itmlst,[iosb],[astadr],[astprm] */
#define sys$getuai SYS$GETUAI
unsigned long sys$getuai();
/*  $GETUTC		get UTC time */
/*	$GETUTC utcadr(octaword!) */
#define sys$getutc SYS$GETUTC
unsigned long sys$getutc();
/*  $GRANTID		grant identifier to process */
/*	$GRANTID [pidadr],[prcnam],[id],[name],[prvatr] [,[segment]] */
#define sys$grantid SYS$GRANTID
unsigned long sys$grantid();
/*  $GRANT_LICENSE	grant authorization to execute licensed software product. */
/*	$GRANT_LICENSE prdnam,prducer [,contxt] [,itmlst] */
#define sys$grant_license SYS$GRANT_LICENSE
unsigned long sys$grant_license();
/*  $HASH_PASSWORD	encrypt a user password to produce a quadword hash value. */
/*	$HASH_PASSWORD pwd,alg,[salt],usrnam,hash */
#define sys$hash_password SYS$HASH_PASSWORD
unsigned long sys$hash_password();
/*  $HIBER		hibernate */
/*	$HIBER	(void) */
#define sys$hiber SYS$HIBER
unsigned long sys$hiber();
/*  $IDTOASC		identifier to ASCII conversion */
/*	$IDTOASC id,[namlen],[nambuf],[resid],[attrib],[contxt] */
#define sys$idtoasc SYS$IDTOASC
unsigned long sys$idtoasc();
/*  $IMGACT		image activation */
/*	$IMGACT name,[dflnam],hdrbuf,[imgctl],[inadr],[retadr],[ident],[acmode] */
#define sys$imgact SYS$IMGACT
unsigned long sys$imgact();
/*  $IMGFIX		image address fixup service */
/*	$IMGFIX (void) */
#define sys$imgfix SYS$IMGFIX
unsigned long sys$imgfix();
/*  $INIT_VOL		initialize volume */
/*	$INIT_VOL devnam,volnam,[itmlst] */
#define sys$init_vol SYS$INIT_VOL
unsigned long sys$init_vol();
/*  $IPC[W]		interprocess communication request */
/*     $IPC[W] [efn],func,ipcb,[astadr],[astprm] */
#define sys$ipc SYS$IPC
unsigned long sys$ipc(), sys$ipcw();
/*  $JOIN_RM[W]		join a resource manager previously started transaction */
/*	$JOIN_RM[W] [efn],[flags],iosb,[astadr],[astprm],rm_id[,[tid],	-*/
/*+		    [part_name],[rm_context],[timout]]			 */
#define sys$join_rm SYS$JOIN_RM
unsigned long sys$join_rm(), sys$join_rmw();
/*  $LCKPAG		lock pages in memory */
/*	$LCKPAG inadr,[retadr],[acmode] */
#define sys$lckpag SYS$LCKPAG
unsigned long sys$lckpag();
/*  $LKWSET		lock pages in working set */
/*	$LKWSET inadr,[retadr],[acmode] */
#define sys$lkwset SYS$LKWSET
unsigned long sys$lkwset();
/*  $MGBLSC		map global section */
/*	$MGBLSC inadr,[retadr],[acmode],[flags],gsdnam,[ident],[relpag] */
#define sys$mgblsc SYS$MGBLSC
unsigned long sys$mgblsc();
/*  $MOD_HOLDER		modify holder record in rights database */
/*	$MOD_HOLDER id,holder,[set_attrib],[clr_attrib] */
#define sys$mod_holder SYS$MOD_HOLDER
unsigned long sys$mod_holder();
/*  $MOD_IDENT		modify identifier record in rights database */
/*	$MOD_IDENT id,[set_attrib],[clr_attrib],[new_name],[new_value] */
#define sys$mod_ident SYS$MOD_IDENT
unsigned long sys$mod_ident();
/*  $MOUNT		mount volume */
/*	$MOUNT	itmlst */
#define sys$mount SYS$MOUNT
unsigned long sys$mount();
/*  $MTACCESS		installation specific accessibility routine */
/*	$MTACCESS lblnam,[uic],[std_version],[access_char],[access_spec],type */
#define sys$mtaccess SYS$MTACCESS
unsigned long sys$mtaccess();
/*  $NUMTIM		convert binary time to numeric time */
/*	$NUMTIM timbuf,[timadr] */
#define sys$numtim SYS$NUMTIM
unsigned long sys$numtim();
/*  $NUMUTC		convert UTC binary time to numeric time */
/*	$NUMUTC timbuf,[utcadr(octaword!)] */
#define sys$numutc SYS$NUMUTC
unsigned long sys$numutc();
/*  $PARSE_ACL		parse an access control list entry */
/*	$PARSE_ACL acl-string,acl-entry,[error-position],[bit-names],[routin] */
#define sys$parse_acl SYS$PARSE_ACL
unsigned long sys$parse_acl();
/*  $PARSE_CLASS	parse access class strings */
/*	$PARSE_CLASS itmlst,[routin] */
#define sys$parse_class SYS$PARSE_CLASS
unsigned long sys$parse_class();
/*   $PERSONA_CREATE	create persona */
/*	$PERSONA_CREATE persona,usrnam,flags */
#define sys$persona_create SYS$PERSONA_CREATE
unsigned long sys$persona_create();
/*   $PERSONA_ASSUME	assume persona */
/*	$PERSONA_ASSUME persona,flags */
#define sys$persona_assume SYS$PERSONA_ASSUME
unsigned long sys$persona_assume();
/*   $PERSONA_DELETE	delete persona */
/*	$PERSONA_DELETE persona */
#define sys$persona_delete SYS$PERSONA_DELETE
unsigned long sys$persona_delete();
/*  $POSIX_FORK_CONTROL control POSIX fork() operations */
/*	$POSIX_FORK_CONTROL cntrl,[when],[handler],[arg],[acmode] */
#define sys$posix_fork_control SYS$POSIX_FORK_CONTROL
unsigned long sys$posix_fork_control();
/*  $PROCESS_SCAN	initialize process_scan context */
/*	$PROCESS_SCAN pidctx,[itmlst] */
#define sys$process_scan SYS$PROCESS_SCAN
unsigned long sys$process_scan();
/*  $PURGWS		purge working set */
/*	$PURGWS inadr */
#define sys$purgws SYS$PURGWS
unsigned long sys$purgws();
/*  $PUTMSG		put message */
/*	$PUTMSG msgvec,[actrtn],[facnam],[actprm] */
#define sys$putmsg SYS$PUTMSG
unsigned long sys$putmsg();
/*  $QIO[W]		queue I/O request */
/*	$QIO[W] [efn],chan,func,[iosb],[astadr],[astprm],	-*/
/*+		[p1],[p2],[p3],[p4],[p5],[p6]			 */
#define sys$qio SYS$QIO
unsigned long sys$qio(), sys$qiow();
/*  $READEF		read event flag */
/*	$READEF efn,state */
#define sys$readef SYS$READEF
unsigned long sys$readef();
/*  $RECOVER[W]		recover transaction state. */
/*	$RECOVER[W] [efn],[flags],iosb,[astadr],[astprm],recovery_prefix,event_handler, -*/
/*+		    tm_log_id[,[tid],[node],[rm_context],[acmode],[max_events]]		 */
#define sys$recover SYS$RECOVER
unsigned long sys$recover(), sys$recoverw();
/*  $RELEASE_LICENSE	release authorization to execute licensed software product. */
/*	$RELEASE_LICENSE context */
#define sys$release_license SYS$RELEASE_LICENSE
unsigned long sys$release_license();
/*  $RELEASE_VP[_INT]	release the vector processor [,internal form] */
/*	$RELEASE_VP[_INT] (void) */
#define sys$release_vp SYS$RELEASE_VP
unsigned long sys$release_vp(), sys$release_vp_int();
/*  $REM_HOLDER		remove holder record from rights database */
/*	$REM_HOLDER id,holder */
#define sys$rem_holder SYS$REM_HOLDER
unsigned long sys$rem_holder();
/*  $REM_IDENT		remove identifier from rights database */
/*	$REM_IDENT id */
#define sys$rem_ident SYS$REM_IDENT
unsigned long sys$rem_ident();
/*  $RESTORE_VP_EXCEPTION | $RESTORE_VP_EXC_INT  restore vector processor exception state */
/*	$RESTORE_VP_EXCEPTION | $RESTORE_VP_EXC_INT excid */
#define sys$restore_vp_exception SYS$RESTORE_VP_EXCEPTION
unsigned long sys$restore_vp_exception(), sys$restore_vp_exc_int();
/*  $RESTORE_VP_STATE	restore mainline vector state */
/*	$RESTORE_VP_STATE (void) */
#define sys$restore_vp_state SYS$RESTORE_VP_STATE
unsigned long sys$restore_vp_state();
/*  $RESUME		resume suspended process */
/*	$RESUME [pidadr],[prcnam] */
#define sys$resume SYS$RESUME
unsigned long sys$resume();
/*  $REVOKID		revoke identifier from process */
/*	$REVOKID [pidadr],[prcnam],[id],[name],[prvatr] [,[segment]] */
#define sys$revokid SYS$REVOKID
unsigned long sys$revokid();
/*  $RMSRUNDWN		RMS rundown -- close all files opened by RMS */
/*	SYS$RMSRUNDWN bufadr,typval */
#define sys$rmsrundwn SYS$RMSRUNDWN
unsigned long sys$rmsrundwn(void *,int);	/* (dsc$descriptor_s,byte) */
/*  $SAVE_VP_EXCEPTION | $SAVE_VP_EXC_INT  save vector processor exception state */
/*	$SAVE_VP_EXCEPTION | $SAVE_VP_EXC_INT excid,[flags] */
#define sys$save_vp_exception SYS$SAVE_VP_EXCEPTION
unsigned long sys$save_vp_exception(), sys$save_vp_exc_int();
/*  $SCAN_INTRUSION	scan intrusion database */
/*	$SCAN_INTRUSION logfail_status,failed_user,job_type,		     -*/
/*+		[source_terminal],[source_node],[source_user],[source_addr], -*/
/*+		[failed_password],[parent_user],[parent_id],[flags]	      */
#define sys$scan_intrusion SYS$SCAN_INTRUSION
unsigned long sys$scan_intrusion();
/*  $SCHED		control class scheduler */
/*	$SCHED	func,p1,p2,p3 */
#define sys$sched SYS$SCHED
unsigned long sys$sched();
/*  $SCHDWK		schedule wakeup */
/*	$SCHDWK [pidadr],[prcnam],daytim,[reptim] */
#define sys$schdwk SYS$SCHDWK
unsigned long sys$schdwk();
/*  $SET_DEFAULT_TRANS[W] set up the process default transaction */
/*	$SET_DEFAULT_TRANS[W] [efn],[flags],iosb[,[astadr],[astprm],[new_tid],[old_tid]] */
#define sys$set_default_trans SYS$SET_DEFAULT_TRANS
unsigned long sys$set_default_trans(), sys$set_default_transw();
/*  $SET_RESOURCE_DOMAIN set resource domain */
/*     $SET_RESOURCE_DOMAIN func,rsdm_id,uic_group,[nullarg],[access],[acmode] */
#define sys$set_resource_domain SYS$SET_RESOURCE_DOMAIN
unsigned long sys$set_resource_domain() ;
/*  $SET_SECURITY	set object security profile */
/*     $SET_SECURITY [clsnam],[objnam],[objhan],[flags],[itmlst],[context],[acmode] */
#define sys$set_security SYS$SET_SECURITY
unsigned long sys$set_security();
/*  $SETAST		set AST enable */
/*	$SETAST enbflg */
#define sys$setast SYS$SETAST
unsigned long sys$setast();
/*  $SETCLUEVT		set cluster event notification */
/*     $SETCLUEVT event,astadr,[astprm],[acmode],[handle] */
#define sys$setcluevt SYS$SETCLUEVT
unsigned long sys$setcluevt();
/*  $SETDDIR		set RMS default directory */
/*	SYS$SETDDIR [newdir],[oldlen],[olddir] */
#define sys$setddir SYS$SETDDIR
unsigned long sys$setddir(const void *,unsigned short *,void *);
/*  $SETDFPROT		set RMS default file protection */
/*	SYS$SETDFPROT [newprot],[oldprot] */
#define sys$setdfprot SYS$SETDFPROT
unsigned long sys$setdfprot(const unsigned short *,unsigned short *);
/*  $SETDTI[W]		set distributed transaction information */
/*	$SETDTI[W] [efn],[flags],iosb,[astadr],[astprm],context,func,itmlst */
#define sys$setdti SYS$SETDTI
unsigned long sys$setdti(), sys$setdtiw();
/*  $SETEF		set event flag */
/*	$SETEF	efn */
#define sys$setef SYS$SETEF
unsigned long sys$setef();
/*  $SETEVTAST[W]	establish an event AST routine */
/*	$SETEVTAST evtnam,evtadr,[evtfac],[acmode],[flags],[reqid],	    -*/
/*+		   [evtid],[evtcrd],[efn],[iosb],[astadr],[astprm],[nullarg] */
#define sys$setevtast SYS$SETEVTAST
unsigned long sys$setevtast(), sys$setevtastw();
/*  $SETEXV		set exception vector */
/*	$SETEXV [vector],[addres],[acmode],[prvhnd] */
#define sys$setexv SYS$SETEXV
unsigned long sys$setexv();
/*  $SETIME		set system time */
/*	$SETIME [timadr] */
#define sys$setime SYS$SETIME
unsigned long sys$setime();
/*  $SETIMR		set timer */
/*	$SETIMR [efn],daytim,[astadr],[reqidt],[flags] */
#define sys$setimr SYS$SETIMR
unsigned long sys$setimr();
/*  $SETPFM		set page fault monitoring */
/*	$SETPFM [pfmflg],[astadr],[astprm],[acmode] */
#define sys$setpfm SYS$SETPFM
unsigned long sys$setpfm();
/*  $SETPRA		set power recovery AST */
/*	$SETPRA astadr,[acmode] */
#define sys$setpra SYS$SETPRA
unsigned long sys$setpra();
/*  $SETPRI		set priority */
/*	$SETPRI [pidadr],[prcnam],pri,[prvpri] */
#define sys$setpri SYS$SETPRI
unsigned long sys$setpri();
/*  $SETPRN		set process name */
/*	$SETPRN [prcnam] */
#define sys$setprn SYS$SETPRN
unsigned long sys$setprn();
/*  $SETPRT		set protection on pages */
/*	$SETPRT inadr,[retadr],[acmode],prot,[prvprt] */
#define sys$setprt SYS$SETPRT
unsigned long sys$setprt();
/*  $SETPRV		set privileges. */
/*	$SETPRV [enbflg],[prvadr],[prmflg],[prvprv] */
#define sys$setprv SYS$SETPRV
unsigned long sys$setprv();
/*  $SETRWM		set resource wait mode */
/*	$SETRWM [watflg] */
#define sys$setrwm SYS$SETRWM
unsigned long sys$setrwm();
/*  $SETSFM		set system service failure mode */
/*	$SETSFM [enbflg] */
#define sys$setsfm SYS$SETSFM
unsigned long sys$setsfm();
/*  $SETSHLV		modify process default unshelving action */
/*     $SETSHLV [pidadr],[prcnam],[shlvflg] */
#define sys$setshlv SYS$SETSHLV
unsigned long sys$setshlv();
/*  $SETSSF		set system service filter */
/*	$SETSSF [mask] */
#define sys$setssf SYS$SETSSF
unsigned long sys$setssf();
/*  $SETSTK		set virtual stack limits */
/*	$SETSTK inadr,[retadr],[acmode] */
#define sys$setstk SYS$SETSTK
unsigned long sys$setstk();
/*  $SETSWM		set process swap mode */
/*	$SETSWM [swpflg] */
#define sys$setswm SYS$SETSWM
unsigned long sys$setswm();
/*  $SETUAI		modify user authorization information */
/*	$SETUAI [efn],[contxt],usrnam,itmlst,[iosb],[astadr],[astprm] */
#define sys$setuai SYS$SETUAI
unsigned long sys$setuai();
/*  $SHOW_INTRUSION	show intrusion record */
/*	$SHOW_INTRUSION user_criteria,intruder,intruder_len,breakin_block,[flags],[context] */
#define sys$show_intrusion SYS$SHOW_INTRUSION
unsigned long sys$show_intrusion();
/*  $SNDACC		send message to accounting manager (obsolete) */
/*	$SNDACC msgbuf,[chan] */
#define sys$sndacc SYS$SNDACC
unsigned long sys$sndacc();
/*  $SNDERR		send message to error logger */
/*	$SNDERR msgbuf */
#define sys$snderr SYS$SNDERR
unsigned long sys$snderr();
/*  $SNDJBC[W]		send message to job controller */
/*	$SNDJBC [efn],func,[nullarg],[itmlst],[iosb],[astadr],[astprm] */
#define sys$sndjbc SYS$SNDJBC
unsigned long sys$sndjbc(), sys$sndjbcw();
/*  $SNDOPR		send message to operator */
/*	$SNDOPR msgbuf,[chan] */
#define sys$sndopr SYS$SNDOPR
unsigned long sys$sndopr();
/*  $SNDSMB		send message to symbiont manager (obsolete) */
/*	$SNDSMB msgbuf,[chan] */
#define sys$sndsmb SYS$SNDSMB
unsigned long sys$sndsmb();
/* $START_BRANCH[W]	start a transaction branch */
/*	$START_BRANCH[W] [efn],[flags],iosb,[astadr],[astprm],tid,	-*/
/*+			 tm_name,bid,[,[timout],[acmode],[tx_class]]	 */
#define sys$start_branch SYS$START_BRANCH
unsigned long sys$start_branch(), sys$start_branchw();
/*  $START_TRANS[W]	start a new transaction */
/*	$START_TRANS[W] [efn],[flags],iosb[,[astadr],[astprm],	-*/
/*+			[tid],[timout],[acmode],[tx_class]]	 */
#define sys$start_trans SYS$START_TRANS
unsigned long sys$start_trans(), sys$start_transw();
/*  $SUBSYSTEM		modify protected subsystem attributes */
/*	$SUBSYSTEM enbflg */
#define sys$subsystem SYS$SUBSYSTEM
unsigned long sys$subsystem();
/*  $SUSPND		suspend process */
/*	$SUSPND [pidadr],[prcnam],[flags] */
#define sys$suspnd SYS$SUSPND
unsigned long sys$suspnd();
/*  $SYNCH		synchronize event completion */
/*	$SYNCH	[iosb],[efn] */
#define sys$synch SYS$SYNCH
unsigned long sys$synch();
/*  $TIMCON		convert between binary UTC and Smithsonian times */
/*	$TIMCON smnadr(quadword),utcadr(octaword!),cvtflg */
#define sys$timcon SYS$TIMCON
unsigned long sys$timcon();
/*  $TRANS_EVENT[W]	start a new transaction */
/*	$TRANS_EVENT[W] [efn],[flags],iosb,[astadr],[astprm],tid,	-*/
/**			tx_event[,[cmttime],[beftime],[afttime]]	 */
#define sys$trans_event SYS$TRANS_EVENT
unsigned long sys$trans_event(), sys$trans_eventw();
/*  $TRNLNM		translate logical name */
/*	$TRNLNM [attr],tabnam,[lognam],[acmode],[itemlist] */
#define sys$trnlnm SYS$TRNLNM
unsigned long sys$trnlnm();
/*  $TRNLOG		translate logical name (obsolete) */
/*	$TRNLOG lognam,[rsllen],rslbuf,[table],[acmode],[dsbmsk] */
#define sys$trnlog SYS$TRNLOG
unsigned long sys$trnlog();
/*  $TSTCLUEVT		test cluster event notification */
/*     $TSTCLUEVT [handle],[acmode],[event] */
#define sys$tstcluevt SYS$TSTCLUEVT
unsigned long sys$tstcluevt();
/*  $ULKPAG		unlock pages from memory */
/*	$ULKPAG inadr,[retadr],[acmode] */
#define sys$ulkpag SYS$ULKPAG
unsigned long sys$ulkpag();
/*  $ULWSET		unlock pages from working set */
/*	$ULWSET inadr,[retadr],[acmode] */
#define sys$ulwset SYS$ULWSET
unsigned long sys$ulwset();
/*  $UNWIND		unwind call stack */
/*	$UNWIND [depadr],[newpc] */
#define sys$unwind SYS$UNWIND
unsigned long sys$unwind();
/*  $UPDSEC[W]		update section file on disk */
/*	$UPDSEC[W] inadr,[retadr],[acmode],[updflg],[efn],[iosb],[astadr],[astprm] */
#define sys$updsec SYS$UPDSEC
unsigned long sys$updsec(), sys$updsecw();
/*  $VERIFY_PROXY	verify proxy record */
/*	$VERIFY_PROXY rem_node,rem_user,[proposed_user],local_user,local_user_len,flags */
#define sys$verify_proxy SYS$VERIFY_PROXY
unsigned long sys$verify_proxy();
/*  $WAITFR		wait for single event flag */
/*	$WAITFR efn */
#define sys$waitfr SYS$WAITFR
unsigned long sys$waitfr();
/*  $WAKE		wake up hibernating process */
/*	$WAKE	[pidadr],[prcnam] */
#define sys$wake SYS$WAKE
unsigned long sys$wake();
/*  $WFLAND		wait for logical AND of event flags */
/*	$WFLAND efn,mask */
#define sys$wfland SYS$WFLAND
unsigned long sys$wfland();
/*  $WFLOR		wait for logical OR of event flags */
/*	$WFLOR	efn,mask */
#define sys$wflor SYS$WFLOR
unsigned long sys$wflor();

# ifdef __cplusplus
}
# endif
#endif	/*_SYS$ROUTINES_H*/
