/* <ttdef.h>
 *
 *	Primary terminal characteristics
 */
#ifndef _TTDEF_H
#define _TTDEF_H

/* define terminal special symbols */
#define TT$C_BAUD_50	1
#define TT$C_BAUD_75	2
#define TT$C_BAUD_110	3
#define TT$C_BAUD_134	4
#define TT$C_BAUD_150	5
#define TT$C_BAUD_300	6
#define TT$C_BAUD_600	7
#define TT$C_BAUD_1200	8
#define TT$C_BAUD_1800	9
#define TT$C_BAUD_2000	10
#define TT$C_BAUD_2400	11
#define TT$C_BAUD_3600	12
#define TT$C_BAUD_4800	13
#define TT$C_BAUD_7200	14
#define TT$C_BAUD_9600	15
#define TT$C_BAUD_19200 16
#define TT$C_BAUD_38400 17
#ifndef NO_VMS_V6
#define TT$C_BAUD_57600 18
#define TT$C_BAUD_76800 19
#define TT$C_BAUD_115200 20
#endif
/* *** matches dcdef macro */
#define TT$_UNKNOWN	0
#define TT$_VT05	1	/* VT05 */
#define TT$_VK100	2	/* strange terminals */
#define TT$_VT173	3
#define TT$_TQ_BTS	4
#define TT$_TEK401X	10
#define TT$_FT1		16	/* foreign terminal types */
#define TT$_FT2		17	/* new support also includes */
#define TT$_FT3		18	/* the negative numbers */
#define TT$_FT4		19
#define TT$_FT5		20
#define TT$_FT6		21
#define TT$_FT7		22
#define TT$_FT8		23	/* end of foreign types */
 /* reserve rest up to 32 for extensions */
#define TT$_LAX		32
#define TT$_LA36	32
#define TT$_LA120	33
#define TT$_LA34	34
#define TT$_LA38	35
#define TT$_LA12	36
#define TT$_LA100	37
#define TT$_LA24	37
#define TT$_LQP02	38
#define TT$_LA84	39
#define TT$_LA210	40
#define TT$_LN03	41
#define TT$_LN01K	42
#define TT$_LA80	43
#define TT$_VT5X	64
#define TT$_VT52	64
#define TT$_VT55	65
#define TT$_VT100	96	/* VT100 */
#define TT$_VT101	97
#define TT$_VT102	98
#define TT$_VT105	99
#define TT$_VT125	100
#define TT$_VT131	101
#define TT$_VT132	102
#define TT$_VT80	103
#define TT$_VT200_Series 110
#define TT$_Pro_Series	 111
#define TT$_VT300_Series 112
#define TT$_VT400_Series 113
#ifndef NO_VMS_V6
#define TT$_VT500_Series 114
#endif
 /* from 128 on is reserved for foreign terminals and must not be */
 /* used for terminal definitions */
#define TT$V_PASSALL	0
#define TT$V_NOECHO	1
#define TT$V_NOTYPEAHD	2
#define TT$V_ESCAPE	3
#define TT$V_HOSTSYNC	4
#define TT$V_TTSYNC	5
#define TT$V_SCRIPT	6
#define TT$V_LOWER	7
#define TT$V_MECHTAB	8
#define TT$V_WRAP	9
#define TT$V_CRFILL	10
#define TT$V_LFFILL	11
#define TT$V_SCOPE	12
#define TT$V_REMOTE	13
#define TT$V_RESERVED	14
#define TT$V_EIGHTBIT	15
#define TT$V_MBXDSABL	16
#define TT$V_NOBRDCST	17
#define TT$V_READSYNC	18
#define TT$V_MECHFORM	19
#define TT$V_HALFDUP	20
#define TT$V_MODEM	21
#define TT$V_OPER	22
#define TT$V_PAGE	24
#define TT$S_PAGE	8
#define TT$M_PASSALL	(1<<TT$V_PASSALL)	/* 0x01 */
#define TT$M_NOECHO	(1<<TT$V_NOECHO)	/* 0x02 */
#define TT$M_NOTYPEAHD	(1<<TT$V_NOTYPEAHD)	/* 0x04 */
#define TT$M_ESCAPE	(1<<TT$V_ESCAPE)	/* 0x08 */
#define TT$M_HOSTSYNC	(1<<TT$V_HOSTSYNC)	/* 0x10 */
#define TT$M_TTSYNC	(1<<TT$V_TTSYNC)	/* 0x20 */
#define TT$M_SCRIPT	(1<<TT$V_SCRIPT)	/* 0x40 */
#define TT$M_LOWER	(1<<TT$V_LOWER)		/* 0x80 */
#define TT$M_MECHTAB	(1<<TT$V_MECHTAB)	/* 0x0100 */
#define TT$M_WRAP	(1<<TT$V_WRAP)		/* 0x0200 */
#define TT$M_CRFILL	(1<<TT$V_CRFILL)	/* 0x0400 */
#define TT$M_LFFILL	(1<<TT$V_LFFILL)	/* 0x0800 */
#define TT$M_SCOPE	(1<<TT$V_SCOPE)		/* 0x1000 */
#define TT$M_REMOTE	(1<<TT$V_REMOTE)	/* 0x2000 */
#define TT$M_RESERVED	(1<<TT$V_RESERVED)	/* 0x4000 */
#define TT$M_EIGHTBIT	(1<<TT$V_EIGHTBIT)	/* 0x8000 */
#define TT$M_MBXDSABL	(1<<TT$V_MBXDSABL)	/* 0x010000 */
#define TT$M_NOBRDCST	(1<<TT$V_NOBRDCST)	/* 0x020000 */
#define TT$M_READSYNC	(1<<TT$V_READSYNC)	/* 0x040000 */
#define TT$M_MECHFORM	(1<<TT$V_MECHFORM)	/* 0x080000 */
#define TT$M_HALFDUP	(1<<TT$V_HALFDUP)	/* 0x100000 */
#define TT$M_MODEM	(1<<TT$V_MODEM)		/* 0x200000 */
#define TT$M_OPER	(1<<TT$V_OPER)		/* 0x400000 */
#define TT$M_PAGE	0xFF000000

#define TT$V_ALTFRAME	4
#define TT$V_ALTRPAR	5
#define TT$V_PARITY	6
#define TT$V_ODD	7
#define TT$V_TWOSTOP	8
#define TT$V_DISPARERR	9
#define TT$V_ALTDISPAR	10
#define TT$V_BREAK	11
#define TT$M_ALTFRAME	(1<<TT$V_ALTFRAME)	/* 0x0010 */
#define TT$M_ALTRPAR	(1<<TT$V_ALTRPAR)	/* 0x0020 */
#define TT$M_PARITY	(1<<TT$V_PARITY)	/* 0x0040 */
#define TT$M_ODD	(1<<TT$V_ODD)		/* 0x0080 */
#define TT$M_TWOSTOP	(1<<TT$V_TWOSTOP)	/* 0x0100 */
#define TT$M_DISPARERR	(1<<TT$V_DISPARERR)	/* 0x0200 */
#define TT$M_ALTDISPAR	(1<<TT$V_ALTDISPAR)	/* 0x0400 */
#define TT$M_BREAK	(1<<TT$V_BREAK)		/* 0x0800 */
#define TT$V_DS_DTR	1
#define TT$V_DS_SECTX	3
#define TT$V_DS_RTS	4
#define TT$V_DS_SECREC	3
#define TT$V_DS_CTS	4
#define TT$V_DS_CARRIER 5
#define TT$V_DS_RING	6
#define TT$V_DS_DSR	7
#define TT$M_DS_DTR	(1<<TT$V_DS_DTR)	/* 0x02 */
#define TT$M_DS_SECTX	(1<<TT$V_DS_SECTX)	/* 0x08 */
#define TT$M_DS_RTS	(1<<TT$V_DS_RTS)	/* 0x10 */
#define TT$M_DS_SECREC	(1<<TT$V_DS_SECREC)	/* 0x08 */
#define TT$M_DS_CTS	(1<<TT$V_DS_CTS)	/* 0x10 */
#define TT$M_DS_CARRIER (1<<TT$V_DS_CARRIER)	/* 0x20 */
#define TT$M_DS_RING	(1<<TT$V_DS_RING)	/* 0x40 */
#define TT$M_DS_DSR	(1<<TT$V_DS_DSR)	/* 0x80 */
union ttdef {
    struct {
	unsigned tt$v_passall	: 1;
	unsigned tt$v_noecho	: 1;
	unsigned tt$v_notypeahd : 1;
	unsigned tt$v_escape	: 1;
	unsigned tt$v_hostsync	: 1;
	unsigned tt$v_ttsync	: 1;
	unsigned tt$v_script	: 1;
	unsigned tt$v_lower	: 1;
	unsigned tt$v_mechtab	: 1;
	unsigned tt$v_wrap	: 1;
	unsigned tt$v_crfill	: 1;
	unsigned tt$v_lffill	: 1;
	unsigned tt$v_scope	: 1;
	unsigned tt$v_remote	: 1;
	unsigned tt$v_reserved	: 1;
	unsigned tt$v_eightbit	: 1;
	unsigned tt$v_mbxdsabl	: 1;
	unsigned tt$v_nobrdcst	: 1;
	unsigned tt$v_readsync	: 1;
	unsigned tt$v_mechform	: 1;
	unsigned tt$v_halfdup	: 1;
	unsigned tt$v_modem	: 1;
	unsigned tt$v_oper	: 1;
	unsigned		: 1;
	unsigned tt$v_page	: 8;
    } tt$r_ttdef_bits0;
    struct {
	unsigned		: 4;
	unsigned tt$v_altframe	: 1;
	unsigned tt$v_altrpar	: 1;
	unsigned tt$v_parity	: 1;
	unsigned tt$v_odd	: 1;
	unsigned tt$v_twostop	: 1;
	unsigned tt$v_disparerr : 1;
	unsigned tt$v_altdispar : 1;
	unsigned tt$v_break	: 1;
	unsigned		: 4;
	unsigned		: 16;
    } tt$r_ttdef_bits1;
    struct {
	unsigned		: 1;
	unsigned tt$v_ds_dtr	: 1;	/* output modem control */
	unsigned		: 1;
	unsigned tt$v_ds_sectx	: 1;
	unsigned tt$v_ds_rts	: 1;
	unsigned		: 3;
	unsigned		: 24;
    } tt$r_ttdef_bits2;
    struct {
	unsigned		: 3;
	unsigned tt$v_ds_secrec : 1;
	unsigned tt$v_ds_cts	: 1;
	unsigned tt$v_ds_carrier: 1;
	unsigned tt$v_ds_ring	: 1;
	unsigned tt$v_ds_dsr	: 1;
	unsigned		: 24;
    } tt$r_ttdef_bits3;
};

#endif	/*_TTDEF_H*/
