/* <uiddef.h>
 *
 *	unknown something-or-other (V5.5)
 */
#ifndef _UIDDEF_H
#define _UIDDEF_H

#define UID$K_ARCHVERSION 1	/* current architecture version */
#define UID$K_APOLLO1	0	/* UID format types */
#define UID$K_APOLLO2	1
#define UID$K_DIGITAL	2
#define UID$K_MICROSOFT 3
#define UID$K_LENGTH	16	/* total structure length */
struct uiddef {
    union {
	unsigned long uid$q_timeandversion[2];	/* time and version */
	struct {
	    unsigned long uid$l_timelow;	/* low order 32 bits of time */
	    unsigned short uid$w_timemid;	/* middle order 16 bits of time */
	    union {
		unsigned short uid$w_timehiandversion; /* high order 12 bits of time and */
		struct {			       /*  4 bits of version */
		    unsigned uid$v_timehi : 12; /* high order 12 bits of time */
		    unsigned uid$v_version : 4; /* 4 bits of version */
		} uid$r_timehi_vers_bits;
	    } uid$r_timehi_vers_overlay;
	} uid$r_time_version_fields;
    } uid$r_time_version_overlay;
    union {
	unsigned short uid$w_clockseqandreserved; /* clock sequence and reserved */
	struct {
	    union {
		unsigned char uid$b_clockseqhiandreserved; /* high order 6 bits of clock sequence */
		struct {				   /*  and 2 reserved bits */
		    unsigned uid$v_clockseqhi : 6; /* high order 6 bits of clock sequence */
		    unsigned uid$v_reserved : 2;   /* 2 bits of reserved */
		} uid$r_clkseqhi_rsrvd_fields;
	    } uid$r_clkseqhi_rsrvd_overlay;
	    unsigned char uid$b_clockseqlow;	/* low order 8 bits of clock sequence */
	} uid$r_clockseq_rsrvd_fields;
    } uid$r_clockseq_rsrvd_overlay;
    union {
	unsigned char uid$b_node[6];
	struct {
	    unsigned short uid$w_nodehi; /* high order 16 bits of node number */
	    unsigned long uid$l_nodelow; /* low order 32 bits of node number */
	} uid$r_node_fields;
    } uid$r_node_overlay;
};

#endif	/*_UIDDEF_H*/
