/* <vms/lib/voldef.h>
 *
 *	LIB - ANSI volume label definitions		[not in Starlet]
 */
#ifndef _VOLDEF_H
#define _VOLDEF_H

#ifndef _VL1DEF_H
#define _VL1DEF_H
/*
   VOL1 ANSI magnetic tape label
   This is the first block on every ANSI labeled magnetic tape.
   It identifies the volume and its protection.
 */
#define VL1$S_VL1DEF	80
#define VL1$S_VOLLBL	6
#define VL1$S_SYSCODE	13
#define VL1$S_OWNER_IDENT 14
#define VL1$S_VOLOWNER	13
struct vl1def {
    unsigned long vl1$l_vl1lid;		/* label identifier and number 'VOL1' */
    char vl1$t_vollbl[6];		/* volume label */
    unsigned char vl1$b_volaccess;	/* volume access */
    char vl1def$$_fill1[13];
    char vl1$t_syscode[13];		/* system code */
    union {
	char vl1$t_owner_ident[14];	/* VOL1 owner id field */
	struct {
	    char vl1$t_volowner[13];	/* volume owner identification */
	    unsigned char vl1$b_decstdver; /* DEC standard version */
	} vl1$r_old_volowner;
    } vl1$r_owner_union;
    char vl1def$$_fill2[28];
    unsigned char vl1$b_lblstdver;	/* label standard version '3' */
};
#endif	/*_VL1DEF_H*/


#ifndef _VL2DEF_H
#define _VL2DEF_H
/*
   VOL2 ANSI magnetic tape label
   This is block is written to tapes when a VMS protection is specified
 */
#define VL2$S_VL2DEF	19
#define VL2$S_VOLOWNER	15
struct vl2def {
    unsigned long vl2$l_vl2lid;		/* label identifier and number 'VOL2' */
    char vl2$t_volowner[15];		/* volume owner identification */
};
#endif	/*_VL2DEF_H*/

#endif	/*_VOLDEF_H*/
