/* <xkstsdef.h>
 *
 *	Definitions for 3271 line status block (returned by IO$_RDSTATS)
 */
#ifndef _XKSTSDEF_H
#define _XKSTSDEF_H

#define XKSTS$K_LSTR	0	/* offset of beginning of data area */
#define XKSTS$C_LSTR	0
#define XKSTS$V_ACT	0
#define XKSTS$V_DGN	1
#define XKSTS$M_ACT	(1<<XKSTS$V_ACT)	/* 0x01 */
#define XKSTS$M_DGN	(1<<XKSTS$V_DGN)	/* 0x02 */
#define XKSTS$K_DSTR	45	/* length of the line status block */
#define XKSTS$C_DSTR	45
struct xkstsdef {
    unsigned char xksts$b_cuad;		/* control unit address (HEX EBCDIC) */
    union {
	unsigned short xksts$w_lsts;	/* line status */
	struct {
	    unsigned xksts$v_act : 1;	/* if set, line is 'on' (active in 3271 mode) */
	    unsigned xksts$v_dgn : 1;	/* if set, line is executing a diagnostic qio */
	    unsigned		 : 6;
	    unsigned		 : 8;	/* padding */
	} xksts$r_lsts_bits;
    } xksts$r_lsts_overlay;
    unsigned char xksts$b_plsz;		/* pool size */
    unsigned short xksts$w_bsiz;	/* maximum block to be received from IBM */
    unsigned char xksts$b_ecnt;		/* ENQ threshold */
    unsigned short xksts$w_tnak;	/* number of NAKS transmitted */
    unsigned short xksts$w_rnak;	/* number of NAKS received */
    unsigned short xksts$w_tenq;	/* number of ENQS sent */
    unsigned short xksts$w_renq;	/* number of ENQS received */
    unsigned short xksts$w_trvi;	/* number of RVIS transmitted */
    unsigned short xksts$w_rrvi;	/* number of RVIS received */
    unsigned short xksts$w_rcnv;	/* number of conversational mode responses received */
    unsigned short xksts$w_chai;	/* number of chained writes received */
    unsigned short xksts$w_gpol;	/* number of general polls received */
    unsigned short xksts$w_xack;	/* number of invalid acks received */
    unsigned short xksts$w_habo;	/* number of host aborts encountered */
    unsigned short xksts$w_dabo;	/* number of driver aborts encountered */
    unsigned short xksts$w_rtim;	/* number of ACK response timeouts */
    unsigned short xksts$w_disc;	/* number of disconnects encountered */
    unsigned short xksts$w_hard;	/* number of hardware failures (including disconnects) encountered */
    unsigned short xksts$w_tblk;	/* number of blocks transmitted */
    unsigned short xksts$w_rblk;	/* number of blocks received */
    unsigned short xksts$w_habx;	/* number of dubious ACK outs */
    unsigned short xksts$w_ieot;	/* number of EOTS implying ACK */
};

#endif	/*_XKSTSDEF_H*/
